SystemOrganization addCategory: #'GdsFeel-Model'!
SystemOrganization addCategory: #'GdsFeel-Model-Element'!
SystemOrganization addCategory: #'GdsFeel-Model-Container'!
SystemOrganization addCategory: #'GdsFeel-Model-Viewing'!
SystemOrganization addCategory: #'GdsFeel-Model-Spec'!
SystemOrganization addCategory: #'GdsFeel-Model-Utility'!
SystemOrganization addCategory: #'GdsFeel-Model-EditSpace'!
SystemOrganization addCategory: #'GdsFeel-Model-Property'!

INIFileSection subclass: #GdsIniFileSecion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsFeel-Model-Utility'!

!GdsIniFileSecion methodsFor: 'private' stamp: 'kf 6/14/2009 21:15'!
writeOn: aStream
	aStream nextPutAll: '[', self label, ']'; cr.
	aStream nextPut: Character lf.
	self associationsDo:
		[:assoc | 
			aStream nextPutAll: assoc key, '=', (assoc value ifNil: ['']); cr.
			aStream nextPut: Character lf.]! !

Model subclass: #GdsAShapeContext
	instanceVariableNames: 'columnCount rowCount xStep yStep propertyOwner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsFeel-Model-Property'!

!GdsAShapeContext commentStamp: 'kf 11/6/2009 13:48' prior: 0!
A GdsArefContext is GDS II's ASHAPE value holder.

Instance Variables
!

!GdsAShapeContext methodsFor: 'accessing' stamp: 'kf 11/9/2009 12:20'!
asRequestString
	^GdsFeel join:  (self values collect: [:each | each asString]) using: ' '.! !

!GdsAShapeContext methodsFor: 'objects from disk' stamp: 'kf 11/9/2009 15:45'!
asXmlElement
	| elmt attrDict |
	attrDict := Dictionary new.
	self attributesOn: attrDict.
	elmt := XMLElement named: 'ashape' attributes: attrDict.
	^elmt.
	! !

!GdsAShapeContext methodsFor: 'objects from disk' stamp: 'kf 11/9/2009 15:49'!
attributesFrom: aDictionary
	self columnCount: (aDictionary at: 'cols' ifAbsent: [1]) asInteger. 
	self rowCount: (aDictionary at: 'rows' ifAbsent: [1]) asInteger. 
	self xStep: (aDictionary at: 'column-spacing' ifAbsent: [0.0]) asNumber. 
	self yStep: (aDictionary at: 'row-spacing' ifAbsent: [0.0]) asNumber. 
	
! !

!GdsAShapeContext methodsFor: 'objects from disk' stamp: 'kf 11/11/2009 09:36'!
attributesOn: aDictionary
	self columnCount >=2
		ifTrue: [aDictionary at: 'cols' put: self columnCount asString].
	self rowCount >=2
		ifTrue: [aDictionary at: 'rows' put: self rowCount asString].
	self xStep = 0.0
		ifFalse: [	
			aDictionary at: 'column-spacing' put: self xStep asString].
	self yStep = 0.0
		ifFalse: [	
			aDictionary at: 'row-spacing' put: self yStep asString].! !

!GdsAShapeContext methodsFor: 'updating' stamp: 'kf 11/12/2009 13:45'!
changed: anObject
	propertyOwner ifNil: [^super changed: anObject.].
	propertyOwner changed: anObject.
	super changed: anObject.! !

!GdsAShapeContext methodsFor: 'accessing' stamp: 'kf 11/5/2009 15:47'!
columnCount
	^columnCount! !

!GdsAShapeContext methodsFor: 'accessing' stamp: 'kf 11/9/2009 14:14'!
columnCount: anInteger
	self assert: [anInteger isKindOf: Number].
	self assert: [anInteger > 0] description: 'columnCount >= 1'.
	columnCount = anInteger asInteger ifTrue: [^self].
	columnCount := anInteger asInteger.
	self refreshBounds.
	self changed: #columnCount.
	! !

!GdsAShapeContext methodsFor: 'initialization' stamp: 'kf 11/5/2009 15:49'!
initialize
	super initialize.
	rowCount := 1.
	columnCount := 1.
	xStep := 0.0.
	yStep := 0.0.
	
	! !

!GdsAShapeContext methodsFor: 'objects from disk' stamp: 'kf 11/9/2009 15:51'!
loadFromXmlNode: aXMLNode
	self attributesFrom: aXMLNode attributes.
! !

!GdsAShapeContext methodsFor: 'private' stamp: 'kf 11/5/2009 18:22'!
lookupLocalBounds: localBounds
	| vw vh |
	vw := (self xStep * (self columnCount - 1)) + localBounds width. 
	vh := (self yStep * (self rowCount - 1)) + localBounds height.
	^localBounds origin extent: vw@vh ! !

!GdsAShapeContext methodsFor: 'accessing' stamp: 'kf 11/6/2009 13:47'!
propertyOwner: anObject
	propertyOwner := anObject.
	self addDependent: anObject.! !

!GdsAShapeContext methodsFor: 'updating' stamp: 'kf 11/5/2009 23:07'!
refreshBounds
	propertyOwner ifNil: [^self].
	propertyOwner refreshBounds.! !

!GdsAShapeContext methodsFor: 'private' stamp: 'kf 11/24/2009 11:35'!
relativeTransforms
	| offset transforms |
	transforms := OrderedCollection new.
	1 to: self columnCount do: [:xIndex |
		1 to: self rowCount do: [:yIndex |
			offset :=  ((xIndex - 1) * self xStep)@((yIndex - 1) * self yStep).
			transforms add: (MatrixTransform2x3 withOffset: offset).]].
	 ^transforms asArray.! !

!GdsAShapeContext methodsFor: 'accessing' stamp: 'kf 11/5/2009 15:47'!
rowCount
	^rowCount! !

!GdsAShapeContext methodsFor: 'accessing' stamp: 'kf 11/9/2009 14:15'!
rowCount: anInteger
	self assert: [anInteger isKindOf: Number].
	self assert: [anInteger > 0] description: 'rowCount >= 1'.
	rowCount = anInteger asInteger ifTrue: [^self].
	rowCount := anInteger asInteger.
	self refreshBounds.
	self changed: #rowCount.
	! !

!GdsAShapeContext methodsFor: 'accessing' stamp: 'kf 11/9/2009 12:13'!
values
	^{self columnCount . self rowCount . self xStep .  self yStep }! !

!GdsAShapeContext methodsFor: 'accessing' stamp: 'kf 11/9/2009 12:16'!
values: anArray
	self assert: [anArray size = 4].
	self assert: [anArray allSatisfy: [:each | each isKindOf: Number]].
	self columnCount: 	anArray first.
	self rowCount: 	anArray second.
	self xStep: anArray third.
	self yStep: anArray fourth.
	! !

!GdsAShapeContext methodsFor: 'accessing' stamp: 'kf 11/5/2009 15:49'!
xStep
	^xStep! !

!GdsAShapeContext methodsFor: 'accessing' stamp: 'kf 11/6/2009 16:03'!
xStep: aFloat
	self assert: [aFloat isKindOf: Number].
	xStep = aFloat ifTrue: [^self].
	xStep := aFloat.
	self refreshBounds.
	self changed: #xStep.
	! !

!GdsAShapeContext methodsFor: 'accessing' stamp: 'kf 11/5/2009 15:49'!
yStep
	^yStep! !

!GdsAShapeContext methodsFor: 'accessing' stamp: 'kf 11/6/2009 16:03'!
yStep: aFloat
	self assert: [aFloat isKindOf: Number].
	yStep = aFloat ifTrue: [^self].
	yStep := aFloat.
	self refreshBounds.
	self changed: #yStep.
	! !

Model subclass: #GdsElement
	instanceVariableNames: 'vertices dataBounds keyNumber statusNumber owner'
	classVariableNames: 'TypeToClassMap'
	poolDictionaries: ''
	category: 'GdsFeel-Model-Element'!

!GdsElement commentStamp: 'kf 11/14/2008 22:13' prior: 0!
A GdsElement is top level abstruct GDS II's element class.

Instance Variables
	colVertices:		<Array<Point>>
	dataBounds:		<Rectangle<Float>>
	keyNumber:		<Integer>
	statusNumber:		<SmallInteger>

colVertices
	- xxxxx

dataBounds
	- xxxxx

keyNumber
	- xxxxx

statusNumber
	- in item: 0 - 9
	- in id:	-1
	- in database: -2!

!GdsElement class methodsFor: 'private' stamp: 'kf 10/23/2008 19:56'!
allCreatableClasses
	^GdsElement allSubclasses reject: [:clazz | clazz type = #none]! !

!GdsElement class methodsFor: 'accessing' stamp: 'kf 10/23/2008 21:17'!
classForType: aStringOrSymbol
	| key |
	key := aStringOrSymbol asLowercase asSymbol.
	TypeToClassMap ifNil: [self setupClassMap].
	^TypeToClassMap at: key ifAbsent:[].! !

!GdsElement class methodsFor: 'accessing' stamp: 'kf 11/13/2008 17:44'!
enabledStateNumbers
	" 0 - 9 : item number
	       -1: id selected
	       -2: in database
	       -4: in trush (GdsFeel)"
	^GdsCompatibility default itemNumberRange asArray, {
		GdsElement inIdStausNumber .
		GdsElement inDatabaseStausNumber. 
		GdsElement inTrushStausNumber} ! !

!GdsElement class methodsFor: 'initialization' stamp: 'kf 10/26/2008 11:22'!
fromItemContext: aGdsEditorContext 
	^ self new fromItemContext: aGdsEditorContext! !

!GdsElement class methodsFor: 'testing' stamp: 'kf 10/27/2009 11:02'!
hasDataType
	^false.! !

!GdsElement class methodsFor: 'testing' stamp: 'kf 10/23/2008 20:25'!
hasLayer
	^false.! !

!GdsElement class methodsFor: 'testing' stamp: 'kf 10/27/2009 13:15'!
hasPathType
	^false.! !

!GdsElement class methodsFor: 'testing' stamp: 'kf 5/4/2009 09:35'!
hasWidth
	^false.! !

!GdsElement class methodsFor: 'constants' stamp: 'kf 11/13/2008 10:02'!
inDatabaseStausNumber
	^-2.! !

!GdsElement class methodsFor: 'constants' stamp: 'kf 11/13/2008 10:02'!
inIdStausNumber
	^-1.! !

!GdsElement class methodsFor: 'constants' stamp: 'kf 11/13/2008 17:36'!
inTrushStausNumber
	"not presents original GDSII
	can't use -3. reason: MSELECT no sort action number"
	^-4.! !

!GdsElement class methodsFor: 'initialization' stamp: 'kf 5/6/2009 21:32'!
initialize
	"GdsElement initialize"
	self setupClassMap.
	Smalltalk addToStartUpList: self.	
! !

!GdsElement class methodsFor: 'testing' stamp: 'kf 11/10/2009 10:24'!
installedElementType: aSymbol
	"self arefInstalled"
	TypeToClassMap ifNil: [self setupClassMap].
	^TypeToClassMap includesKey: aSymbol asLowercase asSymbol.! !

!GdsElement class methodsFor: 'testing' stamp: 'kf 5/12/2009 16:25'!
isReference
	^false.! !

!GdsElement class methodsFor: 'accessing' stamp: 'kf 9/20/2008 14:17'!
requiredVertexCount
	^1.! !

!GdsElement class methodsFor: 'private' stamp: 'kf 10/23/2008 20:04'!
setupClassMap
	TypeToClassMap := Dictionary new.
	self allCreatableClasses do: [:clazz |
		TypeToClassMap at: clazz type put: clazz].! !

!GdsElement class methodsFor: 'system startup' stamp: 'kf 10/23/2008 20:06'!
startUp
	self setupClassMap.
	! !

!GdsElement class methodsFor: 'accessing' stamp: 'kf 11/16/2008 17:23'!
statusSymbolOf: statusNumber
	(self inTrushStausNumber = statusNumber) ifTrue: [^#inTrush].
	(self inIdStausNumber  = statusNumber) ifTrue: [^#inId].
	(self inDatabaseStausNumber = statusNumber) ifTrue: [^#inStructure].
	(GdsCompatibility default itemNumberRange includes: statusNumber)
		ifTrue: [^#inItem].
	^#error.	! !

!GdsElement class methodsFor: 'accessing' stamp: 'kf 10/23/2008 19:49'!
type
	^#none! !

!GdsElement class methodsFor: 'accessing' stamp: 'kf 10/23/2008 19:57'!
typeString
	^self type asString asUppercase.! !

!GdsElement methodsFor: 'accessing-points' stamp: 'kf 10/24/2008 14:27'!
absoluteAngle: aTheta
	| theta |
	theta := aTheta.
	^theta negative
		ifTrue: [(Float pi * 2) + theta]
		ifFalse:[theta].
! !

!GdsElement methodsFor: 'analisys' stamp: 'kf 11/5/2008 10:45'!
analisys: aPoint 
	^GeometryUtils analisysSegmentsAt: aPoint pointArray: self vertices.! !

!GdsElement methodsFor: 'objects from disk' stamp: 'kf 10/12/2008 22:47'!
asXmlElement
	| elmt attrDict vertsElmt |
	attrDict := Dictionary new.
	self attributesOn: attrDict.
	elmt := XMLElement named: 'element' attributes: attrDict.
	vertsElmt := XMLElement named: 'vertices'.
	self vertices do: [:xy |
		vertsElmt addElement: (self xyXmlElement: xy)]. 
	elmt addElement: vertsElmt. 
	^elmt.
! !

!GdsElement methodsFor: 'objects from disk' stamp: 'kf 10/28/2009 10:29'!
attributesFrom: aDictionary
	| key |
	self hasDataType
		ifTrue: [self datatype: (aDictionary at: 'datatype' ifAbsent: [self missingDataTypeNumber]) asNumber].
	self hasLayer
		ifTrue: [
			self layerNumber: 
				(aDictionary 
					at: 'layerNumber' 
					ifAbsent: [(aDictionary 
					at: 'layer' "compatibility" 
					ifAbsent: [self missingLayerNumber])]) asInteger].
	self hasWidth
		ifTrue: [self width: (aDictionary at: 'width' ifAbsent: [self missingWidthNumber]) asNumber].
	self hasPathType
		ifTrue: [self pathtype: (aDictionary at: 'pathtype' ifAbsent: [self missingPathTypeNumber]) asNumber].
	key := aDictionary at: 'keyNumber' ifAbsent:[nil].
	key ifNotNil: [keyNumber := key asInteger].! !

!GdsElement methodsFor: 'objects from disk' stamp: 'kf 11/11/2009 09:39'!
attributesOn: aDictionary
	aDictionary at: 'type' put: self type asString.
	(self hasDataType and: [self datatype ~= self missingDataTypeNumber])
		ifTrue: [aDictionary at: 'datatype' put: self datatype asString.].

	self hasLayer
		ifTrue: [aDictionary at: 'layerNumber' put: self layerNumber asString.].

	(self hasWidth and: [self width ~= self missingWidthNumber])
		ifTrue: [aDictionary at: 'width' put: self width asString.].

	(self hasPathType and: [self pathtype ~= self missingPathTypeNumber ])
		ifTrue: [aDictionary at: 'pathtype' put: self pathtype asString.].

	self keyNumberFilled 
		ifTrue: [aDictionary at: 'keyNumber' put: self keyNumber asString.].
! !

!GdsElement methodsFor: 'accessing-points' stamp: 'kf 10/24/2008 10:42'!
collectFor: aSegemntMessage
	^self lineSegments collect: [:seg | seg perform: aSegemntMessage].! !

!GdsElement methodsFor: 'copying' stamp: 'kf 5/15/2009 13:19'!
copyVertices
	| points |
	points := (self vertices collect: [:each | each copy ]).
	self privateWipe.
	self vertices: points.
	! !

!GdsElement methodsFor: 'testing' stamp: 'kf 7/14/2009 14:58'!
damaged
	^self vertexCount < self requiredVertexCount.! !

!GdsElement methodsFor: 'accessing-points' stamp: 'kf 10/3/2008 23:12'!
dataBounds
	dataBounds ifNil: [dataBounds := self lookupDataBounds].
	^dataBounds. ! !

!GdsElement methodsFor: 'accessing-points' stamp: 'kf 10/26/2008 12:04'!
dataOutlinePoints
	^ self vertices! !

!GdsElement methodsFor: 'accessing-points' stamp: 'kf 10/24/2008 10:43'!
directions
	^self collectFor: #direction.! !

!GdsElement methodsFor: 'accessing-points' stamp: 'kf 10/24/2008 11:09'!
directionsPacked
	^(self directions inject: OrderedCollection new into: [:subtotal :each | 
		subtotal ifEmpty: [subtotal add: each; yourself]
				ifNotEmpty: [subtotal add: (each - subtotal last); yourself]]) asArray.! !

!GdsElement methodsFor: 'accessing-points' stamp: 'kf 10/26/2008 12:04'!
dist: aPoint 
	| col p distP |
	col := OrderedCollection new.
	GeometryUtils 
		pointArray: self dataOutlinePoints
		lineSegmentsDo: 
			[ :seg | 
			p := aPoint 
				nearestPointOnLineFrom: seg start
				to: seg end.
			distP := p dist: aPoint.
			col add: distP ].
	^ col min! !

!GdsElement methodsFor: 'other' stamp: 'kf 11/18/2008 10:20'!
fixGeometryError! !

!GdsElement methodsFor: 'initialization' stamp: 'kf 11/22/2009 16:56'!
fromItemContext: aGdsItemContext 
	vertices := nil.
	self vertices: 
		(self 
			validateVertices: aGdsItemContext vertices
			editorContext: aGdsItemContext).
	self hasDataType ifTrue: [ self datatype: aGdsItemContext datatype ].
	self hasLayer ifTrue: [ self layerNumber: aGdsItemContext layerNumber ].
	self hasPathType ifTrue: [ self pathtype: aGdsItemContext pathtype ].
	self hasWidth ifTrue: [ self width: aGdsItemContext width ].
	self statusNumber: aGdsItemContext number ! !

!GdsElement methodsFor: 'testing' stamp: 'kf 10/27/2009 11:02'!
hasDataType
	^self class hasDataType.! !

!GdsElement methodsFor: 'testing' stamp: 'kf 10/23/2008 21:54'!
hasLayer
	^self class hasLayer.! !

!GdsElement methodsFor: 'testing' stamp: 'kf 10/27/2009 13:16'!
hasPathType
	^self class hasPathType.! !

!GdsElement methodsFor: 'testing' stamp: 'kf 5/4/2009 09:34'!
hasWidth
	^self class hasWidth.! !

!GdsElement methodsFor: 'initialization' stamp: 'kf 9/19/2008 18:15'!
initialize
	super initialize.! !

!GdsElement methodsFor: 'testing' stamp: 'kf 5/12/2009 16:26'!
isReference
	^self class isReference.! !

!GdsElement methodsFor: 'testing' stamp: 'kf 5/8/2009 15:19'!
isStrictGds
	^true! !

!GdsElement methodsFor: 'testing' stamp: 'kf 10/27/2009 15:50'!
isVisible
	owner ifNil: [^true].
	self hasLayer ifFalse: [^true].
	^(owner layers atNumber: self layerNumber) isVisible.! !

!GdsElement methodsFor: 'accessing' stamp: 'kf 11/12/2008 09:22'!
keyNumber
	^keyNumber! !

!GdsElement methodsFor: 'testing' stamp: 'kf 11/12/2008 09:05'!
keyNumberFilled
	^keyNumber isNil not! !

!GdsElement methodsFor: 'accessing-points' stamp: 'kf 10/24/2008 10:40'!
lineSegments
	| col |
	col := OrderedCollection new.
	self lineSegmentsDo: [:seg |
		col add: seg].
	^col asArray.! !

!GdsElement methodsFor: 'accessing-points' stamp: 'kf 10/17/2008 21:47'!
lineSegmentsDo: aLineSegmentBlock
	GeometryUtils  pointArray: self vertices  lineSegmentsDo: aLineSegmentBlock.! !

!GdsElement methodsFor: 'objects from disk' stamp: 'kf 11/7/2009 21:42'!
loadFromXmlNode: aXMLNode
	self protectedLoadFromXmlNode: aXMLNode.! !

!GdsElement methodsFor: 'accessing-points' stamp: 'kf 11/5/2008 17:11'!
lookupDataBounds
	^GeometryUtils lookupDataBounds:  self dataOutlinePoints! !

!GdsElement methodsFor: 'objects from disk' stamp: 'kf 10/27/2009 21:57'!
missingDataTypeNumber
	^0.
	! !

!GdsElement methodsFor: 'objects from disk' stamp: 'kf 5/4/2009 11:26'!
missingLayerNumber
	^1.
	! !

!GdsElement methodsFor: 'objects from disk' stamp: 'kf 10/27/2009 21:57'!
missingPathTypeNumber
	^0.
	! !

!GdsElement methodsFor: 'objects from disk' stamp: 'kf 5/4/2009 11:26'!
missingWidthNumber
	^1.0.
	! !

!GdsElement methodsFor: 'accessing-points' stamp: 'kf 5/15/2009 14:36'!
moveRelative: aPoint
	self moveRelative: aPoint from: self! !

!GdsElement methodsFor: 'accessing-points' stamp: 'kf 5/15/2009 14:36'!
moveRelative: aPoint from: aOtherElement
	| translatedPoints |
	translatedPoints := aOtherElement vertices collect: [:p | p + aPoint].
	self privateWipe.
	self vertices: translatedPoints.! !

!GdsElement methodsFor: 'accessing' stamp: 'kf 5/13/2009 09:56'!
owner
	^owner! !

!GdsElement methodsFor: 'copying' stamp: 'kf 11/22/2009 16:51'!
postCopy
	super postCopy.
	self copyVertices.
	! !

!GdsElement methodsFor: 'printing' stamp: 'kf 10/21/2009 17:29'!
printOn: aStream
	aStream nextPutAll: self typeString.
	aStream nextPut: $(.
	keyNumber ifNotNil: [
		aStream nextPutAll: keyNumber asString].
	self printSelfOn: aStream.
	aStream nextPut: $).
	! !

!GdsElement methodsFor: 'printing' stamp: 'kf 5/13/2009 16:53'!
printSelfOn: aStream

	! !

!GdsElement methodsFor: 'private' stamp: 'kf 11/22/2009 16:56'!
privateWipe
	vertices := nil.
	self refreshBounds.
	! !

!GdsElement methodsFor: 'objects from disk' stamp: 'kf 11/17/2009 20:25'!
protectedLoadFromXmlNode: aXMLNode
	| col |
	self attributesFrom: aXMLNode attributes. 
	col := OrderedCollection new.
	(aXMLNode firstTagNamed: #vertices) elementsDo: [:xyNode |
		| words xy |
		words := xyNode contents first string findTokens: ' '.
		xy := (words first asNumber)@(words last asNumber).
		col add: xy.].
	self assert: [col isEmpty not].
	self vertices: col asArray.! !

!GdsElement methodsFor: 'private' stamp: 'kf 6/24/2009 16:36'!
refreshBounds
	dataBounds := nil.! !

!GdsElement methodsFor: 'initialization' stamp: 'kf 11/22/2009 16:55'!
release
	vertices := nil.	
	owner := nil.
	super release.! !

!GdsElement methodsFor: 'other' stamp: 'kf 10/28/2008 23:53'!
removeGeometryCache! !

!GdsElement methodsFor: 'accessing' stamp: 'kf 9/20/2008 14:18'!
requiredVertexCount
	^self class requiredVertexCount.! !

!GdsElement methodsFor: 'accessing' stamp: 'kf 11/13/2008 10:26'!
state
	^GdsElement statusSymbolOf: self statusNumber.
	! !

!GdsElement methodsFor: 'accessing' stamp: 'kf 11/13/2008 10:25'!
statusNumber
	"in item: 0 - 9
	in id:	-1
	in database: -2"
	statusNumber ifNil: [statusNumber := GdsElement inDatabaseStausNumber].
	^statusNumber! !

!GdsElement methodsFor: 'accessing' stamp: 'kf 11/13/2008 17:40'!
statusNumber: aInteger
	"in item: 0 - 9
	in id:	-1
	in database: -2"
	self assert: [GdsElement enabledStateNumbers includes: aInteger].
	statusNumber := aInteger.
	self changed: #statusNumber.! !

!GdsElement methodsFor: 'accessing-points' stamp: 'kf 10/24/2008 10:45'!
thetas
	^self lineSegments collect: [:seg | seg direction theta].! !

!GdsElement methodsFor: 'accessing-points' stamp: 'kf 10/24/2008 14:42'!
thetasPacked
	| col thetas prevSeg |
	col := OrderedCollection new.
	prevSeg := nil.
	self lineSegmentsDo: [:seg |
		prevSeg ifNotNil: [ 
			| to from |
			to := self absoluteAngle: seg direction theta.
			from := self absoluteAngle: prevSeg reversed direction theta.
			col add: (self absoluteAngle: (to - from))].
		prevSeg := seg].
	^col asArray.! !

!GdsElement methodsFor: 'accessing' stamp: 'kf 10/23/2008 19:50'!
type
	^self class type.! !

!GdsElement methodsFor: 'accessing' stamp: 'kf 10/21/2009 17:29'!
typeString
	^self type asString asUppercase! !

!GdsElement methodsFor: 'accessing' stamp: 'kf 9/20/2008 14:24'!
validateVertices: aPointArray
	(aPointArray size < self requiredVertexCount) 
		ifTrue: [self error: 'required vertex count is ', self requiredVertexCount printString, 'but: ', aPointArray size printString].
	^aPointArray.! !

!GdsElement methodsFor: 'accessing' stamp: 'kf 5/6/2009 17:33'!
validateVertices: aPointArray editorContext: aGdsEditorContext
	^self validateVertices: aPointArray.! !

!GdsElement methodsFor: 'accessing-points' stamp: 'kf 7/14/2009 14:56'!
vertexCount
	^self vertices size! !

!GdsElement methodsFor: 'accessing-points' stamp: 'kf 11/22/2009 16:57'!
vertices
	vertices ifNil: [vertices := #()].
	^vertices.! !

!GdsElement methodsFor: 'accessing-points' stamp: 'kf 11/22/2009 16:54'!
vertices: aPointArray
	vertices := aPointArray.
	self removeGeometryCache.
	self refreshBounds.
! !

!GdsElement methodsFor: 'accessing' stamp: 'kf 11/13/2008 10:15'!
wipe
	self privateWipe.
	self statusNumber: GdsElement inTrushStausNumber.
	! !

!GdsElement methodsFor: 'accessing-points' stamp: 'kf 6/8/2009 17:07'!
xy
	^self vertices first.
	! !

!GdsElement methodsFor: 'accessing-points' stamp: 'kf 5/12/2009 16:47'!
xy: aPoint
	self vertices: (Array with: aPoint).! !

!GdsElement methodsFor: 'accessing' stamp: 'kf 10/9/2009 16:42'!
xyXmlElement: aPoint
	^((XMLElement named: 'xy') 
		addContent: (XMLStringNode string: 
			(aPoint x asString, ' ', aPoint y asString))) 
! !

GdsElement subclass: #GdsPrimitiveElement
	instanceVariableNames: 'layer datatype layerNumber'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsFeel-Model-Element'!

!GdsPrimitiveElement commentStamp: 'kf 11/12/2008 12:04' prior: 0!
A GdsPrimitiveElement is GDS II's primitive element.

Instance Variables
	layer:		<SmallInteger>

layer
	- 0 to 255
!

GdsPrimitiveElement subclass: #GdsBoundary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsFeel-Model-Element'!

!GdsBoundary commentStamp: 'kf 11/12/2008 11:59' prior: 0!
A GdsBoundary is GDS II's BOUNDARY.

Instance Variables
!

!GdsBoundary class methodsFor: 'accessing' stamp: 'kf 9/20/2008 14:18'!
requiredVertexCount
	^3.! !

!GdsBoundary class methodsFor: 'accessing' stamp: 'kf 10/23/2008 19:52'!
type
	^#boundary! !

!GdsBoundary methodsFor: 'initialization' stamp: 'kf 9/19/2008 18:15'!
initialize
	super initialize.! !

!GdsBoundary methodsFor: 'accessing' stamp: 'kf 9/20/2008 14:36'!
validateVertices: aPointArray
	| points |
	points := super validateVertices: aPointArray.
	(points first = points last)
		ifFalse: [
			points := aPointArray asOrderedCollection.
			points add: points first].
	^points asArray.! !

!GdsBoundary methodsFor: 'accessing' stamp: 'kf 11/18/2008 10:17'!
validateVertices: aPointArray editorContext: aGdsEditorContext
	| points vPoint ce1 |
	points := super validateVertices: aPointArray.
	ce1 := points last.
	(points first = ce1)
		ifFalse: [
			points := aPointArray asOrderedCollection.
			vPoint := aGdsEditorContext completionPointFrom: ce1 to: points first.
			vPoint ifNotNil:[
				(aGdsEditorContext digitaizingMode = #orthint)
					ifTrue: [
						points last = vPoint
							ifFalse:[points add: vPoint.]]]. 
			points add: points first].
	^points asArray.! !

!GdsBoundary methodsFor: 'accessing' stamp: 'kf 7/14/2009 15:06'!
vertexCount
	((self vertices size >= 3) and:
	[self vertices first = self vertices last])
		ifTrue: [^self vertices size - 1].
	^super vertexCount! !

GdsPrimitiveElement subclass: #GdsBoxText
	instanceVariableNames: 'contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsFeel-Model-Element'!

!GdsBoxText commentStamp: 'kf 5/4/2009 22:29' prior: 0!
A GdsBoxText is not GDSII's real font.

Adhook Squeak's TrueType rendering.

Instance Variables
!

!GdsBoxText class methodsFor: 'accessing' stamp: 'kf 5/6/2009 15:23'!
type
	^#boxtext! !

!GdsBoxText methodsFor: 'objects from disk' stamp: 'kf 5/8/2009 15:10'!
attributesFrom: aDictionary
	super attributesFrom: aDictionary.
	self contents: (aDictionary at: 'string' ifAbsent: ['UNTITLED']) asString! !

!GdsBoxText methodsFor: 'objects from disk' stamp: 'kf 5/8/2009 15:08'!
attributesOn: aDictionary
	super attributesOn: aDictionary.
	aDictionary at: 'string' put: self contents asString.! !

!GdsBoxText methodsFor: 'accessing' stamp: 'kf 5/8/2009 15:20'!
contents
	^contents! !

!GdsBoxText methodsFor: 'accessing' stamp: 'kf 5/8/2009 15:20'!
contents: aByteString
	contents := aByteString.
	! !

!GdsBoxText methodsFor: 'other' stamp: 'kf 5/8/2009 15:21'!
fixGeometryError! !

!GdsBoxText methodsFor: 'accessing' stamp: 'kf 5/7/2009 15:22'!
fromItemContext: aGdsItemContext 
	super fromItemContext: aGdsItemContext.
	self contents: aGdsItemContext text.
	! !

!GdsBoxText methodsFor: 'initialization' stamp: 'kf 5/6/2009 17:42'!
initialize
	super initialize.
	self contents: 'UNTITLED'.
	! !

!GdsBoxText methodsFor: 'testing' stamp: 'kf 5/8/2009 15:19'!
isStrictGds
	^false! !

!GdsBoxText methodsFor: 'printing' stamp: 'kf 5/13/2009 16:57'!
printSelfOn: aStream
	aStream nextPut: $,.
	aStream nextPutAll: self contents.! !

GdsPrimitiveElement subclass: #GdsPath
	instanceVariableNames: 'wire'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsFeel-Model-Element'!

!GdsPath commentStamp: 'kf 11/12/2008 12:05' prior: 0!
A GdsPath is GDS II's PATH.

Instance Variables
	boundaryPoints:		<Array<Point>>
	outlineSegMap:		<Object>
	width:		<Float>

boundaryPoints
	- xxxxx

outlineSegMap
	- xxxxx

width
	- xxxxx
!

!GdsPath class methodsFor: 'testing' stamp: 'kf 10/27/2009 13:54'!
hasPathType
	^true.! !

!GdsPath class methodsFor: 'testing' stamp: 'kf 5/4/2009 11:15'!
hasWidth
	^true.! !

!GdsPath class methodsFor: 'accessing' stamp: 'kf 9/20/2008 14:18'!
requiredVertexCount
	^2.! !

!GdsPath class methodsFor: 'accessing' stamp: 'kf 10/23/2008 19:53'!
type
	^#path! !

!GdsPath methodsFor: 'copying' stamp: 'kf 10/27/2009 22:22'!
copy
	| newElement |
	newElement := super copy.
	newElement copyWireContext.
	(newElement instVarNamed: 'wire') element: newElement.
	^newElement! !

!GdsPath methodsFor: 'copying' stamp: 'kf 10/27/2009 22:14'!
copyWireContext
	wire := wire copy.! !

!GdsPath methodsFor: 'accessing' stamp: 'kf 10/24/2009 20:22'!
dataOutlinePoints
	^ wire boundaryPoints! !

!GdsPath methodsFor: 'accessing' stamp: 'kf 10/17/2008 22:30'!
halfWidth
	^self width / 2.0.! !

!GdsPath methodsFor: 'initialization' stamp: 'kf 10/24/2009 20:45'!
initialize
	super initialize.
	wire := GdsWireContext new element: self.
! !

!GdsPath methodsFor: 'outline' stamp: 'kf 10/24/2009 20:28'!
outlineSegmentsOf: aLineSegment offsetRadians: radians r: r
	^wire outlineSegmentsOf: aLineSegment offsetRadians: radians r: r
	! !

!GdsPath methodsFor: 'accessing' stamp: 'kf 10/24/2009 20:28'!
pathtype
	^wire pathtype! !

!GdsPath methodsFor: 'accessing' stamp: 'kf 10/24/2009 20:29'!
pathtype: aInteger
	wire pathtype: aInteger.
	self changed: #pathtype.! !

!GdsPath methodsFor: 'other' stamp: 'kf 10/24/2009 21:03'!
removeGeometryCache
	wire removeGeometryCache.! !

!GdsPath methodsFor: 'accessing' stamp: 'kf 10/1/2008 23:14'!
validateVertices: aPointArray editorContext: aGdsEditorContext
	| |
	^super validateVertices: aPointArray.
! !

!GdsPath methodsFor: 'accessing' stamp: 'kf 10/24/2009 20:23'!
width
	^wire width! !

!GdsPath methodsFor: 'accessing' stamp: 'kf 10/27/2009 21:45'!
width: aNumber
	wire width: aNumber.
	self changed: #width.	! !

!GdsPrimitiveElement class methodsFor: 'testing' stamp: 'kf 10/27/2009 11:03'!
hasDataType
	^true.! !

!GdsPrimitiveElement class methodsFor: 'testing' stamp: 'kf 10/23/2008 20:26'!
hasLayer
	^true.! !

!GdsPrimitiveElement methodsFor: 'accessing' stamp: 'kf 10/21/2009 16:38'!
datatype
	^datatype! !

!GdsPrimitiveElement methodsFor: 'accessing' stamp: 'kf 10/21/2009 16:38'!
datatype: aInteger
	self assert: [aInteger isKindOf: Integer].
	datatype := aInteger.
	self changed: #datatype.! !

!GdsPrimitiveElement methodsFor: 'debugging' stamp: 'kf 7/14/2009 14:59'!
fixGeometryError
	| newPoints|
	self vertexCount < self requiredVertexCount ifTrue: [^self].
	newPoints := OrderedCollection new.
	GeometryUtils removeDuplicatePoints:  self vertices on: newPoints.
	self privateWipe.
	self vertices: (self validateVertices: newPoints).
	! !

!GdsPrimitiveElement methodsFor: 'initialization' stamp: 'kf 9/19/2008 18:55'!
initialize
	super initialize.
	layer := 1.
	! !

!GdsPrimitiveElement methodsFor: 'deprecated' stamp: 'kf 10/27/2009 10:35'!
layer
	self deprecated: 'use #layerNumber'.
	^layer.
	! !

!GdsPrimitiveElement methodsFor: 'deprecated' stamp: 'kf 10/27/2009 10:34'!
layer: aInteger
	self deprecated: 'use #layerNumber:'.
	self assert: [aInteger isKindOf: Integer].
	layer := aInteger.
	self changed: #layer.! !

!GdsPrimitiveElement methodsFor: 'accessing' stamp: 'kf 10/27/2009 10:41'!
layerNumber
	^layerNumber.
	! !

!GdsPrimitiveElement methodsFor: 'accessing' stamp: 'kf 10/27/2009 10:41'!
layerNumber: aInteger
	self assert: [aInteger isKindOf: Integer].
	layerNumber := aInteger.
	self changed: #layerNumber.! !

!GdsPrimitiveElement methodsFor: 'accessing' stamp: 'kf 9/19/2008 18:57'!
xy: aPoint

	! !

GdsElement subclass: #GdsReferenceElement
	instanceVariableNames: 'strans'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsFeel-Model-Element'!

!GdsReferenceElement class methodsFor: 'as yet unclassified' stamp: 'kf 5/12/2009 15:33'!
fromItemContext: aGdsEditorContext atIndex: anIndex
	^ self new fromItemContext: aGdsEditorContext atIndex: anIndex.! !

!GdsReferenceElement class methodsFor: 'as yet unclassified' stamp: 'kf 5/12/2009 16:26'!
isReference
	^true! !

!GdsReferenceElement methodsFor: 'accessing' stamp: 'kf 5/14/2009 22:55'!
angle
	^strans angle! !

!GdsReferenceElement methodsFor: 'accessing' stamp: 'kf 6/24/2009 16:37'!
angle: aDegees
	strans angle: aDegees.
	self refreshBounds.	! !

!GdsReferenceElement methodsFor: 'copying' stamp: 'kf 5/15/2009 14:52'!
copyTransform
	strans := strans copy.
! !

!GdsReferenceElement methodsFor: 'accessing' stamp: 'kf 6/24/2009 16:39'!
dataOutlinePoints
	^self lookupExtentPoints! !

!GdsReferenceElement methodsFor: 'initialization' stamp: 'kf 5/15/2009 11:45'!
fromItemContext: aGdsItemContext
	self fromItemContext: aGdsItemContext atIndex: 1.
	 	
! !

!GdsReferenceElement methodsFor: 'initialization' stamp: 'kf 11/10/2009 11:34'!
fromItemContext: aGdsItemContext atIndex: aVerticesIndex
	| location |
	self assert: aGdsItemContext structureName isEmpty not.
	location := aGdsItemContext vertices at: aVerticesIndex.
	self xy: location.
	self angle: aGdsItemContext angle.
	self mag: aGdsItemContext mag.
	self setReflected: aGdsItemContext isReflected.
	self statusNumber: aGdsItemContext number.
	 	
! !

!GdsReferenceElement methodsFor: 'initialization' stamp: 'kf 5/12/2009 11:21'!
initialize
	super initialize.
	strans := GdsStructureTransform new.
	! !

!GdsReferenceElement methodsFor: 'testing' stamp: 'kf 6/24/2009 16:10'!
isPureTranslation
	^self transform isPureTranslation! !

!GdsReferenceElement methodsFor: 'testing' stamp: 'kf 11/10/2009 11:20'!
isReflected
	^strans isReflected! !

!GdsReferenceElement methodsFor: 'accessing' stamp: 'kf 5/15/2009 22:42'!
mag
	^strans mag! !

!GdsReferenceElement methodsFor: 'accessing' stamp: 'kf 6/24/2009 16:37'!
mag: aFactor
	strans mag: aFactor.
	self refreshBounds.	! !

!GdsReferenceElement methodsFor: 'accessing' stamp: 'kf 5/15/2009 14:41'!
moveRelative: aPoint from: aOtherElement
	| translatedPoint |
	translatedPoint := aOtherElement xy+ aPoint.
	self privateWipe.
	self xy: translatedPoint.! !

!GdsReferenceElement methodsFor: 'copying' stamp: 'kf 11/22/2009 16:52'!
postCopy
	super postCopy. 
	self copyTransform.
	
! !

!GdsReferenceElement methodsFor: 'testing' stamp: 'kf 11/10/2009 11:23'!
setReflected: aBoolean
	strans setReflected: aBoolean
	! !

!GdsReferenceElement methodsFor: 'accessing' stamp: 'kf 10/23/2009 21:35'!
strans
	^strans! !

!GdsReferenceElement methodsFor: 'accessing' stamp: 'kf 5/12/2009 18:40'!
transform
	^strans asMatrix2x3! !

!GdsReferenceElement methodsFor: 'accessing' stamp: 'kf 6/24/2009 16:37'!
xy: aPoint
	self privateWipe.
	super xy: aPoint.
	strans offset: aPoint.
	self refreshBounds.! !

GdsReferenceElement subclass: #GdsStructureReference
	instanceVariableNames: 'sname structure'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsFeel-Model-Element'!

!GdsStructureReference commentStamp: 'kf 11/12/2008 11:58' prior: 0!
A GdsStructureReference is GDS II's SREF.

Instance Variables
!

GdsStructureReference subclass: #GdsArrayedStructureReference
	instanceVariableNames: 'ashape'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsFeel-Model-Element'!

!GdsArrayedStructureReference commentStamp: 'kf 11/12/2008 11:58' prior: 0!
A GdsArrayedStructureReference is GDS II's AREF.

Instance Variables
!

!GdsArrayedStructureReference class methodsFor: 'accessing' stamp: 'kf 10/23/2008 19:54'!
type
	^#aref.! !

!GdsArrayedStructureReference methodsFor: 'objects from disk' stamp: 'kf 11/9/2009 16:07'!
asXmlElement
	| elmt|
	elmt := super asXmlElement.
	elmt addElement: ashape asXmlElement.
	^elmt.
	

! !

!GdsArrayedStructureReference methodsFor: 'private' stamp: 'kf 11/6/2009 15:35'!
baseLocalBounds
	^super lookupLocalBounds.
! !

!GdsArrayedStructureReference methodsFor: 'accessing' stamp: 'kf 11/6/2009 15:46'!
columnCount
	^ ashape columnCount! !

!GdsArrayedStructureReference methodsFor: 'accessing' stamp: 'kf 11/6/2009 15:46'!
columnCount: anInteger 
	ashape columnCount: anInteger! !

!GdsArrayedStructureReference methodsFor: 'private' stamp: 'kf 11/9/2009 15:36'!
fromItemContext: aGdsItemContext atIndex: aVerticesIndex
	super fromItemContext:  aGdsItemContext atIndex: aVerticesIndex.
	self columnCount: aGdsItemContext ashape columnCount.
	self rowCount: aGdsItemContext ashape rowCount.
	self xStep: aGdsItemContext ashape xStep.
	self yStep: aGdsItemContext ashape yStep.	
	! !

!GdsArrayedStructureReference methodsFor: 'initialization' stamp: 'kf 11/6/2009 21:53'!
initialize
	super initialize.
	ashape := GdsAShapeContext new propertyOwner: self! !

!GdsArrayedStructureReference methodsFor: 'objects from disk' stamp: 'kf 11/9/2009 16:22'!
loadFromXmlNode: aXMLNode
	super loadFromXmlNode: aXMLNode.
	aXMLNode elementsDo: [:node |
		node tag = #ashape
			ifTrue: [
				ashape loadFromXmlNode: node].]

! !

!GdsArrayedStructureReference methodsFor: 'private' stamp: 'kf 11/6/2009 15:46'!
lookupLocalBounds
	^ ashape lookupLocalBounds: super lookupLocalBounds! !

!GdsArrayedStructureReference methodsFor: 'private' stamp: 'kf 11/9/2009 15:37'!
rebuildVertices! !

!GdsArrayedStructureReference methodsFor: 'private' stamp: 'kf 11/6/2009 15:46'!
relativeTransforms
	^ ashape relativeTransforms! !

!GdsArrayedStructureReference methodsFor: 'accessing' stamp: 'kf 11/6/2009 15:46'!
rowCount
	^ ashape rowCount! !

!GdsArrayedStructureReference methodsFor: 'accessing' stamp: 'kf 11/6/2009 15:46'!
rowCount: anInteger 
	ashape rowCount: anInteger! !

!GdsArrayedStructureReference methodsFor: 'accessing' stamp: 'kf 11/6/2009 17:32'!
stepToOwnSize
	self xStepToOwnSize.
	self yStepToOwnSize.
	! !

!GdsArrayedStructureReference methodsFor: 'accessing' stamp: 'kf 11/6/2009 15:46'!
xStep
	^ ashape xStep! !

!GdsArrayedStructureReference methodsFor: 'accessing' stamp: 'kf 11/6/2009 16:02'!
xStep: aFloat 
	ashape xStep: aFloat.
	self rebuildVertices.
	! !

!GdsArrayedStructureReference methodsFor: 'accessing' stamp: 'kf 11/6/2009 17:31'!
xStepToOwnSize
	self xStep: self baseLocalBounds width.! !

!GdsArrayedStructureReference methodsFor: 'accessing' stamp: 'kf 11/6/2009 15:46'!
yStep
	^ ashape yStep! !

!GdsArrayedStructureReference methodsFor: 'accessing' stamp: 'kf 11/6/2009 16:02'!
yStep: aFloat 
	ashape yStep: aFloat.
	self rebuildVertices.
! !

!GdsArrayedStructureReference methodsFor: 'accessing' stamp: 'kf 11/6/2009 17:32'!
yStepToOwnSize
	self yStep: self baseLocalBounds height.! !

!GdsStructureReference class methodsFor: 'accessing' stamp: 'kf 10/23/2008 19:53'!
type
	^#sref! !

!GdsStructureReference methodsFor: 'objects from disk' stamp: 'kf 11/10/2009 16:16'!
attributesFrom: aDictionary
	super attributesFrom: aDictionary.
	self structureName: (aDictionary at: 'sname' ifAbsent: ['ERRREF']) asString.
	self angle: (aDictionary at: 'angle' ifAbsent: [0.0]) asNumber.
	self mag: (aDictionary at: 'mag' ifAbsent: [1.0]) asNumber.	
	self setReflected: ((aDictionary at: 'reflected' ifAbsent: [false]) asString sameAs: 'true').	
	! !

!GdsStructureReference methodsFor: 'objects from disk' stamp: 'kf 11/11/2009 09:47'!
attributesOn: aDictionary
	super attributesOn: aDictionary.
	aDictionary at: 'sname' put: self structureName asString.
	self angle = 0.0
		ifFalse: [
			aDictionary at: 'angle' put: self angle asString].	
	self mag = 1.0
		ifFalse: [
			aDictionary at: 'mag' put: self mag asString].
	self isReflected 
		ifTrue: [	
			aDictionary at: 'reflected' put: self isReflected asString].					! !

!GdsStructureReference methodsFor: 'initialization' stamp: 'kf 5/12/2009 15:35'!
fromItemContext: aGdsItemContext atIndex: aVerticesIndex
	super fromItemContext:  aGdsItemContext atIndex: aVerticesIndex.
	self structureName: aGdsItemContext structureName.! !

!GdsStructureReference methodsFor: 'initialization' stamp: 'kf 11/6/2009 11:52'!
initialize
	super initialize.
	sname := ''.! !

!GdsStructureReference methodsFor: 'objects from disk' stamp: 'kf 11/6/2009 18:56'!
loadFromXmlNode: aXmlNode
	super loadFromXmlNode: aXmlNode.
	self xy: self vertices first.
! !

!GdsStructureReference methodsFor: 'accessing' stamp: 'kf 11/5/2009 15:57'!
localBounds
	^self lookupLocalBounds.
	 	 			! !

!GdsStructureReference methodsFor: 'private' stamp: 'kf 11/5/2009 15:57'!
lookupBasicExtentPoints
	^GeometryUtils verticesFromBounds: self localBounds.
	 	 			! !

!GdsStructureReference methodsFor: 'private' stamp: 'kf 11/24/2009 16:29'!
lookupExtentPoints
	^self lookupBasicExtentPoints 
			collect: [:each | self transform transformPoint: each ].
! !

!GdsStructureReference methodsFor: 'private' stamp: 'kf 11/5/2009 15:55'!
lookupLocalBounds
	^self structure dataExtentForElements.
	 	 			! !

!GdsStructureReference methodsFor: 'printing' stamp: 'kf 11/6/2009 11:29'!
printSelfOn: aStream
	sname ifNil: [^self].
	aStream nextPut: $,.
	aStream nextPutAll: self structureName! !

!GdsStructureReference methodsFor: 'accessing' stamp: 'kf 5/13/2009 10:01'!
structure
	structure ifNil: [
		structure := self owner database structureNamed: self structureName.].
	^structure! !

!GdsStructureReference methodsFor: 'accessing' stamp: 'kf 5/12/2009 16:32'!
structureName
	^sname
	! !

!GdsStructureReference methodsFor: 'accessing' stamp: 'kf 5/12/2009 11:23'!
structureName: aString
	sname := aString.
	self changed: #sname.
	! !

GdsReferenceElement subclass: #GdsText
	instanceVariableNames: 'contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsFeel-Model-Element'!

!GdsText commentStamp: 'kf 11/12/2008 11:59' prior: 0!
A GdsText is GDS II's TEXT.

Instance Variables
!

!GdsText class methodsFor: 'accessing' stamp: 'kf 10/23/2008 19:53'!
type
	^#text.! !

!GdsText methodsFor: 'initialization' stamp: 'kf 9/19/2008 18:16'!
initialize
	super initialize.! !

Model subclass: #GdsGrid
	instanceVariableNames: 'offsetX offsetY scaleX scaleY displayMultiply'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsFeel-Model-Viewing'!

!GdsGrid commentStamp: 'kf 11/12/2008 11:58' prior: 0!
A GdsGrid is Gridding attribute.

Instance Variables
	offsetX:		<Float>
	offsetY:		<Float>
	scaleX:		<Float>
	scaleY:		<Float>

offsetX
	- xxxxx

offsetY
	- xxxxx

scaleX
	- xxxxx

scaleY
	- xxxxx
!

!GdsGrid class methodsFor: 'as yet unclassified' stamp: 'kf 11/16/2009 13:30'!
lookupGridStepsMin: aMinValue max: aMaxValue gridScale: aGridScale
	^((Interval 
		from: ((aMinValue roundTo: aGridScale) -  aGridScale) 
		to: ((aMaxValue roundTo: aGridScale) + aGridScale ) by: aGridScale) 
			collect: [:each | each roundTo: aGridScale]) asArray.! !

!GdsGrid methodsFor: 'convert' stamp: 'kf 6/9/2009 10:50'!
asAbbreviateArray
	| values |
	values := OrderedCollection new.
	self isZeroOffset 
		ifTrue: [
			values add: scaleX.
			self isSameScale 
				ifFalse: [values add: scaleY]]
		ifFalse: [
			values addAll: self asArray].
	^values asArray
! !

!GdsGrid methodsFor: 'convert' stamp: 'kf 6/9/2009 10:47'!
asAbbreviateArrayDeprecated
	| values |
	values := OrderedCollection new.
	self isZeroOffset 
		ifTrue: [
			values add: scaleX.
			self isSameScale 
				ifFalse: [values add: scaleY]]
		ifFalse: [
			values add: scaleX.
			values add: scaleY.
			values add: offsetX.
			self isSameOffset
				ifFalse: [values add: offsetY]].
	^values asArray
! !

!GdsGrid methodsFor: 'convert' stamp: 'kf 6/9/2009 10:47'!
asArray
	^{ offsetX . offsetY . scaleX . scaleY }! !

!GdsGrid methodsFor: 'convert' stamp: 'kf 6/9/2009 10:46'!
asArrayDeprecated
	^{ scaleX . scaleY . offsetX . offsetY }! !

!GdsGrid methodsFor: 'convert' stamp: 'kf 11/20/2008 10:46'!
asRequestString
	^GdsFeel join:  (self asAbbreviateArray collect: [:each | each asString]) using: ' '.! !

!GdsGrid methodsFor: 'accessing' stamp: 'kf 6/10/2009 09:56'!
displayMultiply
	^displayMultiply
	! !

!GdsGrid methodsFor: 'accessing' stamp: 'kf 6/10/2009 10:48'!
displayMultiply: aValue
	| value |
	value := aValue asInteger .
	value negative ifTrue: [^self].
	displayMultiply := value.
	self changed: #gridDisplayMultiply.
	! !

!GdsGrid methodsFor: 'initialization' stamp: 'kf 6/10/2009 09:51'!
initialize
	offsetX := 0.0.
	offsetY := 0.0.
	scaleX := 10.0.
	scaleY := 10.0.
	displayMultiply := 1.
	! !

!GdsGrid methodsFor: 'testing' stamp: 'kf 11/20/2008 10:26'!
isSameOffset
	^offsetX = offsetY! !

!GdsGrid methodsFor: 'testing' stamp: 'kf 11/20/2008 10:25'!
isSameScale
	^scaleX = scaleY! !

!GdsGrid methodsFor: 'testing' stamp: 'kf 11/20/2008 10:40'!
isZeroOffset
	^self offset isZero! !

!GdsGrid methodsFor: 'utility' stamp: 'kf 11/16/2009 13:10'!
lookupGridStepsMin: aMin max: aMax gridScale: aGridScale gridOffset: aGridOffset
	|  start end  values unit |
	start :=  aMin roundTo: aGridScale.
	end :=  aMax roundTo: aGridScale.
	values := (self class lookupGridStepsMin: start max: end gridScale: aGridScale).
	unit := self  displayMultiply * aGridScale.
	values := values select: [:each | | v | 
		v := (each rem: unit) abs roundTo: unit.
		v = 0.0 or: [v = unit]].  
	values := values collect: [:each | each + aGridOffset].
	^values
	
	! !

!GdsGrid methodsFor: 'accessing' stamp: 'kf 11/17/2009 20:21'!
offset
	^offsetX@offsetY.! !

!GdsGrid methodsFor: 'accessing' stamp: 'kf 6/10/2009 10:02'!
offset: aOffset
	| p |
	p := aOffset asPoint.
	self setOffsetX: p x setOffsetY: p y. 
	self changed: #gridOffset.
	self displayMultiply: 1.
	
	! !

!GdsGrid methodsFor: 'accessing' stamp: 'kf 11/17/2009 20:21'!
scale
	^scaleX@scaleY.! !

!GdsGrid methodsFor: 'accessing' stamp: 'kf 6/10/2009 10:02'!
scale: aScale
	| p |
	p := aScale asPoint.
	self setScaleX: p x setScaleY: p y. 
	self changed: #gridScale.
	self displayMultiply: 1.
	! !

!GdsGrid methodsFor: 'private' stamp: 'kf 9/26/2008 23:00'!
setOffsetX: aX setOffsetY: aY
	offsetX := aX.
	offsetY := aY.
	
! !

!GdsGrid methodsFor: 'private' stamp: 'kf 9/26/2008 23:01'!
setScaleX: aX setScaleY: aY
	scaleX := aX.
	scaleY := aY.
	! !

!GdsGrid methodsFor: 'accessing' stamp: 'kf 6/10/2009 10:02'!
values: anArray
	self assert: [anArray isNil not].
	self assert: [anArray allSatisfy: [:each | each isNumber]].
	self assert: [#(1 2 4) includes: anArray size].
	anArray ifEmpty: [^self].
	anArray size = 1
		ifTrue: [
			scaleX := anArray at: 1.
			scaleY := anArray at: 1.].
	anArray size = 2
		ifTrue: [
			scaleX := anArray at: 1.
			scaleY := anArray at: 2.].
	anArray size = 4
		ifTrue: [
			offsetX := anArray at: 1.
			offsetY := anArray at: 2.
			scaleX := anArray at: 3.
			scaleY := anArray at: 4.].

	self changed: #gridScale.
	anArray size = 4 
		ifTrue: [self changed: #gridOffset.].
	self displayMultiply: 1.
	! !

!GdsGrid methodsFor: 'accessing' stamp: 'kf 6/9/2009 10:51'!
valuesDeprecated: anArray
	self assert: [anArray isNil not].
	self assert: [anArray allSatisfy: [:each | each isNumber]].
	self assert: [anArray size <= 4].
	anArray ifEmpty: [^self].
	anArray size >= 1 ifTrue: [scaleX := anArray at: 1].
	anArray size >= 2 ifTrue: [scaleY := anArray at: 2].
	anArray size >= 3 ifTrue: [offsetX := anArray at: 3].
	anArray size = 4 ifTrue: [offsetY := anArray at: 4].
	anArray size = 1 ifTrue: [scaleY := anArray at: 1].
	anArray size = 3 ifTrue: [offsetY := anArray at: 3].	
	self changed: #gridScale.
	anArray size >= 3 ifTrue: [self changed: #gridOffset.].! !

Model subclass: #GdsIdContext
	instanceVariableNames: 'structure ids'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsFeel-Model-EditSpace'!

!GdsIdContext commentStamp: 'kf 11/12/2008 13:38' prior: 0!
A GdsIdContext is element identify selection context.

Instance Variables
!

!GdsIdContext methodsFor: 'accessing' stamp: 'kf 11/12/2008 14:14'!
elements
	self isEmpty ifTrue: [^#() copy].
	^structure liveElements select: [:each | ids includes: each keyNumber].! !

!GdsIdContext methodsFor: 'testing' stamp: 'kf 11/12/2008 14:11'!
enabled
	^self isEmpty not.! !

!GdsIdContext methodsFor: 'private' stamp: 'kf 11/13/2008 15:13'!
forgetStructure
	self idClear.
	structure ifNotNil: [self removeDependent: structure].
	structure := nil.
	! !

!GdsIdContext methodsFor: 'id operation' stamp: 'kf 11/13/2008 15:44'!
id: keyNumber 
	self privateIdClear.
	self idAdd: keyNumber.
	self changed: #id! !

!GdsIdContext methodsFor: 'id operation' stamp: 'kf 11/14/2008 22:28'!
idAdd: keyNumber 
	self assert: [keyNumber isKindOf: Integer].
	ids ifNil: [ ids := Set new ].
	ids add: keyNumber.
	self changed: #id! !

!GdsIdContext methodsFor: 'id operation' stamp: 'kf 11/12/2008 14:03'!
idClear
	self privateIdClear.
	self changed: #id! !

!GdsIdContext methodsFor: 'testing' stamp: 'kf 11/13/2008 16:00'!
idClearEnabled
	^self notEmpty.! !

!GdsIdContext methodsFor: 'id operation' stamp: 'kf 11/14/2008 23:27'!
idDelete
	structure idDelete.	 
	structure updateIdState.
	self privateIdClear.
	self changed: #tstructEnabed.
	self changed: #idDelete.
	self changed: #id! !

!GdsIdContext methodsFor: 'testing' stamp: 'kf 11/14/2008 22:47'!
idDeleteEnabled
	^self notEmpty.! !

!GdsIdContext methodsFor: 'testing' stamp: 'kf 11/13/2008 13:43'!
isEmpty
	structure ifNil: [^true].
	ids ifNil: [^true].
	^ids  isEmpty.! !

!GdsIdContext methodsFor: 'accessing' stamp: 'kf 11/13/2008 14:31'!
keyNumbers
	self isEmpty ifTrue: [^#() copy].
	^ids! !

!GdsIdContext methodsFor: 'testing' stamp: 'kf 11/13/2008 15:38'!
notEmpty
	^self isEmpty not.! !

!GdsIdContext methodsFor: 'private' stamp: 'kf 11/12/2008 14:03'!
privateIdClear
	ids := nil.
! !

!GdsIdContext methodsFor: 'accessing' stamp: 'kf 11/12/2008 14:06'!
structure: aGdsStructure
	aGdsStructure
		ifNil: [structure ifNotNil: [self removeDependent: structure]]
		ifNotNil: [self addDependent: aGdsStructure].
	structure := aGdsStructure.
	self changed: #structure.
		! !

!GdsIdContext methodsFor: 'id operation' stamp: 'kf 11/13/2008 11:55'!
unId: keyNumber 
	ids ifNil: [ ^ self ].
	ids remove: keyNumber ifAbsent: [Transcript cr; show: '*** WARNING ***' , 'UNID: ',keyNumber printString, ' not in id selection'].
	self changed: #id! !

Model subclass: #GdsItemContext
	instanceVariableNames: 'structure elementType colVertices digitaizingDirection digitaizingMode editElement itemNumber offset width text structureName wire datatype layerNumber ashape strans'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsFeel-Model-EditSpace'!

!GdsItemContext commentStamp: 'kf 5/4/2009 11:40' prior: 0!
A GdsItemContext is attribute holder for ITEM edit.

Instance Variables
	colVertices:		<Array<Point>>
	digitaizingDirection:		<Symbol>
	digitaizingMode:		<Symbol>
	editElement:		<GdsElement>
	elementType:		<Symbol>
	itemNumber:		<SmallInteger>
	layer:		<SmallInteger>
	width:		<Float>
	structure:		<GdsStructure>

colVertices
	- xxxxx

digitaizingDirection
	- xxxxx

digitaizingMode
	- xxxxx

editElement
	- xxxxx

elementType
	- xxxxx

itemNumber
	- xxxxx

layer
	- xxxxx

structure
	- xxxxx
!

!GdsItemContext class methodsFor: 'as yet unclassified' stamp: 'kf 11/6/2009 13:56'!
new
	^self error: 'only use #newWithNumber: '.! !

!GdsItemContext class methodsFor: 'as yet unclassified' stamp: 'kf 11/6/2009 13:54'!
newWithNumber: anInteger
	^self basicNew initWithNumber: anInteger! !

!GdsItemContext methodsFor: 'accessing' stamp: 'kf 11/10/2009 09:59'!
angle
	^strans angle
	! !

!GdsItemContext methodsFor: 'utility' stamp: 'kf 5/16/2009 10:59'!
angle360: aDegree
	| rem |
	rem := aDegree asFloat rem: 360.0.
	^aDegree negative ifTrue: [360.0 + rem] ifFalse: [rem].
	! !

!GdsItemContext methodsFor: 'accessing' stamp: 'kf 5/16/2009 11:01'!
angle: aDegrees
	| newAngle oldAngle |
	oldAngle := self angle360: self angle.  
	newAngle := self angle360: aDegrees.
	oldAngle = newAngle ifTrue: [^self].
	self privateAngle: newAngle.
	! !

!GdsItemContext methodsFor: 'as yet unclassified' stamp: 'kf 11/6/2009 13:39'!
aref
	self elementType: #aref.
	! !

!GdsItemContext methodsFor: 'as yet unclassified' stamp: 'kf 11/6/2009 13:40'!
arefActivated
	^elementType == #aref.! !

!GdsItemContext methodsFor: 'as yet unclassified' stamp: 'kf 11/6/2009 13:41'!
arefEnabled
	^ self srefEnabled "and: [more]"! !

!GdsItemContext methodsFor: 'accessing' stamp: 'kf 11/9/2009 12:09'!
ashape
	^ashape! !

!GdsItemContext methodsFor: 'testing' stamp: 'kf 11/9/2009 14:10'!
ashapeInstalled
	^(Smalltalk 
		at: #GdsAShapeContext
		ifAbsent: [ nil ]) notNil! !

!GdsItemContext methodsFor: 'command-elementKind' stamp: 'kf 10/21/2008 17:49'!
boundary
	self elementType: #boundary.
	! !

!GdsItemContext methodsFor: 'testing' stamp: 'kf 7/14/2009 13:38'!
boundaryActivated
	^self isBoundary.! !

!GdsItemContext methodsFor: 'testing' stamp: 'kf 7/15/2009 11:36'!
boundaryClosed
	^(self isBoundary) and: [
	(self colVertices size > 3) and:
	[self colVertices first = self colVertices last]].
! !

!GdsItemContext methodsFor: 'testing' stamp: 'kf 10/21/2008 17:13'!
boundaryEnabled
	^true! !

!GdsItemContext methodsFor: 'command-elementKind' stamp: 'kf 5/6/2009 17:04'!
boxtext
	self elementType: #boxtext.
	! !

!GdsItemContext methodsFor: 'command-points' stamp: 'kf 6/8/2009 17:10'!
ce: aPoint
	| absPoint |
	aPoint class = Point
		ifFalse: [self error: 'ce: require Point instance.'].
	offset ifNil: [offset := 0@0].
	absPoint := offset + aPoint.
	(self colVertices isEmpty not)
		ifTrue: [
			(self colVertices last = absPoint)
				ifTrue: [^self.]].
	self colVertices add: absPoint.
	self changedPutGetDpendent.	
	! !

!GdsItemContext methodsFor: 'command-points' stamp: 'kf 11/27/2008 21:06'!
ceMove: deltaPoint
	deltaPoint class = Point
		ifFalse: [self error: 'ceMove: require Point instance.'].
	offset := offset + deltaPoint.
	! !

!GdsItemContext methodsFor: 'command-points' stamp: 'kf 11/27/2008 21:06'!
ceMoveTo: aPoint
	aPoint class = Point
		ifFalse: [self error: 'ceMoveTo: require Point instance.'].
	offset := aPoint.
	! !

!GdsItemContext methodsFor: 'private' stamp: 'kf 11/6/2008 17:37'!
changedPutGetDpendent
	self putGetDependentSelectors do: [:each | self changed: each].! !

!GdsItemContext methodsFor: 'accessing-points' stamp: 'kf 7/15/2009 11:06'!
closeVertex
	(self needsCloseBoundary)
		ifTrue: [colVertices add: (self colVertices first copy)].! !

!GdsItemContext methodsFor: 'private' stamp: 'kf 9/20/2008 14:12'!
colVertices
	colVertices ifNil: [colVertices := OrderedCollection  new].
	 ^colVertices.! !

!GdsItemContext methodsFor: 'private' stamp: 'kf 11/17/2009 10:41'!
completionPointFrom: aPoint1 to: aPoint2
	| deltaPoint r theta roundedTheta |
	(self digitaizingMode = #straight)
		ifTrue: [^nil.].
	(self digitaizingMode = #octagonal)
		ifTrue: [
			deltaPoint := aPoint2 - aPoint1.
			r := deltaPoint r.
			theta := deltaPoint theta.
			roundedTheta := GeometryUtils octagonalRoundTheta: theta.
			^(Point r: r degrees: roundedTheta radiansToDegrees) + aPoint1.].
	(self digitaizingMode = #orthint)
		ifTrue: [
			^(self digitaizingDirection = #vertfirst)
				ifTrue: [(aPoint1 x)@(aPoint2 y)]
				ifFalse: [(aPoint2 x)@(aPoint1 y)]].
	^nil.! !

!GdsItemContext methodsFor: 'copying' stamp: 'kf 5/15/2009 10:02'!
copyTo: aGdsItemContext
	aGdsItemContext privateWipe.
	aGdsItemContext vertices: self vertices.
	! !

!GdsItemContext methodsFor: 'command' stamp: 'kf 11/8/2008 22:18'!
createElement
	^self elementClass fromItemContext: self.
! !

!GdsItemContext methodsFor: 'command' stamp: 'kf 5/12/2009 16:54'!
createElements
	| elements |
	elements := OrderedCollection new.
	1 to: self vertices size do: [:index |
		elements add: (self elementClass fromItemContext: self atIndex: index).].
	^elements asArray.
! !

!GdsItemContext methodsFor: 'accessing' stamp: 'kf 10/27/2009 13:20'!
datatype
	^datatype
	
	
! !

!GdsItemContext methodsFor: 'accessing' stamp: 'kf 10/27/2009 13:29'!
datatype: anInteger
	datatype  = anInteger ifTrue: [^self].
	datatype := anInteger.
	self changed: #datatype.
	"TODO: remove this change. Model not known GUI"
	"self changed: #chooseDataTypeLabel.	"
	
! !

!GdsItemContext methodsFor: 'command' stamp: 'kf 9/23/2008 23:16'!
digitaizingDirection
	digitaizingDirection ifNil: [digitaizingDirection := #vertfirst.].
	^digitaizingDirection.
	
! !

!GdsItemContext methodsFor: 'command' stamp: 'kf 10/21/2008 18:14'!
digitaizingDirection: aSymbol
	digitaizingDirection := aSymbol.
	self changed: #vertfirstActivated.
	self changed: #horizfirstActivated.	! !

!GdsItemContext methodsFor: 'accessing' stamp: 'kf 10/21/2008 17:36'!
digitaizingMode
	digitaizingMode ifNil: [self digitaizingMode: #straight].
	^digitaizingMode
! !

!GdsItemContext methodsFor: 'accessing' stamp: 'kf 5/16/2009 10:56'!
digitaizingMode: aSymbol
	digitaizingMode = aSymbol ifTrue: [^self].
	digitaizingMode := aSymbol.

	self orthintActivated 
		ifTrue:[
			self changed: #vertfirstActivated.
			self changed: #horizfirstActivated.].
		
	self changed: #vertfirstEnabled.
	self changed: #horizfirstEnabled.
	
	self changed: #straightActivated.
	self changed: #octagonalActivated.
	self changed: #orthintActivated.
! !

!GdsItemContext methodsFor: 'accessing' stamp: 'kf 10/26/2008 14:45'!
editElement
	^editElement! !

!GdsItemContext methodsFor: 'command' stamp: 'kf 10/23/2008 20:10'!
elementClass
	^GdsElement classForType: elementType.
! !

!GdsItemContext methodsFor: 'accessing' stamp: 'kf 11/5/2008 15:58'!
elementType
	^elementType! !

!GdsItemContext methodsFor: 'accessing' stamp: 'kf 11/12/2009 18:10'!
elementType: aSymbol
	elementType = aSymbol ifTrue: [^self].
	elementType := aSymbol.
	self changed: #elementType.
	self changed: #boundaryActivated.
	self changed: #pathActivated.
	self changed: #srefActivated.	
	self changed: #arefActivated.	
	self putGetDependentSelectors do: [:each |
		self changed: each].! !

!GdsItemContext methodsFor: 'testing' stamp: 'kf 5/7/2009 14:52'!
enterTextEnabled
	^true! !

!GdsItemContext methodsFor: 'utility' stamp: 'kf 7/13/2009 17:28'!
feedbackElements
	| el |
	el := self  editElement.
	el ifNotNil: [
		el := el copy.
		[el fromItemContext: self]
			on: Error do: [:ex | ^#() copy].
		^Array with: el ].
	
	^[self isReferenceType
			ifTrue: [self  createElements] 
			ifFalse: [ Array with: self createElement ]]
		on: Error do:  [:ex | #() copy].! !

!GdsItemContext methodsFor: 'utility' stamp: 'kf 5/16/2009 11:02'!
fixMag: aFactor
	^(aFactor asFloat <= 0.0) ifTrue: [1.0] ifFalse: [aFactor asFloat].

	! !

!GdsItemContext methodsFor: 'private' stamp: 'kf 10/31/2009 20:13'!
forgetStructure
	structure ifNotNil: [
		"self removeDependent: structure."
		structure := nil]
	! !

!GdsItemContext methodsFor: 'command' stamp: 'kf 11/13/2008 10:14'!
get: aGdsElement
	self colVertices ifNotEmpty: [^self error: 'item not empty'].
	self importAttribute: aGdsElement.
	aGdsElement statusNumber: itemNumber.
	editElement := aGdsElement.
	self changed.
	self changedPutGetDpendent.! !

!GdsItemContext methodsFor: 'testing' stamp: 'kf 10/26/2008 22:21'!
getEnabled
	^editElement isNil and: [self vertices isEmpty].
! !

!GdsItemContext methodsFor: 'testing' stamp: 'kf 10/28/2008 22:16'!
holdsElement
	^editElement isNil not.
! !

!GdsItemContext methodsFor: 'command-digitaizingMode' stamp: 'kf 10/21/2008 18:12'!
horizfirst
	self digitaizingDirection: #horizfirst.
	
	! !

!GdsItemContext methodsFor: 'testing - dizitizing' stamp: 'kf 10/21/2008 17:55'!
horizfirstActivated
	^digitaizingDirection == #horizfirst.
	
	! !

!GdsItemContext methodsFor: 'testing - dizitizing' stamp: 'kf 11/9/2009 16:29'!
horizfirstEnabled
	^self isPrimitiveType and: [digitaizingMode == #orthint].
	
	! !

!GdsItemContext methodsFor: 'command' stamp: 'kf 11/10/2009 11:33'!
importAttribute: aGdsElement
	aGdsElement hasLayer ifTrue: [self layerNumber: aGdsElement layerNumber].
	aGdsElement hasDataType ifTrue: [self pathtype: aGdsElement datatype].
	aGdsElement hasPathType ifTrue: [self pathtype: aGdsElement pathtype].
	aGdsElement hasWidth ifTrue: [self width: aGdsElement width].
	(aGdsElement isMemberOf: GdsBoxText ) ifTrue: [self text: aGdsElement contents].
	(aGdsElement isKindOf: GdsStructureReference)
		ifTrue: [
			self structureName: aGdsElement structureName.
			self angle: aGdsElement angle.
			self mag: aGdsElement mag .
			self setReflected: aGdsElement isReflected].
	self colVertices addAll: aGdsElement vertices.
	(aGdsElement type = #aref)
		ifTrue: [
			ashape xStep: aGdsElement xStep.
			ashape yStep: aGdsElement yStep.
			ashape columnCount: aGdsElement columnCount.
			ashape rowCount: aGdsElement rowCount.
			colVertices := nil.
			self colVertices add: aGdsElement xy.].
	wire removeGeometryCache.
	self elementType: aGdsElement type.! !

!GdsItemContext methodsFor: 'initialization' stamp: 'kf 11/10/2009 10:01'!
initWithNumber: anInteger 
	super initialize.
	itemNumber := anInteger.
	offset := 0 @ 0.
	layerNumber := 1.
	datatype := 0.
	structureName := ''.
	wire := GdsWireContext new.
	strans := GdsStructureTransform new.
	ashape := nil.
	(Smalltalk 
		at: #GdsAShapeContext
		ifAbsent: [ nil ]) ifNotNilDo: [ :clazzAref | ashape := clazzAref new propertyOwner: self ].
	self digitaizingMode: #straight.
	self elementType: #boundary! !

!GdsItemContext methodsFor: 'testing' stamp: 'kf 5/14/2009 15:39'!
isAbsAngle
	^false "should implement."
	! !

!GdsItemContext methodsFor: 'testing' stamp: 'kf 5/14/2009 15:40'!
isAbsMag
	^false "should implement."
	! !

!GdsItemContext methodsFor: 'testing' stamp: 'kf 7/14/2009 13:37'!
isBoundary
	^elementType == #boundary.! !

!GdsItemContext methodsFor: 'testing' stamp: 'kf 11/10/2008 15:10'!
isEmpty
	^self colVertices isEmpty! !

!GdsItemContext methodsFor: 'testing' stamp: 'kf 5/13/2009 11:58'!
isPrimitiveType
	^self isReferenceType not! !

!GdsItemContext methodsFor: 'testing' stamp: 'kf 5/13/2009 11:58'!
isReferenceType
	^self elementClass isReference! !

!GdsItemContext methodsFor: 'private' stamp: 'kf 11/10/2009 11:36'!
isReflected
	^strans isReflected
	! !

!GdsItemContext methodsFor: 'testing' stamp: 'kf 7/15/2009 10:19'!
itemReverseEnabled
	^ self vertexCount >= 2! !

!GdsItemContext methodsFor: 'testing' stamp: 'kf 10/23/2008 20:27'!
layerEnabled
	self elementClass ifNil: [^false].
	^self elementClass hasLayer.! !

!GdsItemContext methodsFor: 'accessing' stamp: 'kf 10/27/2009 10:40'!
layerNumber
	^layerNumber.! !

!GdsItemContext methodsFor: 'accessing' stamp: 'kf 10/27/2009 13:32'!
layerNumber: aInteger
	layerNumber = aInteger ifTrue: [^self].
	layerNumber := aInteger.
	self changed: #layerNumber.
	"TODO: remove this change. Model not known GUI"	
	self changed: #chooseLayerLabel.	
! !

!GdsItemContext methodsFor: 'accessing' stamp: 'kf 11/10/2009 10:00'!
mag
	^strans mag.
	! !

!GdsItemContext methodsFor: 'accessing' stamp: 'kf 5/16/2009 11:04'!
mag: aFactor
	| oldValue newValue |
	oldValue := self fixMag: self mag.
	newValue := self fixMag: aFactor.
	oldValue = newValue ifTrue: [^self].
	self privateMag: newValue.
	! !

!GdsItemContext methodsFor: 'testing' stamp: 'kf 7/15/2009 11:07'!
needsCloseBoundary
	self isBoundary ifFalse: [^false].
	self colVertices size < 3 ifTrue: [^false].
	^(self colVertices first ~= self colVertices last).
! !

!GdsItemContext methodsFor: 'accessing' stamp: 'kf 11/10/2008 14:23'!
number
	^itemNumber! !

!GdsItemContext methodsFor: 'private' stamp: 'kf 11/10/2008 11:35'!
number: aNumber
	itemNumber := aNumber.
	! !

!GdsItemContext methodsFor: 'command-digitaizingMode' stamp: 'kf 10/21/2008 17:33'!
octagonal
	self digitaizingMode: #octagonal.
! !

!GdsItemContext methodsFor: 'testing - dizitizing' stamp: 'kf 10/21/2008 17:54'!
octagonalActivated
	^digitaizingMode == #octagonal.
! !

!GdsItemContext methodsFor: 'testing - dizitizing' stamp: 'kf 11/9/2009 16:28'!
octagonalEnabled
	^self isPrimitiveType 
! !

!GdsItemContext methodsFor: 'command-digitaizingMode' stamp: 'kf 10/21/2008 17:33'!
orthint
	self digitaizingMode: #orthint.
! !

!GdsItemContext methodsFor: 'testing - dizitizing' stamp: 'kf 10/21/2008 17:54'!
orthintActivated
	^digitaizingMode == #orthint.
! !

!GdsItemContext methodsFor: 'testing - dizitizing' stamp: 'kf 11/9/2009 16:28'!
orthintEnabled
	^self isPrimitiveType 
! !

!GdsItemContext methodsFor: 'command-elementKind' stamp: 'kf 10/21/2008 17:49'!
path
	self elementType: #path.
	! !

!GdsItemContext methodsFor: 'testing' stamp: 'kf 10/21/2008 17:52'!
pathActivated
	^elementType == #path.! !

!GdsItemContext methodsFor: 'testing' stamp: 'kf 10/21/2008 17:13'!
pathEnabled
	^true! !

!GdsItemContext methodsFor: 'testing' stamp: 'kf 10/27/2009 11:22'!
pathTypeEnabled
	self elementClass ifNil: [^false].
	^self elementClass = GdsPath.! !

!GdsItemContext methodsFor: 'accessing' stamp: 'kf 10/27/2009 11:33'!
pathtype
	^wire pathtype
	
	
! !

!GdsItemContext methodsFor: 'accessing' stamp: 'kf 10/27/2009 11:32'!
pathtype: anInteger
	wire pathtype  = anInteger ifTrue: [^self].
	wire pathtype: anInteger.
	self changed: #pathtype.
	"TODO: remove this change. Model not known GUI"
	self changed: #choosePathTypeLabel.	
	
	
! !

!GdsItemContext methodsFor: 'printing' stamp: 'kf 11/10/2008 14:15'!
printOn: aStream
	aStream nextPutAll: 'ITEM: '.
	aStream nextPutAll: itemNumber printString.! !

!GdsItemContext methodsFor: 'private' stamp: 'kf 11/10/2009 09:59'!
privateAngle: aDegree
	strans angle: aDegree.
	self changed: #angle.
	"TODO: remove this change. Model not known GUI"
	self changed: #requestAngleLabel.	
	! !

!GdsItemContext methodsFor: 'private' stamp: 'kf 11/10/2009 10:00'!
privateMag: aFloat
	strans mag: aFloat.
	self changed: #mag.
	"TODO: remove this change. Model not known GUI"
	self changed: #requestMagLabel.	
	! !

!GdsItemContext methodsFor: 'private' stamp: 'kf 11/10/2009 14:39'!
privateReflected: aBoolean
	strans setReflected: aBoolean.
	self changed: #reflected.
	self changed: #toggleReflectLabel.
	! !

!GdsItemContext methodsFor: 'private' stamp: 'kf 11/13/2008 10:14'!
privateUnget
	editElement ifNil: [self error: 'item is not holds element'].
	self colVertices ifEmpty: [ self error: 'empty vertices' ].
	self elementClass ifNil: [ self error: 'element type not set' ].
	self privateWipe.	
	editElement statusNumber: GdsElement inDatabaseStausNumber.
	editElement := nil.
! !

!GdsItemContext methodsFor: 'private' stamp: 'kf 10/27/2008 23:12'!
privateWipe
	colVertices := nil.
	! !

!GdsItemContext methodsFor: 'command' stamp: 'kf 5/12/2009 15:20'!
put
	self colVertices ifEmpty: [ self error: 'empty vertices' ].
	self elementClass ifNil: [ self error: 'element type not set' ].
	(self elementClass isReference)
		ifTrue: [ self putReference]
		ifFalse: [ self putPrimitive].! !

!GdsItemContext methodsFor: 'testing' stamp: 'kf 7/14/2009 14:53'!
putEnabled
	self elementClass ifNil: [^false].
	^(self vertexCount >= self elementClass requiredVertexCount)
! !

!GdsItemContext methodsFor: 'command' stamp: 'kf 10/30/2009 11:19'!
putEpilogue: newElement
	self privateWipe.
	editElement := nil.
	self changed.
	newElement ifNotNil: [self changed: #newElement].
	self changed: #put.
	self changedPutGetDpendent.
	! !

!GdsItemContext methodsFor: 'private' stamp: 'kf 11/12/2009 18:13'!
putGetDependentSelectors
	| col |
	col := OrderedCollection new.
	col add: #boundaryEnabled.
	col add: #pathEnabled.
	col add: #srefEnabled.
	col add: #arefEnabled.
	
	col add: #putEnabled.
	col add: #ungetEnabled.
	col add: #ceEnabled.
	col add: #getElementEnabled.
	col add: #confirmWipeEnabled.

	col add: #itemMoveEnabled.
	col add: #itemStretchEnabled.
	col add: #itemMovePointEnabled.
	col add: #itemDeleteVertexEnabled.
	col add: #itemReverseEnabled.
	
	col add: #chooseLayerEnabled.
	col add: #requestWidthEnabled.
	col add: #choosePathTypeEnabled.

	col add: #chooseStructureNameEnabled.
	col add: #requestAngleEnabled.
	col add: #requestMagEnabled.
	col add: #toggleReflectEnabled.
	col add: #requestArrayShapeEnabled.

	col add: #tstructEnabled.
	col add: #holdsElement.
	"dizitizing direction"
	col add: #vertfirstEnabled.
	col add: #horizfirstEnabled.
	col add: #octagonalEnabled.
	col add: #straightEnabled.
	col add: #orthintEnabled.
	^ col asArray! !

!GdsItemContext methodsFor: 'utility' stamp: 'kf 7/8/2009 09:42'!
putPathFrom: aPoint1 to: aPoint2
	self  path.
	self  ce: aPoint1.
	self  ce: aPoint2.
	self  put.! !

!GdsItemContext methodsFor: 'command' stamp: 'kf 5/15/2009 10:04'!
putPrimitive
	| targetElement newElement|
	newElement := editElement isNil.
	newElement
		ifTrue: [
			targetElement := self createElement.
			structure addElement: targetElement.]
		ifFalse: [
			targetElement := editElement.
			targetElement fromItemContext: self].
	targetElement statusNumber: GdsElement inDatabaseStausNumber.
	self putEpilogue: newElement.
! !

!GdsItemContext methodsFor: 'utility' stamp: 'kf 5/9/2009 14:34'!
putRectangle: aRectangle
	self  boundary.
	(GeometryUtils verticesFromBounds: aRectangle)
		do: [:each | self  ce: each].
	self  put.! !

!GdsItemContext methodsFor: 'command' stamp: 'kf 11/10/2009 13:14'!
putReference
	| targetElement newElement targetElements removeElements |
	newElement := false.
	removeElements := #().
	editElement
		ifNil: [newElement := true]
		ifNotNil: [
			elementType ~= editElement type
				ifTrue: [
					newElement := true.
					removeElements := Array with: editElement]].

	newElement
		ifTrue: [
			targetElements := self createElements.
			targetElements do: [:each |
				structure addElement: each.]]
		ifFalse: [
			targetElement := editElement.
			targetElement fromItemContext: self atIndex: 1.
			targetElements := Array with: targetElement].

	targetElements 
		do: [:each |
			each statusNumber: GdsElement inDatabaseStausNumber.].

	removeElements 
		do: [:each |
			each statusNumber: GdsElement inTrushStausNumber.].

	self putEpilogue: newElement
	! !

!GdsItemContext methodsFor: 'private' stamp: 'kf 11/6/2009 18:00'!
refreshBounds
	"dummy"! !

!GdsItemContext methodsFor: 'initialization' stamp: 'kf 11/6/2009 15:45'!
release
	ashape ifNotNil: 
		[ ashape removeDependent: self.
		ashape := nil ].
	super release! !

!GdsItemContext methodsFor: 'accessing-points' stamp: 'kf 7/14/2009 14:36'!
removeVertexAt: anIndex	
	| savedSize closed |
	savedSize := self colVertices size.
	savedSize = 0 ifTrue: [^self].
	closed := (savedSize >= 4) and: [self colVertices first = self colVertices last].
	colVertices removeAt: anIndex.
	(self isBoundary and: [closed])
		ifTrue: [
			anIndex = 1
				ifTrue: [colVertices removeLast].
			anIndex = savedSize
				ifTrue: [colVertices removeFirst].
			self closeVertex].
	self changed: #geometry.! !

!GdsItemContext methodsFor: 'develop-now' stamp: 'kf 7/15/2009 09:34'!
reverseVertices
	self vertexCount < 2 ifTrue: [^self].
	colVertices := colVertices reversed.
	self changed: #geometry.
	! !

!GdsItemContext methodsFor: 'private' stamp: 'kf 11/10/2009 14:16'!
safeReset
	structureName := ''.
	strans safeReset.
	
	
	! !

!GdsItemContext methodsFor: 'private' stamp: 'kf 11/10/2009 11:31'!
setReflected: aBoolean
	self privateReflected: aBoolean.
	! !

!GdsItemContext methodsFor: 'testing' stamp: 'kf 5/12/2009 11:43'!
snameSpecified
	^structureName isEmpty not.! !

!GdsItemContext methodsFor: 'command-elementKind' stamp: 'kf 5/12/2009 11:35'!
sref
	self elementType: #sref.
	! !

!GdsItemContext methodsFor: 'testing' stamp: 'kf 5/12/2009 11:40'!
srefActivated
	^elementType == #sref.! !

!GdsItemContext methodsFor: 'testing' stamp: 'kf 8/16/2009 17:54'!
srefEnabled
	structure ifNil: [ ^ false ].
	structure database ifNil: [ ^ false ].
	^ structure  referenceEnabledStructureNames isEmpty not! !

!GdsItemContext methodsFor: 'command-digitaizingMode' stamp: 'kf 10/21/2008 17:33'!
straight
	self digitaizingMode: #straight.
	! !

!GdsItemContext methodsFor: 'testing - dizitizing' stamp: 'kf 10/21/2008 17:53'!
straightActivated
	^digitaizingMode == #straight.
	! !

!GdsItemContext methodsFor: 'testing - dizitizing' stamp: 'kf 11/9/2009 16:28'!
straightEnabled
	^self isPrimitiveType 
	! !

!GdsItemContext methodsFor: 'private' stamp: 'kf 11/10/2009 14:16'!
structure: aGdsStructure
	self assert: [aGdsStructure isNil not].
	self safeReset.
	structure := aGdsStructure.
	self addDependent: structure.
	! !

!GdsItemContext methodsFor: 'accessing' stamp: 'kf 5/12/2009 15:27'!
structureName
	^structureName! !

!GdsItemContext methodsFor: 'accessing' stamp: 'kf 5/14/2009 23:14'!
structureName: aString
	structureName := aString.
	self changed: #sname.
	self changed: #srefEnabled.
	self changed: #ceEnabled.
	self changed: #chooseStructureNameLabel. "BAD BUT..."
! !

!GdsItemContext methodsFor: 'accessing' stamp: 'kf 5/7/2009 14:51'!
text
	text ifNil: [text := 'UNTITLED'].
	^text
	! !

!GdsItemContext methodsFor: 'accessing' stamp: 'kf 5/16/2009 10:55'!
text: aString
	text = aString ifTrue: [^self].
	text := aString.
	self changed: #text.
	! !

!GdsItemContext methodsFor: 'utility' stamp: 'kf 11/10/2009 14:36'!
toggleReflect
	self  setReflected: self  isReflected not.! !

!GdsItemContext methodsFor: 'command-points' stamp: 'kf 10/28/2008 23:51'!
translate: aPoint
	| col |
	aPoint class = Point
		ifFalse: [self error: 'ce: require Point instance.'].
	(self colVertices size <= 0)
		ifTrue: [self error: 'empty vertices'.].
	col := colVertices copy.
	col doWithIndex: [ :p :i |
		colVertices at: i put: p + aPoint.].
	self changed: #geometry.! !

!GdsItemContext methodsFor: 'command' stamp: 'kf 11/8/2008 21:48'!
unget
	self privateUnget.
	self changed.
	self changed: #unget.
	self changedPutGetDpendent.! !

!GdsItemContext methodsFor: 'testing' stamp: 'kf 11/8/2008 15:00'!
ungetEnabled
	^self holdsElement
! !

!GdsItemContext methodsFor: 'as yet unclassified' stamp: 'kf 11/12/2009 13:24'!
update: anObject
	(#(columnCount rowCount) includes: anObject)
		ifTrue: [^self changed: #requestArrayShapeLabel].
	super update: anObject.! !

!GdsItemContext methodsFor: 'accessing-points' stamp: 'kf 7/14/2009 14:52'!
vertexCount
	(self isBoundary and: [self vertices size > 1])
		ifTrue: [
			self vertices first = self vertices last
				ifTrue: [^self vertices size - 1]].
	^self vertices size! !

!GdsItemContext methodsFor: 'command-digitaizingMode' stamp: 'kf 10/21/2008 18:12'!
vertfirst
	self digitaizingDirection: #vertfirst.
! !

!GdsItemContext methodsFor: 'testing - dizitizing' stamp: 'kf 10/21/2008 17:55'!
vertfirstActivated
	^digitaizingDirection == #vertfirst.
! !

!GdsItemContext methodsFor: 'testing - dizitizing' stamp: 'kf 11/9/2009 16:28'!
vertfirstEnabled
	^self isPrimitiveType and: [digitaizingMode == #orthint].
! !

!GdsItemContext methodsFor: 'accessing-points' stamp: 'kf 9/20/2008 14:12'!
vertices
	^self colVertices asArray.! !

!GdsItemContext methodsFor: 'accessing-points' stamp: 'kf 7/14/2009 14:29'!
verticesAt: index put: aPoint
	self verticesAt:  index put: aPoint  fixClosed: self isBoundary.! !

!GdsItemContext methodsFor: 'accessing-points' stamp: 'kf 11/5/2008 16:55'!
verticesAt: index put: aPoint fixClosed: aBoolean.
	(aBoolean and: [index = 1 or: [colVertices size = index]])
		ifFalse: [colVertices at: index put: aPoint]
		ifTrue: [
			colVertices at: 1 put: aPoint.
			colVertices at: (colVertices size) put: aPoint].
	self changed: #geometry.! !

!GdsItemContext methodsFor: 'accessing-points' stamp: 'kf 5/6/2009 17:17'!
verticesBounds
	^GeometryUtils lookupDataBounds: self vertices.! !

!GdsItemContext methodsFor: 'accessing-points' stamp: 'kf 7/15/2009 11:09'!
verticesWithoutClosePoint
	self boundaryClosed
		ifTrue: [^self vertices allButLast].	
	^self vertices! !

!GdsItemContext methodsFor: 'accessing' stamp: 'kf 10/27/2009 11:32'!
width
	^wire width
	
	
! !

!GdsItemContext methodsFor: 'accessing' stamp: 'kf 10/27/2009 12:01'!
width: aFloat
	wire width  = aFloat ifTrue: [^self].
	wire width: aFloat.
	self changed: #width.
	"TODO: remove this change. Model not known GUI"
	self changed: #requestWidthLabel.	
! !

!GdsItemContext methodsFor: 'testing' stamp: 'kf 5/13/2009 11:14'!
widthEnabled
	self elementClass ifNil: [^false].
	^self elementClass hasWidth.! !

!GdsItemContext methodsFor: 'command' stamp: 'kf 11/8/2008 17:05'!
wipe
	self privateWipe.
	editElement 
		ifNotNil: [
			editElement wipe.
			structure removeElement: editElement.
			editElement := nil.].
	self changed.
	self changed: #wipe.
	self changedPutGetDpendent.
	! !

!GdsItemContext methodsFor: 'testing' stamp: 'kf 10/28/2008 22:17'!
wipeEnabled
	^self holdsElement
! !

Model subclass: #GdsItems
	instanceVariableNames: 'items structure zeroBasedIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsFeel-Model-EditSpace'!

!GdsItems commentStamp: 'kf 11/12/2008 11:49' prior: 0!
A GdsItems is collection of GdsItem.

activate only one of item from 0 to 9.

Instance Variables
	items:		<Array<GdsItemContext>>
	structure:		<GdsStructure>
	zeroBasedIndex:		<SmallInteger>

items
	- xxxxx

structure
	- xxxxx

zeroBasedIndex
	- xxxxx
!

!GdsItems methodsFor: 'accessing' stamp: 'kf 11/10/2008 11:45'!
atNumber: aZeroBasedItemIndex
	^items detect: [:each | each number = aZeroBasedItemIndex] ifNone:[]
	! !

!GdsItems methodsFor: 'actions' stamp: 'kf 11/10/2008 11:50'!
current
	^self atNumber: zeroBasedIndex
	! !

!GdsItems methodsFor: 'accessing' stamp: 'kf 11/10/2008 13:51'!
current: aZeroBasedIndex
	zeroBasedIndex := aZeroBasedIndex.
	self changed: #current.
	^self current.
	
	! !

!GdsItems methodsFor: 'private' stamp: 'kf 11/10/2008 14:39'!
forgetStructure
	items do: [ :each |  each forgetStructure].
	! !

!GdsItems methodsFor: 'initialization' stamp: 'kf 11/6/2009 13:56'!
initialize
	super initialize.
	items := OrderedCollection new.
	zeroBasedIndex := GdsCompatibility default itemNumberMin.
	GdsCompatibility default itemNumberRange  do: [:each | 
		| item |
		item := GdsItemContext newWithNumber: each.
		items add: item]
	! !

!GdsItems methodsFor: 'accessing' stamp: 'kf 11/10/2008 11:48'!
structure: aGdsStructure
	structure := aGdsStructure.
	items do: [ :each |  each structure: aGdsStructure].
	! !

Model subclass: #GdsLayers
	instanceVariableNames: 'layers colorMapForLayer numbers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsFeel-Model-Property'!

!GdsLayers methodsFor: 'objects from disk' stamp: 'kf 11/7/2009 22:47'!
asXmlElement
	| elmt |
	elmt := XMLElement named: 'layers'.
	self numbers do: [:num |
		elmt addElement: (self atNumber: num) asXmlElement.].
	^elmt! !

!GdsLayers methodsFor: 'accessing' stamp: 'kf 11/17/2009 20:35'!
atNumber: anInteger
	| newLayer create result |
	layers ifNil: [layers := Dictionary new.].
	create := false.
	result := layers 
		at: anInteger 
		ifAbsentPut: [
			newLayer := GdsLayer fromLayerNumber: anInteger.
			create := true.
			newLayer].
	create 
		ifTrue: [
			numbers := nil.
			self changed: #newLayer with: newLayer.].
	^result.! !

!GdsLayers methodsFor: 'deprecated' stamp: 'kf 10/27/2009 15:26'!
fillDefault
	GdsCompatibility default layerNumberRange do: [:number |
		self atNumber: number.].! !

!GdsLayers methodsFor: 'initialization' stamp: 'kf 10/27/2009 15:26'!
initialize
	super initialize.! !

!GdsLayers methodsFor: 'objects from disk' stamp: 'kf 11/8/2009 21:53'!
loadFromXmlDocument: aXMLDocument
	| topNode  layer layerNumber  |
	topNode := aXMLDocument firstTagNamed: #layers.
	topNode
		elementsDo: [ :node |
			layerNumber := (node attributes at: 'gdsno') asInteger.
			layer := self atNumber: layerNumber.
			layer loadFromXmlNode: node]
! !

!GdsLayers methodsFor: 'accessing' stamp: 'kf 11/17/2009 20:33'!
lookupNumbers
	layers ifNil: [^#()].
	^layers keys asSortedArray.! !

!GdsLayers methodsFor: 'accessing' stamp: 'kf 11/17/2009 20:34'!
numbers
	numbers ifNil: [numbers := self lookupNumbers].
	^numbers.! !

Model subclass: #GdsLibrary
	instanceVariableNames: 'structures nameMap station unitString libname databaseUnit archivePath meterUnit lastModified lastAccessed layers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsFeel-Model-Container'!

!GdsLibrary commentStamp: 'kf 10/21/2009 15:27' prior: 0!
A GdsLibrary is xxxxxxxxx.

Instance Variables
	nameMap:		<Dictionary<String,GdsStructure>>
	station:		<GdsStation>
	structures:		<Array<GdsStructure>>
	lastModified:	<DateAndTime>
	lastAccessed:  <DateAndTime>

nameMap
	- fast lookup structure instance by structure name.

station
	- reference to Application Model instance.

structures
	- holds structures instance 
!

!GdsLibrary class methodsFor: 'instance creation' stamp: 'kf 6/22/2009 14:58'!
all
	^self filePaths collect: [:each | self fromDbPath: each].! !

!GdsLibrary class methodsFor: 'accessing' stamp: 'kf 6/22/2009 16:27'!
archivedNames
	^((self fileDirectory) fileNamesMatching: self extensionBasicMatchExpr ) 
		reject: [:each | (each sameAs: 'Thumbs.db') 
			or: [(self isValidDbPath: (self fileDirectory fullNameFor: each)) not]]! !

!GdsLibrary class methodsFor: 'accessing' stamp: 'kf 6/12/2009 11:06'!
baseName: aString
	^((aString endsWith: self extension)
		ifTrue: [aString  allButLast: self extension size]
		ifFalse: [aString]) asUppercase! !

!GdsLibrary class methodsFor: 'accessing' stamp: 'kf 6/12/2009 11:33'!
baseNames
	^ self names collect: [:each | self baseName: each ].! !

!GdsLibrary class methodsFor: 'instance creation' stamp: 'kf 10/23/2008 17:26'!
betaInstance
	^self new loadBetaStructures! !

!GdsLibrary class methodsFor: 'check' stamp: 'kf 6/12/2009 13:11'!
checkDatabaseUnit: aNumber
	aNumber < 10 ifTrue: [^self error: 'DBU LEAST 10'].
	! !

!GdsLibrary class methodsFor: 'check' stamp: 'kf 6/22/2009 15:14'!
checkLibName: aString
	| libnameSizeRange checkName |
	checkName := self baseName: aString.
	GdsCompatibility default libNameMax > 0
		ifTrue: [
			libnameSizeRange := 1 to: GdsCompatibility default libNameMax.
			(libnameSizeRange includes: checkName size)
				ifFalse: [
					^self error: ('LIBRARYNAME SIZE UNDER {1} ' 
						format: {libnameSizeRange max})]].
	(GdsCompatibility default isValidLibraryName: checkName)
		ifFalse: [self error: 'LIBRARY NAME ERROR'].
	"(self exists: checkName)
		ifTrue: [
			^self error: ('LIBNAME ALREADY EXISTS: {1}' format: {checkName})]."! !

!GdsLibrary class methodsFor: 'check' stamp: 'kf 6/12/2009 10:10'!
checkUnitString: aString
	(self  unitStrings includes: aString asUppercase)
		ifFalse: [^self error: ('UNITS ONLY {1}' format: {self unitsString })].
	! !

!GdsLibrary class methodsFor: 'accessing' stamp: 'kf 6/16/2009 13:53'!
dbName: aString
	^((aString endsWith: self extension)
		ifTrue: [aString]
		ifFalse: [aString, self extension]) asUppercase! !

!GdsLibrary class methodsFor: 'as yet unclassified' stamp: 'kf 10/1/2008 22:27'!
exampleEmptyInstance
	| db struct |
	db := GdsLibrary new.
	struct := db newStructureNamed: 'MAIN'.
	^db! !

!GdsLibrary class methodsFor: 'as yet unclassified' stamp: 'kf 10/1/2008 22:27'!
exampleInstance
	| db struct |
	db := GdsLibrary new.
	struct := db newStructureNamed: 'MAIN'.
	struct fillExampleInstance .
	^db! !

!GdsLibrary class methodsFor: 'accessing' stamp: 'kf 6/12/2009 11:25'!
exists: aString
	| checkName |
	checkName := self baseName: aString.
	^self baseNames anySatisfy: [:each | each sameAs: checkName] ! !

!GdsLibrary class methodsFor: 'testing' stamp: 'kf 8/13/2009 15:09'!
existsBaseName: aBaseName
	^(self baseNames detect: [:each | each sameAs: aBaseName] ifNone: [nil]) isNil not.! !

!GdsLibrary class methodsFor: 'constants' stamp: 'kf 6/12/2009 10:40'!
extension
	^'.' , self extensionBody ! !

!GdsLibrary class methodsFor: 'constants' stamp: 'kf 6/12/2009 10:42'!
extensionBasicMatchExpr
	^'*', self extension.! !

!GdsLibrary class methodsFor: 'constants' stamp: 'kf 6/12/2009 10:39'!
extensionBody
	^'DB'! !

!GdsLibrary class methodsFor: 'instance creation' stamp: 'kf 10/22/2009 16:52'!
extract: aLibName
	| archivedSpaceFd zipPath archiver extractedFd |
	archivedSpaceFd := GdsFeel fileDirectory.
	zipPath := archivedSpaceFd fullNameFor: (self dbName: aLibName).
	self assert: [archivedSpaceFd fileExists: zipPath].
	(ZipArchive isZipArchive: zipPath)
		ifFalse: [^self error: ('DATABASE FORMAT ERROR {1}' format: {zipPath})].
	archiver := ZipArchive new.
	archiver readFrom: zipPath.
	self makeWorkDirectory: aLibName.
	extractedFd := GdsLibrary fileDirectoryForExtract: (self dbName: aLibName).
	archiver extractAllTo: extractedFd .
	archiver close.
	^extractedFd.
	
	! !

!GdsLibrary class methodsFor: 'accessing' stamp: 'kf 6/22/2009 14:46'!
extractedNames
	^((self fileDirectory) directoryNames 
		select: [:each | 
			(each endsWith: self extension)]) 
! !

!GdsLibrary class methodsFor: 'accessing' stamp: 'kf 6/22/2009 14:46'!
fileDirectory
	^GdsFeel fileDirectory! !

!GdsLibrary class methodsFor: 'as yet unclassified' stamp: 'kf 6/15/2009 20:57'!
fileDirectoryForExtract
	^self fileDirectoryForExtract: nil.
	! !

!GdsLibrary class methodsFor: 'as yet unclassified' stamp: 'kf 11/4/2009 13:56'!
fileDirectoryForExtract: aLocalName
	^self fileDirectorySubDirectoryNamed: '.editlibs' forExtract: aLocalName
	! !

!GdsLibrary class methodsFor: 'as yet unclassified' stamp: 'kf 6/22/2009 14:48'!
fileDirectoryForLocalName: aLocalName
	| fd |
	fd := self fileDirectory.
	fd assureExistence.
	^FileDirectory on: (fd fullPathFor: aLocalName).! !

!GdsLibrary class methodsFor: 'as yet unclassified' stamp: 'kf 11/4/2009 13:55'!
fileDirectorySubDirectoryNamed: aSubDirName forExtract: aLocalName
	| fd |
	fd := self fileDirectoryForLocalName: aSubDirName.
	fd assureExistence.
	^aLocalName 
		ifNil: [fd]
		ifNotNil: [FileDirectory on: (fd fullPathFor: aLocalName)].
	! !

!GdsLibrary class methodsFor: 'accessing' stamp: 'kf 6/22/2009 15:15'!
filePaths
	| fullPaths |
	fullPaths := (GdsLibrary fileDirectory fileNamesMatching: '*.DB')
		collect: [:each | 
			GdsLibrary fileDirectory fullNameFor: each].
	^fullPaths select: [:each | GdsLibrary isValidDbPath: each].! !

!GdsLibrary class methodsFor: 'instance creation' stamp: 'kf 6/22/2009 15:17'!
fromDbPath: aPathToDatabase
	^self new archivePath: aPathToDatabase.! !

!GdsLibrary class methodsFor: 'testing' stamp: 'kf 6/22/2009 14:37'!
hasMemberNamed: aZipMemberName archivePath: aPathToDatabase
	| members |
	members := self privateZipMembersOf: aPathToDatabase.
	members ifEmpty: [^false].
	^members includes: aZipMemberName! !

!GdsLibrary class methodsFor: 'instance creation' stamp: 'kf 6/16/2009 21:15'!
initializeName: aString databaseUnits: anInteger unitString: aUnitString 
	self checkLibName: aString.
	self checkDatabaseUnit: anInteger.
	self checkUnitString: aUnitString.
	^GdsLibrary new
		name: aString databaseUnit: anInteger unitString: aUnitString.
! !

!GdsLibrary class methodsFor: 'testing' stamp: 'kf 6/22/2009 14:49'!
isValidDbPath: aPathToDatabase
	| filePart directoryPart |
	filePart := FileDirectory localNameFor: aPathToDatabase.
	directoryPart := FileDirectory dirPathFor: aPathToDatabase.
	((FileDirectory on: directoryPart) fileExists: filePart)
		ifFalse: [^false].
	(directoryPart sameAs: GdsFeel pathToSelf)
		ifFalse: [
			"current impelments one directory "
			^false].
	[self checkLibName: filePart] on: Error do: [:ex | ^false].
	^self hasMemberNamed: self libInfoFileName archivePath: aPathToDatabase! !

!GdsLibrary class methodsFor: 'constants' stamp: 'kf 6/22/2009 14:47'!
libInfoFileName
	^'LIB.ini'! !

!GdsLibrary class methodsFor: 'private' stamp: 'kf 6/15/2009 13:51'!
libInfoFromIni: aIniStream
	| iniFile |
	iniFile := GdsIniFile readFrom: aIniStream.
	^(iniFile section: 'INITLIB')
	
	
	
	
	  ! !

!GdsLibrary class methodsFor: 'private' stamp: 'kf 6/15/2009 13:33'!
libInfoFromIniOrig: aIniStream
	| map |
	map := self libInfoMapFromIni: aIniStream.
	({ 'name' . 'dbu' . 'unit'}
		anySatisfy: [:each | (map includesKey: each) not])
		ifTrue: [^self error: 'LIBRARY INFO FORMAT ERROR'].
	({ 'name' . 'dbu' . 'unit'}
		anySatisfy: [:each | (map at: each ifAbsent: [nil]) isNil])
		ifTrue: [^self error: 'LIBRARY INFO FORMAT ERROR'].
	^map.
	
	
	
	
	  ! !

!GdsLibrary class methodsFor: 'private' stamp: 'kf 6/12/2009 17:15'!
libInfoMapFromIni: aIniStream
	| map line sepIndex key value |
	map := Dictionary new.
	[aIniStream atEnd]
		whileFalse: [
			line := aIniStream  upToAll: String crlf.
			sepIndex := line indexOf: $=.
			sepIndex > 0
				ifTrue: [
					key := line copyFrom: 1 to: sepIndex - 1.
					value := line copyFrom: sepIndex + 1 to: line size.
					map at: key put: value]].
	^map.	
	
	
	
	  ! !

!GdsLibrary class methodsFor: 'instance creation' stamp: 'kf 10/22/2009 16:52'!
makeWorkDirectory: aLibName
	(GdsLibrary fileDirectoryForExtract)
		createDirectory:  (self dbName: aLibName).
	
	! !

!GdsLibrary class methodsFor: 'accessing' stamp: 'kf 6/12/2009 10:36'!
names
	^ self archivedNames , self extractedNames! !

!GdsLibrary class methodsFor: 'instance creation' stamp: 'kf 6/16/2009 16:36'!
openNamed: aLibName
	| tLibName fullDbName fd stream map lib extractedFd |
	tLibName := self  baseName: aLibName.
	fullDbName := (tLibName, self  extension).
	fd := self  fileDirectoryForExtract.
	(fd directoryExists: fullDbName)
		ifTrue: [^self error: ('LIBRARY ALREADY OPEND {1}' format: {tLibName} )].  
	(self exists: fullDbName)
		ifFalse: [^self error: ('LIBRARY NOT FOUND {1}' format: {tLibName} )].  
		
	extractedFd := self extract: aLibName.
		
	stream := nil.	
	 [stream := extractedFd readOnlyFileNamed: 'LIB.ini'.
	 map := self libInfoFromIni: stream.]
		ensure: [stream ifNotNil: [stream close.]].
	lib := GdsLibrary new.
	[lib privateLibName: (map at: 'name'). 
	lib databaseUnit: (map at: 'dbu') asInteger.
	lib unitString: (map at: 'unit')] 
		on: Error
		do:  [:ex | 
			^self error: 'LIBRARY INFO FORMAT ERROR'].
	^lib
	! !

!GdsLibrary class methodsFor: 'testing' stamp: 'kf 6/22/2009 16:41'!
privateZipMembersOf: aPathToDatabase
	| zipArchive result |
	result := #().
	zipArchive := ZipArchive new.
	[zipArchive readFrom: aPathToDatabase.
	result := zipArchive memberNames]
		on: Error do: [: ex | ].
	zipArchive close.	
	^result.		! !

!GdsLibrary class methodsFor: 'instance creation' stamp: 'kf 6/23/2009 13:26'!
storagePathDbNamed: aLibName
	| tLibName fullDbName |
	tLibName := self  baseName: aLibName.
	fullDbName := (tLibName, self  extension).
	^self  fileDirectoryForExtract fullNameFor: fullDbName.
	! !

!GdsLibrary class methodsFor: 'accessing' stamp: 'kf 10/21/2009 14:19'!
unitSpec
	^{
		#('M' 1.0) . 
		#('CM' 1.0e-2) . 
		#('MM' 1.0e-3). 
		#('MICRON' 1.0e-6) . 
		#('INCH' 2.54e-2). 
		#('MIL' 2.54e-3) 
	}! !

!GdsLibrary class methodsFor: 'accessing' stamp: 'kf 10/21/2009 14:23'!
unitStrings
	^self unitSpec collect: [:each | each first].! !

!GdsLibrary class methodsFor: 'accessing' stamp: 'kf 6/12/2009 10:08'!
unitsString
	^(self unitStrings joinUsing: $, asString)! !

!GdsLibrary class methodsFor: 'maintenance' stamp: 'kf 6/17/2009 22:32'!
upgrade
	"GdsLibrary upgrade"
	(FileDirectory default directoryExists:  GdsFeel pathToBeta)
		ifFalse: [^self inform: 'Don''t need Upgrade'].
		
	Cursor wait 
		showWhile: [Smalltalk garbageCollect].
	GdsLibrary allInstances 
		ifNotEmpty: [
			^self inform: 'Can''t upgrade
GdsStationUI still opend.
close GdsStationUI morpc window and
waiting soon or restart Squeak Virtual Image'].
	Cursor wait showWhile: [
		GdsFeel rebuild.
		self upgradeBetaFolder].
		! !

!GdsLibrary class methodsFor: 'maintenance' stamp: 'kf 6/17/2009 14:21'!
upgradeBetaFolder
	| station |
	self assert: [(FileDirectory default directoryExists:  GdsFeel pathToBeta)].
	station := GdsStation new.
	station openBetaLibrary.
	station closeBetaLibrary.		! !

!GdsLibrary methodsFor: 'structure control' stamp: 'kf 10/22/2009 16:19'!
addStructure: aGdsStructure
	structures add: aGdsStructure.
	nameMap ifNil: [nameMap := Dictionary new.].
	nameMap at: aGdsStructure name put: aGdsStructure.
	aGdsStructure database: self.! !

!GdsLibrary methodsFor: 'private' stamp: 'kf 6/22/2009 14:00'!
archivePath: aPathToDatabase
	archivePath := aPathToDatabase.
	! !

!GdsLibrary methodsFor: 'utility' stamp: 'kf 11/24/2009 10:46'!
autoAllocateLayerColors
	| numbers layer colorStream |
	numbers := self lookupUsingLayerNumbers.
	colorStream := ReadStream on: (Color wheel: numbers size saturation: 0.7 brightness: 1.0).
	numbers do: [:each | 
		layer := self layers atNumber: each.
		layer color: colorStream next].
	
	
	! !

!GdsLibrary methodsFor: 'as yet unclassified' stamp: 'kf 11/8/2009 20:47'!
close
	self isOpen ifFalse: [^self].
	self saveLayers.
	self makeArchive.
	self deleteWorkFolder.
! !

!GdsLibrary methodsFor: 'accessing' stamp: 'kf 6/12/2009 15:39'!
databaseUnit
	^databaseUnit 
	! !

!GdsLibrary methodsFor: 'accessing' stamp: 'kf 6/12/2009 15:39'!
databaseUnit: aInteger
	databaseUnit := aInteger.
	! !

!GdsLibrary methodsFor: 'defaults' stamp: 'kf 6/12/2009 15:41'!
defaultDatabaseUnit
	^1000
	! !

!GdsLibrary methodsFor: 'defaults' stamp: 'kf 6/12/2009 15:40'!
defaultUnitString
	^'MICRON'
	! !

!GdsLibrary methodsFor: 'private' stamp: 'kf 6/17/2009 15:29'!
deleteFileDirectoryBlock: aBlock
	| extractedFd |
	extractedFd := aBlock value.
	(self class exists: self libNameWithExtension)
		ifFalse: [^self].
	extractedFd recursiveDelete.
	self assert: [extractedFd exists not].
! !

!GdsLibrary methodsFor: 'private' stamp: 'kf 6/17/2009 15:30'!
deleteWorkFolder
	self deleteFileDirectoryBlock: [self fileDirectoryForWork].
! !

!GdsLibrary methodsFor: 'testing' stamp: 'kf 6/22/2009 16:52'!
dirty
	^self structures anySatisfy: [:each | each dirty].! !

!GdsLibrary methodsFor: 'structure control' stamp: 'kf 6/16/2009 22:50'!
elementClass
	^GdsStructure
	! !

!GdsLibrary methodsFor: 'private' stamp: 'kf 6/17/2009 17:01'!
fileDirectoryForEdit
	| fd folderName |
	self assert: [self libName isNil not].
	fd := self class fileDirectoryForExtract .
	fd assureExistence.
	folderName := self libNameWithExtension.
	^FileDirectory on: (fd fullPathFor: folderName).
	! !

!GdsLibrary methodsFor: 'private' stamp: 'kf 6/17/2009 14:31'!
fileDirectoryForWork
	^self fileDirectoryForEdit.! !

!GdsLibrary methodsFor: 'testing' stamp: 'kf 6/8/2009 17:10'!
hasStructureName: aStructureName
	^(self structures select: [ :s | s name sameAs: aStructureName ]) isEmpty not.! !

!GdsLibrary methodsFor: 'initialization' stamp: 'kf 10/29/2009 10:16'!
initialize
	super initialize.
	structures := OrderedCollection new.
	unitString := nil.
	layers := GdsLayers new.
	
! !

!GdsLibrary methodsFor: 'testing' stamp: 'kf 6/22/2009 14:05'!
isOpen
	^self fileDirectoryForEdit exists.! !

!GdsLibrary methodsFor: 'testing' stamp: 'kf 6/16/2009 22:48'!
isTransient
	^ false! !

!GdsLibrary methodsFor: 'accessing' stamp: 'kf 10/21/2009 15:26'!
lastAccessed: aDateAndTime
	lastAccessed := aDateAndTime.
	! !

!GdsLibrary methodsFor: 'accessing' stamp: 'kf 10/21/2009 15:26'!
lastModified: aDateAndTime
	lastModified := aDateAndTime.
	! !

!GdsLibrary methodsFor: 'accessing' stamp: 'kf 11/8/2009 21:14'!
layers
	layers ifNil: [layers := GdsLayers new].
	^layers! !

!GdsLibrary methodsFor: 'private' stamp: 'kf 6/15/2009 13:43'!
libInfoAsIniOn: aIniStream 
	| iniFile |
	iniFile := GdsIniFile  new.
	iniFile 
		section: 'INITLIB'
		at: 'name'
		put: self libName.
	iniFile 
		section: 'INITLIB'
		at: 'dbu'
		put: self databaseUnit asString.
	iniFile 
		section: 'INITLIB'
		at: 'unit'
		put: self unitString.
	iniFile writeOn: aIniStream.! !

!GdsLibrary methodsFor: 'accessing' stamp: 'kf 6/22/2009 15:46'!
libName
	libname ifNotNil:  [^libname].
	archivePath 
		ifNotNil: [
			^self class baseName: (FileDirectory localNameFor: archivePath)].
	^libname
	! !

!GdsLibrary methodsFor: 'accessing' stamp: 'kf 6/17/2009 15:29'!
libName: aString
	libname ifNotNil: [^self error: 'LIBRARY NAME ASSIGNED ONCE'].
	GdsLibrary checkLibName: aString.
	libname := self class baseName: aString.! !

!GdsLibrary methodsFor: 'accessing' stamp: 'kf 6/12/2009 16:13'!
libNameWithExtension
	^self libName, self class extension.
	! !

!GdsLibrary methodsFor: 'objects from disk' stamp: 'kf 11/8/2009 21:18'!
loadLayers
	| pathToXml |
	pathToXml := self fileDirectoryForEdit fullNameFor: self localNameForLayers .
	(FileDirectory default fileExists: pathToXml)
		ifFalse: [^self].
	GdsFeel 
		xmlDocumentFromPath: pathToXml 
		documentBlock: [:xmlDocument |
			self layers loadFromXmlDocument: xmlDocument]! !

!GdsLibrary methodsFor: 'objects from disk' stamp: 'kf 6/23/2009 10:46'!
loadLibInfo
	| stream map |
	stream := nil.	
	 [stream := self fileDirectoryForEdit readOnlyFileNamed: 'LIB.ini'.
	 map := self class libInfoFromIni: stream.]
		ensure: [stream ifNotNil: [stream close.]].
	[self privateLibName: (map at: 'name'). 
	self databaseUnit: (map at: 'dbu') asInteger.
	self unitString: (map at: 'unit')] 
		on: Error
		do:  [:ex | 
			^self error: 'LIBRARY INFO FORMAT ERROR'].

	! !

!GdsLibrary methodsFor: 'objects from disk' stamp: 'kf 6/18/2009 15:16'!
loadStructures
	| fd |
	fd := self fileDirectoryForEdit.
	fd assureExistence.
	Cursor wait showWhile: [self loadStructures: fd].! !

!GdsLibrary methodsFor: 'objects from disk' stamp: 'kf 10/28/2009 11:34'!
loadStructures: aFileDirectory 
	| names |
	names := aFileDirectory directoryNames select: [:each | each endsWith: '.structure'].
	names := names 
				select: [:name | GdsCompatibility default isValidStructureName: (FileDirectory baseNameFor: name)].
	names do: 
			[:each | 
			| name structure |
			name := FileDirectory baseNameFor: each.
			name := (name findTokens: '.') first. 
			structure := self newStructureNamed: name.
			[structure load] on: Error
				do: 
					[:ex | 
					Transcript
						cr;
						show: (String streamContents: 
										[:s | 
										s nextPutAll: '***ERROR***'.
										s nextPutAll: ' '.
										s nextPutAll: 'skip broken structure: '.
										s nextPutAll: name]).
					self removeStructure: structure]]! !

!GdsLibrary methodsFor: 'objects from disk' stamp: 'kf 11/8/2009 21:09'!
localNameForLayers
	^'layers.xml'.
! !

!GdsLibrary methodsFor: 'private' stamp: 'kf 11/18/2009 17:04'!
lookupUsingLayerNumbers
	^(Array streamContents: [:s |
		self structures do: [:struc |
			s nextPutAll: struc lookupUsingLayerNumbers]
		]) asSet asSortedArray.! !

!GdsLibrary methodsFor: 'private' stamp: 'kf 6/18/2009 15:04'!
makeArchive
	| archive |
	(FileDirectory default fileExists: self zipedPath)
		ifTrue: [FileDirectory deleteFilePath: self zipedPath  ].
	archive := ZipArchive new.
	archive addTree: self fileDirectoryForEdit removingFirstCharacters: self fileDirectoryForEdit pathName size + 1.
	[ archive writeToFileNamed: self zipedPath ] on: Error do: [ :ex | self inform: ex description. ].
	archive close.	! !

!GdsLibrary methodsFor: 'private' stamp: 'kf 11/8/2009 20:39'!
makeFolder
	| newFd stream |
	newFd := self fileDirectoryForEdit.
	newFd assureExistence.
		
	stream := nil.	
	[stream := newFd newFileNamed: self class libInfoFileName.
	self libInfoAsIniOn: stream] 
			ensure: [stream ifNotNil: [stream close]]! !

!GdsLibrary methodsFor: 'accessing' stamp: 'kf 10/21/2009 14:02'!
meterUnit
	^meterUnit
	! !

!GdsLibrary methodsFor: 'accessing' stamp: 'kf 10/21/2009 14:02'!
meterUnit: aFloat
	meterUnit := aFloat.
	! !

!GdsLibrary methodsFor: 'initialization' stamp: 'kf 6/17/2009 14:50'!
name: aLibName databaseUnit: aInteger unitString: aUnitString
	self privateName: aLibName databaseUnit:  aInteger unitString: aUnitString.
	self makeArchive.
	self deleteWorkFolder.
	! !

!GdsLibrary methodsFor: 'structure control' stamp: 'kf 6/16/2009 22:51'!
newStructureNamed: aStructureName
	| s |
	(self hasStructureName: aStructureName)
		ifTrue: [self error: 'structure name: ', aStructureName printString, 'already exists'].
	s := self elementClass new setName: aStructureName database: self.
	self addStructure: s.
	^s.
	! !

!GdsLibrary methodsFor: 'objects from disk' stamp: 'kf 11/8/2009 20:49'!
open
	self isOpen ifTrue: [^self].
	self class extract: self libName.
	self loadLibInfo.
	self loadLayers.
	self loadStructures.
	! !

!GdsLibrary methodsFor: 'printing' stamp: 'kf 6/12/2009 16:07'!
printOn: aStream
	super printOn: aStream.
	aStream nextPut: $(.
	aStream nextPutAll: self libName.	
	aStream nextPut: $).
	! !

!GdsLibrary methodsFor: 'accessing' stamp: 'kf 6/13/2009 14:15'!
privateLibName: aString
	libname := self class baseName: aString.! !

!GdsLibrary methodsFor: 'initialization' stamp: 'kf 6/17/2009 14:49'!
privateName: aLibName databaseUnit: aInteger unitString: aUnitString
	self libName: aLibName.
	self databaseUnit: aInteger.
	self unitString: aUnitString.
	self makeFolder.
	! !

!GdsLibrary methodsFor: 'initialization' stamp: 'kf 10/31/2009 20:39'!
release
	structures ifNotNil: [structures do: [:each | each release]].
	structures := nil.
	nameMap := nil.
	station := nil.
	super release.! !

!GdsLibrary methodsFor: 'structure control' stamp: 'kf 11/6/2008 12:21'!
removeStructure: aGdsStructure
	structures remove: aGdsStructure.
	nameMap ifNotNil: [nameMap removeKey: aGdsStructure name ifAbsent: [].].
	! !

!GdsLibrary methodsFor: 'objects from disk' stamp: 'kf 11/8/2009 21:10'!
saveLayers
	GdsFeel 
		fileOutXmlTopElement: self layers asXmlElement 
		fileDirectory: self fileDirectoryForEdit  localName: self localNameForLayers.
! !

!GdsLibrary methodsFor: 'accessing' stamp: 'kf 11/10/2008 13:50'!
station
	^station! !

!GdsLibrary methodsFor: 'accessing' stamp: 'kf 11/10/2008 13:46'!
station: aGdsStation
	station := aGdsStation.! !

!GdsLibrary methodsFor: 'structure control' stamp: 'kf 10/20/2008 20:48'!
structureNamed: aString
	^self structures detect: [:each | each name sameAs: aString ] ifNone:[].! !

!GdsLibrary methodsFor: 'structure control' stamp: 'kf 10/20/2008 20:46'!
structureNames
	^self structures collect: [:each | each name].! !

!GdsLibrary methodsFor: 'accessing' stamp: 'kf 5/12/2009 14:14'!
structureNamesForReference
	self assert: self structure isNil not.
	^(self structureNames reject: [:name | self structure name sameAs: name]) asArray.
! !

!GdsLibrary methodsFor: 'accessing' stamp: 'kf 9/19/2008 18:34'!
structures
	^structures asArray.! !

!GdsLibrary methodsFor: 'accessing' stamp: 'kf 6/12/2009 16:24'!
unitString
	^unitString! !

!GdsLibrary methodsFor: 'accessing' stamp: 'kf 6/12/2009 12:32'!
unitString: aString
	self class checkUnitString: aString.
	unitString := aString asUppercase.! !

!GdsLibrary methodsFor: 'accessing' stamp: 'kf 10/21/2009 14:01'!
userUnit
	^self databaseUnit reciprocal asFloat.! !

!GdsLibrary methodsFor: 'accessing' stamp: 'kf 10/21/2009 14:01'!
userUnit: aFloat
	self databaseUnit: aFloat reciprocal asInteger.! !

!GdsLibrary methodsFor: 'private' stamp: 'kf 6/16/2009 14:38'!
zipedPath
	| savePathFd |
	savePathFd := self class fileDirectoryForLocalName: self libNameWithExtension .
	^savePathFd pathName.! !

GdsLibrary subclass: #GdsTransientBetaLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsFeel-Model-Container'!

!GdsTransientBetaLibrary class methodsFor: 'as yet unclassified' stamp: 'kf 6/17/2009 22:38'!
fileDirectoryForBeta
	^FileDirectory on: (GdsFeel pathToBeta).
	! !

!GdsTransientBetaLibrary class methodsFor: 'as yet unclassified' stamp: 'kf 6/17/2009 22:42'!
hasBetaFolder
	^self fileDirectoryForBeta exists.
	! !

!GdsTransientBetaLibrary methodsFor: 'maintenance' stamp: 'kf 6/17/2009 15:30'!
closeWithUpdate
	self name: 'BETA' databaseUnit: 1000 unitString: 'MICRON'.	
	self structures do: [:each | each fileOutAsXmlNew ].
	super close.
	self deleteFileDirectoryBlock: [self fileDirectoryForEdit].

! !

!GdsTransientBetaLibrary methodsFor: 'as yet unclassified' stamp: 'kf 6/16/2009 22:51'!
elementClass
	^GdsTransientBetaStructure
	! !

!GdsTransientBetaLibrary methodsFor: 'as yet unclassified' stamp: 'kf 6/17/2009 22:39'!
fileDirectoryForWork
	^self class fileDirectoryForBeta! !

!GdsTransientBetaLibrary methodsFor: 'as yet unclassified' stamp: 'kf 6/16/2009 22:48'!
isTransient
	^ true! !

!GdsTransientBetaLibrary methodsFor: 'as yet unclassified' stamp: 'kf 6/22/2009 15:46'!
libName
	^'BETA'! !

!GdsTransientBetaLibrary methodsFor: 'objects from disk' stamp: 'kf 6/17/2009 22:39'!
loadStructures
	| fd |
	fd := self class fileDirectoryForBeta.
	fd assureExistence.
	self loadStructures: fd! !

!GdsTransientBetaLibrary methodsFor: 'objects from disk' stamp: 'kf 6/16/2009 22:46'!
loadStructures: aFileDirectory 
	| names |
	names := aFileDirectory fileNamesMatching: '*.gdsfeelbeta'.
	names := names 
				select: [:name | GdsCompatibility default isValidStructureName: (FileDirectory baseNameFor: name)].
	names do: 
			[:each | 
			| name structure |
			name := FileDirectory baseNameFor: each.
			structure := self newStructureNamed: name.
			[structure loadBetaFromPath: (aFileDirectory fullPathFor: each)] on: Error
				do: 
					[:ex | 
					Transcript
						cr;
						show: (String streamContents: 
										[:s | 
										s nextPutAll: '***ERROR***'.
										s nextPutAll: ' '.
										s nextPutAll: 'skip broken structure: '.
										s nextPutAll: name]).
					self removeStructure: structure]]! !

!GdsTransientBetaLibrary methodsFor: 'as yet unclassified' stamp: 'kf 6/17/2009 15:19'!
name: aLibName databaseUnit: aInteger unitString: aUnitString
	self privateName: aLibName databaseUnit:  aInteger unitString: aUnitString.
! !

Model subclass: #GdsState
	instanceVariableNames: 'selectable visible'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsFeel-Model-Property'!

GdsState subclass: #GdsLayer
	instanceVariableNames: 'no color colElements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsFeel-Model-Property'!

!GdsLayer class methodsFor: 'as yet unclassified' stamp: 'kf 5/10/2009 23:09'!
fromLayerNumber: anInteger
	^self new setLayerNumber: anInteger.! !

!GdsLayer methodsFor: 'accessing' stamp: 'kf 10/30/2009 14:48'!
addElement: aGdsElement
	colElements ifNil: [colElements := OrderedCollection new].
	(colElements includes: aGdsElement)
		ifFalse: [colElements add: aGdsElement].! !

!GdsLayer methodsFor: 'objects from disk' stamp: 'kf 11/7/2009 22:39'!
asXmlElement
	| elmt attrDict colorElmt |
	attrDict := Dictionary new.
	self attributesOn: attrDict.
	elmt := XMLElement named: 'layer' attributes: attrDict.
	attrDict := Dictionary new.
	GdsColorUtils rgbaAttributesOn: attrDict color: self color. 
	colorElmt := XMLElement named: 'color' attributes: attrDict.
	elmt addElement: colorElmt. 
	^elmt.
! !

!GdsLayer methodsFor: 'objects from disk' stamp: 'kf 11/11/2009 09:41'!
attributesFrom: aDictionary
	super attributesFrom: aDictionary.
	self setLayerNumber: (aDictionary at: 'gdsno') asInteger.	
! !

!GdsLayer methodsFor: 'objects from disk' stamp: 'kf 11/11/2009 09:42'!
attributesOn: aDictionary
	super attributesOn: aDictionary.
	aDictionary at: 'gdsno' put: self layerNumber asString.	
! !

!GdsLayer methodsFor: 'accessing' stamp: 'kf 11/8/2009 21:35'!
color
	color ifNil: [color := Color white].
	^color
	! !

!GdsLayer methodsFor: 'accessing' stamp: 'kf 10/29/2009 10:29'!
color: aColor
	color := aColor.
	! !

!GdsLayer methodsFor: 'accessing' stamp: 'kf 5/11/2009 13:23'!
colorLetter
	
! !

!GdsLayer methodsFor: 'accessing' stamp: 'kf 5/11/2009 13:21'!
fill
	
	! !

!GdsLayer methodsFor: 'accessing' stamp: 'kf 5/11/2009 13:21'!
fillLetter
	^self fill name.! !

!GdsLayer methodsFor: 'initialize-release' stamp: 'kf 10/27/2009 15:23'!
initialize
	super initialize.
	self setSelectable: true.
	self setVisible: true.
	! !

!GdsLayer methodsFor: 'accessing' stamp: 'kf 10/27/2009 16:27'!
layerNumber
	^no.
	! !

!GdsLayer methodsFor: 'objects from disk' stamp: 'kf 11/8/2009 22:22'!
loadFromXmlNode: aXMLNode
	self attributesFrom: aXMLNode attributes.
	aXMLNode
		elementsDo: [:colorNode |
			self color: (GdsColorUtils  fromAttributes:  colorNode attributes)].
		
	! !

!GdsLayer methodsFor: 'accessing' stamp: 'kf 5/10/2009 23:10'!
number
	^no.
	! !

!GdsLayer methodsFor: 'printing' stamp: 'kf 5/10/2009 23:11'!
printOn: aStream
	super printOn: aStream.
	aStream nextPut: $(.
	aStream nextPutAll: self number printString.
	aStream nextPut: $).
	! !

!GdsLayer methodsFor: 'private' stamp: 'kf 5/10/2009 23:08'!
setLayerNumber: aInteger.
	no := aInteger.
	! !

!GdsLayer methodsFor: 'accessing' stamp: 'kf 5/11/2009 13:22'!
style
! !

!GdsLayer methodsFor: 'accessing' stamp: 'kf 5/11/2009 13:23'!
styleLetter
	
! !

!GdsState methodsFor: 'objects from disk' stamp: 'kf 11/11/2009 09:41'!
attributesFrom: aDictionary
	self setSelectable: (aDictionary at: 'selectable' ifAbsent: ['true']) = 'true'.  
	self setVisible: (aDictionary at: 'visible' ifAbsent: ['true']) = 'true'.  ! !

!GdsState methodsFor: 'objects from disk' stamp: 'kf 11/11/2009 09:43'!
attributesOn: aDictionary
	self isSelectable
		ifFalse: [
			aDictionary at: 'selectable' put: self isSelectable asString].
	self isVisible 
		ifFalse: [	
			aDictionary at: 'visible' put: self isVisible asString].! !

!GdsState methodsFor: 'testing' stamp: 'kf 10/27/2009 15:53'!
isSelectable
	^selectable
	! !

!GdsState methodsFor: 'testing' stamp: 'kf 10/27/2009 15:53'!
isVisible
	^visible
	! !

!GdsState methodsFor: 'testing' stamp: 'kf 10/27/2009 15:12'!
setSelectable: aBoolean
	selectable :=  aBoolean.
	
	! !

!GdsState methodsFor: 'testing' stamp: 'kf 10/27/2009 15:12'!
setVisible: aBoolean
	visible := aBoolean.
	
	! !

!GdsState methodsFor: 'accessing' stamp: 'kf 5/11/2009 13:36'!
stateLetter
	(self isVisible and: [self isSelectable]) ifTrue: [^$@].
	(self isVisible) ifTrue: [^$O].	
	(self isSelectable) ifTrue: [^$+].
	^$-.
			! !

Model subclass: #GdsStation
	instanceVariableNames: 'library structure items idContext'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsFeel-Model-Container'!

!GdsStation commentStamp: 'kf 11/12/2008 11:40' prior: 0!
A GdsStation is xxxxxxxxx.

Instance Variables
	items:		<GdsItems>
	library:		<GdsLibrary>
	structure:		<GdsStructure>

items
	- xxxxx

library
	- xxxxx

structure
	- xxxxx
!

!GdsStation class methodsFor: 'instance creation' stamp: 'kf 6/15/2009 18:01'!
openDefault
	^self new openDefault.! !

!GdsStation methodsFor: 'command-handler' stamp: 'kf 10/22/2008 14:20'!
assertNilDependent
	self assert: [(self dependents includes: nil) not].
	! !

!GdsStation methodsFor: 'command-handler' stamp: 'kf 6/18/2009 10:38'!
bstructEnabled
	library ifNil: [^false].
	structure ifNotNil: [^false].
	^true.
! !

!GdsStation methodsFor: 'command-handler' stamp: 'kf 5/3/2009 17:20'!
bstructName: aBlockOrString
	self newStructureNamed: aBlockOrString.
	^self.
	
! !

!GdsStation methodsFor: 'action' stamp: 'kf 6/18/2009 11:27'!
closeBetaLibrary
	library ifNil: [^self].
	library closeWithUpdate.
	self library: nil.! !

!GdsStation methodsFor: 'testing' stamp: 'kf 6/22/2009 17:12'!
closeEnabled
	structure ifNil: [^true].
	^structure closeEnabled! !

!GdsStation methodsFor: 'action' stamp: 'kf 6/18/2009 15:25'!
closeLibrary
	library ifNil: [^self].
	library close.
	self library: nil.! !

!GdsStation methodsFor: 'action' stamp: 'kf 11/4/2009 16:22'!
closeStructure
	"self assertNilDependent."
	structure ifNil: [^self error: 'structure already closed.'].
	structure closeWithSave.
	self structure: nil.
	! !

!GdsStation methodsFor: 'accessing' stamp: 'kf 11/12/2008 13:58'!
idSelection
	^idContext
! !

!GdsStation methodsFor: 'initialization' stamp: 'kf 11/12/2008 13:43'!
initialize
	super initialize.
	items := GdsItems new.
	idContext := GdsIdContext new.
	
	! !

!GdsStation methodsFor: 'command-handler' stamp: 'kf 10/8/2009 10:02'!
initlibNamed: name databaseUnits: dbu unitString: unit
	| lib |
	lib := GdsLibrary initializeName: name databaseUnits: dbu unitString: unit.
	lib ifNotNil: [self changed: #openlibEnabled].
	^lib! !

!GdsStation methodsFor: 'command-handler' stamp: 'kf 10/8/2009 09:59'!
initlibNamed: name unitString: unit
	^self initlibNamed: name databaseUnits: 1000 unitString: unit 
! !

!GdsStation methodsFor: 'accessing' stamp: 'kf 11/10/2008 13:51'!
items
	^items
! !

!GdsStation methodsFor: 'accessing' stamp: 'kf 6/22/2009 16:55'!
labelString
	^String streamContents: [:s |
		s nextPutAll: 'GdsFeel: '.
		self library 
			ifNotNil: [self library dirty ifTrue: [s nextPutAll: '* ']].
		s nextPutAll: self labelStringAfter].
! !

!GdsStation methodsFor: 'accessing' stamp: 'kf 6/22/2009 16:49'!
labelStringAfter
	library ifNil: [^'NO LIBRARY OPEN'].
	structure ifNil: [^'[{1}].NO STRUCTURE OPEN' format: {library libName}].
	^'[{1}].[{2}]' format: {library libName . structure name}.! !

!GdsStation methodsFor: 'accessing' stamp: 'kf 10/23/2008 15:52'!
library
	^library.! !

!GdsStation methodsFor: 'accessing' stamp: 'kf 6/18/2009 15:22'!
library: aGdsLibrary
	library ifNotNil: [library removeDependent: self].
	library := aGdsLibrary.
	aGdsLibrary
		ifNil: []
		ifNotNil: [
			library addDependent: self.
			self structure: nil.].
	self libraryChanged.	
	self structureChanged.! !

!GdsStation methodsFor: 'updating' stamp: 'kf 10/8/2009 10:00'!
libraryChanged
	self changed: #library.
	self changed: #openlibEnabled.
	self changed: #closelibEnabled.
! !

!GdsStation methodsFor: 'ui-basics' stamp: 'kf 10/12/2008 23:16'!
modelCommandSelector: aSelector
	^self modelCommandNamed: aSelector asString asUppercase selector: aSelector.! !

!GdsStation methodsFor: 'accessing' stamp: 'kf 5/3/2009 17:19'!
newStructureNamed: aBlockOrString
	| name newStructure |
	self assertNilDependent.
	library ifNil: [^self error: 'no library open.'].
	structure ifNotNil: [^self error: 'structure already opend.'].
	name := aBlockOrString value.
	name ifNil: [^self].
	newStructure := library newStructureNamed: name.
	self structure: newStructure.
	^newStructure
! !

!GdsStation methodsFor: 'maintenance' stamp: 'kf 6/18/2009 11:28'!
openBetaLibrary
	self library: (GdsTransientBetaLibrary new).
	library station: self.
	library loadStructures.
	! !

!GdsStation methodsFor: 'action' stamp: 'kf 6/17/2009 22:49'!
openDefault
	"self openBetaLibrary"! !

!GdsStation methodsFor: 'action' stamp: 'kf 6/23/2009 13:28'!
openLibraryNamed: aLibName
	| lib |
	lib := GdsLibrary fromDbPath: (
		 GdsLibrary storagePathDbNamed: aLibName).
	self library: lib.
	library station: self.
	library open.
	self structure: nil.
	! !

!GdsStation methodsFor: 'command-handler' stamp: 'kf 11/4/2009 16:10'!
openStructureNamed: aStructureName 
	self openStructureNamed: aStructureName ifAbsentCreate: false! !

!GdsStation methodsFor: 'command-handler' stamp: 'kf 6/15/2009 17:34'!
openStructureNamed: aStructureName ifAbsentCreate: aDoCreate
	| struc |
	struc := self library structureNamed: aStructureName. 
	(struc isNil and: [aDoCreate]) 
		ifTrue:  [self bstructName: aStructureName]
		ifFalse: [self ostructNames: [:names | aStructureName]].
	^self structure.
	! !

!GdsStation methodsFor: 'command-handler' stamp: 'kf 6/18/2009 11:19'!
openlibNames: aNamesArgBlock sortBlock: sortBlock
	"aNamesArgBlock must be return library name"
	| name names |
	self assertNilDependent.
	library ifNotNil: [^self error: 'library already opend.'].
	structure ifNotNil: [^self error: 'structure already opend.'].
	names := (GdsLibrary baseNames asArray sort: sortBlock) collect: [:each | each ].	
	name := aNamesArgBlock value: names.	
	name ifNil: [^self].
	self openLibraryNamed:  name.
! !

!GdsStation methodsFor: 'command-handler' stamp: 'kf 6/8/2009 17:12'!
ostructEnabled
	library ifNil: [^false].
	structure ifNotNil: [^false].
	^library structures isEmpty not.
! !

!GdsStation methodsFor: 'command-handler' stamp: 'kf 10/28/2008 14:53'!
ostructNames: aNamesArgBlock
	^self ostructNames: aNamesArgBlock  sortBlock: [:a :b | a  name <= b name]. 
! !

!GdsStation methodsFor: 'command-handler' stamp: 'kf 11/4/2009 17:51'!
ostructNames: aNamesArgBlock sortBlock: sortBlock
	"aNamesArgBlock must be return structure name"
	| name names |
	"self assertNilDependent."
	library ifNil: [^self error: 'no library open.'].
	structure ifNotNil: [^self error: 'structure already opend.'].
	names := (library structures sort: sortBlock) collect: [:each | each name].	
	name := aNamesArgBlock value: names.	
	name ifNil: [^self].
	self structure: (library structureNamed: name).
! !

!GdsStation methodsFor: 'initialization' stamp: 'kf 10/31/2009 20:40'!
release
	items release.
	items := nil.
	idContext release.
	idContext := nil.	
	super release.
	
	! !

!GdsStation methodsFor: 'accessing' stamp: 'kf 10/20/2008 16:34'!
structure
	^structure! !

!GdsStation methodsFor: 'accessing' stamp: 'kf 11/13/2009 21:03'!
structure: aGdsStructure
	self structureWillChange.
	structure := aGdsStructure.
	aGdsStructure
		ifNil: [
			self structureDidUnBind]
		ifNotNil: [
			self structureDidBind.].
	"self assert: [self dependents size >= 2]."
	self structureChanged.
	self libraryChanged.	
	! !

!GdsStation methodsFor: 'updating' stamp: 'kf 10/26/2008 22:05'!
structureChanged
	self changed: #relabel.
	self changed: #structure.		
	self changed: #ostructEnabled.
	self changed: #bstructEnabled.
	self changed: #tstructEnabled.		! !

!GdsStation methodsFor: 'accessing' stamp: 'kf 11/13/2009 21:05'!
structureDidBind
	self assert: [structure notNil].
	structure addDependent: self.
	items structure: structure.
	idContext structure: structure.
	items current addDependent: self.
	! !

!GdsStation methodsFor: 'accessing' stamp: 'kf 11/13/2009 21:01'!
structureDidUnBind
	items forgetStructure.
	idContext forgetStructure	! !

!GdsStation methodsFor: 'accessing' stamp: 'kf 11/13/2009 21:05'!
structureWillChange
	structure ifNotNil: [structure removeDependent: self].
	items ifNotNil: [items current removeDependent: self].
! !

!GdsStation methodsFor: 'command-handler' stamp: 'kf 5/16/2009 11:15'!
tstruct
	Cursor wait showWhile: [self closeStructure].
	
	! !

!GdsStation methodsFor: 'command-handler' stamp: 'kf 6/22/2009 17:11'!
tstructEnabled	
	structure ifNil: [^false].
	^structure closeEnabled.

	
	! !

!GdsStation methodsFor: 'updating' stamp: 'kf 11/13/2009 21:07'!
update: aParameter
	aParameter == #tstructEnabled
		ifTrue: [
			self changed: #tstructEnabled.
			self changed: #closelibEnabled].
	aParameter == #elementType
		ifTrue: [self changed: #elementType].
	super update: aParameter.! !

Model subclass: #GdsStructure
	instanceVariableNames: 'database name colElements dataExtentForElements timeModified timeCreated savedName storagePath dirtyReservedArea dirtyElements maxKeyNumber layers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsFeel-Model-Container'!

!GdsStructure commentStamp: 'kf 11/12/2008 11:57' prior: 0!
A GdsStructure is holdes collection of GdsElement.

element member of GdsLibrary.

Instance Variables
	colElements:		<Array<GdsElement>>
	dataExtentForElements:		<Rectangle<Float>>>
	database:		<GdsLibrary>
	dirtyElements:		<Array<GdsElement>>
	dirtyReservedArea:		<Array<GdsElement>>
	maxKeyNumber:		<Integer>
	name:		<String>
	savedName:		<String>
	storagePath:		<String>
	timeCreated:		<DateAndTime>
	timeModified:		<DateAndTime>

colElements
	- xxxxx

dataExtentForElements
	- xxxxx

database
	- xxxxx

dirtyElements
	- xxxxx

dirtyReservedArea
	- xxxxx

maxKeyNumber
	- xxxxx

name
	- xxxxx

savedName
	- xxxxx

storagePath
	- xxxxx

timeCreated
	- xxxxx

timeModified
	- xxxxx
!

!GdsStructure class methodsFor: 'as yet unclassified' stamp: 'kf 11/12/2008 09:12'!
keyNumberForInStructure
	^1! !

!GdsStructure class methodsFor: 'as yet unclassified' stamp: 'kf 9/19/2008 18:23'!
named: aStructureName
	! !

!GdsStructure class methodsFor: 'as yet unclassified' stamp: 'kf 11/12/2008 09:31'!
safeNoElementDataExtent
	^(-100@-100) corner: (100@100)! !

!GdsStructure methodsFor: 'accessing' stamp: 'kf 11/12/2008 09:47'!
addElement: aGdsElement
	self addElement: aGdsElement keyNumberFill: aGdsElement keyNumberFilled not.! !

!GdsStructure methodsFor: 'accessing' stamp: 'kf 10/30/2009 14:45'!
addElement: aGdsElement keyNumberFill: aBoolean
	| refLayer |
	colElements add: aGdsElement.
	dataExtentForElements := nil.
	aGdsElement instVarNamed: 'owner' put: self.

	aBoolean
		ifTrue: [aGdsElement instVarNamed: 'keyNumber' put: self nextKeyNumber].
		
	aGdsElement hasLayer
		ifTrue: [
			refLayer := layers atNumber: aGdsElement layerNumber.
			].
	! !

!GdsStructure methodsFor: 'objects from disk' stamp: 'kf 11/7/2009 22:52'!
asXmlElement
	| attr elmt |
	attr := Dictionary new.
	self attributesOn: attr.
	elmt := XMLElement 
		named: 'structure'
		attributes: attr.
	self liveElements do: [ :each | elmt addElement: each asXmlElement ].
	^elmt.! !

!GdsStructure methodsFor: 'printing' stamp: 'kf 10/23/2008 16:58'!
attributesOn: aDictionary
	aDictionary at: 'name' put: self name.
	aDictionary at: 'created' put: self timeCreated printString.
	aDictionary at: 'modified' put: self timeModified printString.
	! !

!GdsStructure methodsFor: 'updating' stamp: 'kf 11/19/2008 00:04'!
changedIdGroup
	self updateIdState.
	self changed: #tstructEnabled.			
	self changed: #unIdEnabled.
	self changed: #idClearEnabled.			
	self changed: #idDeleteEnabled.			
	self changed: #idNotEmpty.			
! !

!GdsStructure methodsFor: 'debug' stamp: 'kf 5/15/2009 14:50'!
clonedElements: elements appendOn: aOrderedCollection fromToBlock: aBlock
	elements do: [:each |
		| cloned |
		cloned := each copy.
		cloned instVarNamed: 'keyNumber' put: nil.
		aBlock value: each value: cloned.
		aOrderedCollection add: cloned.]! !

!GdsStructure methodsFor: 'objects from disk' stamp: 'kf 11/14/2008 23:22'!
close
	self items ifNotNil: [self items forgetStructure].
	self idSelection ifNotNil: [self idSelection forgetStructure].
	dirtyElements := nil.! !

!GdsStructure methodsFor: 'objects from disk' stamp: 'kf 6/23/2009 10:30'!
closeDiscard
	self closeSaving: false.! !

!GdsStructure methodsFor: 'testing' stamp: 'kf 6/22/2009 17:10'!
closeEnabled
	self currentItem putEnabled ifTrue: [^false].
	^self idSelection isEmpty
	! !

!GdsStructure methodsFor: 'objects from disk' stamp: 'kf 6/23/2009 10:29'!
closeSaving: aBoolean
	aBoolean ifTrue: [self save].
	self close.! !

!GdsStructure methodsFor: 'objects from disk' stamp: 'kf 6/23/2009 10:30'!
closeWithSave
	self closeSaving: true.! !

!GdsStructure methodsFor: 'private' stamp: 'kf 11/8/2008 17:41'!
comitDirty
	|element |
	element := self popDirtyReservedArea.
	element 
		ifNotNil: [
			dirtyElements ifNil: [dirtyElements := OrderedCollection new].
			dirtyElements add: element].
	self changed: #dirty.		! !

!GdsStructure methodsFor: 'edit chanel' stamp: 'kf 11/12/2008 14:20'!
currentItem
	self items ifNil: [^nil].
	^self items current.
	! !

!GdsStructure methodsFor: 'accessing' stamp: 'kf 10/3/2008 23:07'!
dataExtentForElements
	dataExtentForElements ifNil: [dataExtentForElements := self lookupDataExtentForElements ].
	^dataExtentForElements.! !

!GdsStructure methodsFor: 'accessing' stamp: 'kf 6/8/2009 17:13'!
dataExtentForFittingView
	self elements isEmpty 
		ifTrue: [^self safeNoElementDataExtent.].
	^self dataExtentForElements.! !

!GdsStructure methodsFor: 'accessing' stamp: 'kf 5/12/2009 14:11'!
database
	^database! !

!GdsStructure methodsFor: 'initialization' stamp: 'kf 10/22/2009 16:18'!
database: aGdsDatabase.
	database := aGdsDatabase.
	
! !

!GdsStructure methodsFor: 'accessing' stamp: 'kf 11/6/2009 14:30'!
directReferenceElements
	^ self  elements select: [:each | each type == #sref or: [each type == #aref] ].! !

!GdsStructure methodsFor: 'accessing' stamp: 'kf 11/8/2008 16:51'!
dirty
	self removedElements ifNotEmpty: [^true].
	dirtyElements ifNil: [^false].
	^dirtyElements notEmpty.
! !

!GdsStructure methodsFor: 'accessing' stamp: 'kf 9/19/2008 21:37'!
elements
	^colElements asArray.! !

!GdsStructure methodsFor: 'objects from disk' stamp: 'kf 6/16/2009 14:22'!
fileDirectory
	| libFd folderName |
	libFd := database fileDirectoryForEdit.
	folderName := self nameWithExtension.
	(libFd directoryExists: folderName)
		ifFalse: [libFd createDirectory: folderName].
	^FileDirectory on: (libFd fullPathFor: folderName).
! !

!GdsStructure methodsFor: 'objects from disk' stamp: 'kf 6/17/2009 14:57'!
fileDirectoryForLoad
	^self fileDirectory.! !

!GdsStructure methodsFor: 'objects from disk' stamp: 'kf 6/17/2009 14:54'!
fileOutAsXml
	self fileOutAsXmlNew.
! !

!GdsStructure methodsFor: 'objects from disk' stamp: 'kf 11/7/2009 23:02'!
fileOutAsXmlInto: aFileDirectory localName: aLocalName 
	GdsFeel 
		fileOutXmlTopElement: self asXmlElement
		fileDirectory: aFileDirectory
		localName: aLocalName! !

!GdsStructure methodsFor: 'objects from disk' stamp: 'kf 6/17/2009 14:54'!
fileOutAsXmlNew
	self fileOutAsXmlInto: (self fileDirectory) localName: self maxRevName.
! !

!GdsStructure methodsFor: 'example' stamp: 'kf 10/27/2009 10:31'!
fillExampleInstance
	self currentItem boundary.
	self currentItem layerNumber: 1.
	self currentItem ce: 0@0.
	self currentItem ce: 0@100.
	self currentItem ce: 0@100.
	self currentItem ce: 0@100.
	self currentItem ce: 0@100.
	self currentItem ce: 100@100.
	self currentItem ce: 100@0.
	self currentItem put.
	self currentItem path.
	self currentItem layerNumber: 3.
	self currentItem ce: 0@0.
	self currentItem ce: 0@100.
	self currentItem ce: 100@100.
	self currentItem ce: 100@0.
	self currentItem translate: 20@30.
	self currentItem put.
! !

!GdsStructure methodsFor: 'debug' stamp: 'kf 10/28/2008 00:02'!
findNearestElementByPoint: aPoint
	^self findNearestElementByPoint: aPoint elements: self liveElements. ! !

!GdsStructure methodsFor: 'debug' stamp: 'kf 7/10/2009 09:51'!
findNearestElementByPoint: aPoint elements: filteredElements
	| distanceOrderElements insideElements |
	filteredElements
		ifEmpty: [^nil].
	filteredElements size = 1
		ifTrue: [^filteredElements first].
	insideElements := filteredElements
		select: [:each  | each dataBounds containsPoint: aPoint ].	
	insideElements ifEmpty: [insideElements := filteredElements].	
	distanceOrderElements := insideElements
		sort: [:a :b | (a dist: aPoint) < (b dist: aPoint)].
	^distanceOrderElements first.! !

!GdsStructure methodsFor: 'private' stamp: 'kf 11/8/2008 16:30'!
flushDirtyInfo
	dirtyReservedArea := nil.
	dirtyElements := nil.! !

!GdsStructure methodsFor: 'debug' stamp: 'kf 5/15/2009 14:38'!
idCopyOffset: aPoint
	| newElements |
	newElements := OrderedCollection new.
	self 
		clonedElements: self idSelection elements 
		appendOn: newElements 
		fromToBlock: [:from :to |
			to moveRelative: aPoint from: from.].
	self idSelection idClear.
	newElements do: [:each |
		self addElement: each.
		self idSelection idAdd: each keyNumber.
		self pushDirtyReservedArea: each.].
	self comitDirty.
	
	! !

!GdsStructure methodsFor: 'debug' stamp: 'kf 11/14/2008 23:19'!
idDelete
	self idSelection elements do: [:each | 
		self pushDirtyReservedArea: each.
		each wipe.
		self removeElement: each.].
! !

!GdsStructure methodsFor: 'debug' stamp: 'kf 5/15/2009 14:38'!
idMoveOffset: aPoint
	self idSelection elements do: [:each | 
		each moveRelative: aPoint.
		self pushDirtyReservedArea: each].
	dataExtentForElements := nil.
	self comitDirty.
	
	! !

!GdsStructure methodsFor: 'edit chanel' stamp: 'kf 11/12/2008 13:59'!
idSelection
	database ifNil:[^nil].
	database station ifNil:[^nil].
	^database station idSelection.! !

!GdsStructure methodsFor: 'accessing' stamp: 'kf 11/6/2009 15:01'!
indirectReferencedStructureNames
	^self indirectReferencedStructures collect: [:each | each name]	 ! !

!GdsStructure methodsFor: 'accessing' stamp: 'kf 11/6/2009 14:58'!
indirectReferencedStructures
	| refs set |
	set := Set new.
	refs := self referencedStructures.
	set addAll: refs.
	[refs isEmpty]
		whileFalse: [
			refs 
				do: [:each |
					refs := each indirectReferencedStructures.
					set addAll: refs]].
	^set asArray.
		
	 ! !

!GdsStructure methodsFor: 'initialization' stamp: 'kf 10/27/2009 15:19'!
initialize
	| time |
	super initialize.	
	time := DateAndTime now.
	timeCreated := time copy.
	timeModified := time copy.
	colElements := OrderedCollection new.
	maxKeyNumber := nil.
	layers := GdsLayers new.

	! !

!GdsStructure methodsFor: 'testing' stamp: 'kf 6/16/2009 22:48'!
isTransient
	^ database isTransient! !

!GdsStructure methodsFor: 'edit chanel' stamp: 'kf 11/10/2008 13:53'!
items
	database ifNil:[^nil].
	database station ifNil:[^nil].
	^database station items.! !

!GdsStructure methodsFor: 'accessing' stamp: 'kf 10/28/2008 20:10'!
labelString
	^String streamContents: [:s |
		self dirty ifTrue: [s nextPutAll: '* '].
		s nextPutAll: self name].! !

!GdsStructure methodsFor: 'accessing' stamp: 'kf 10/29/2009 09:47'!
layers
	self libraryLayers ifNotNilDo: [:it | ^it].
	^self localLayers.! !

!GdsStructure methodsFor: 'accessing' stamp: 'kf 10/29/2009 09:46'!
libraryLayers
	database ifNil: [^nil].
	^database layers! !

!GdsStructure methodsFor: 'accessing' stamp: 'kf 7/14/2009 14:10'!
liveElements
	^self elements reject: [:each | 
		each state = #inTrush or: [each damaged]].! !

!GdsStructure methodsFor: 'objects from disk' stamp: 'kf 6/17/2009 14:57'!
load
	| lastPath |
	lastPath := self fileDirectoryForLoad fullNameFor: self maxRevName.
	self loadBetaFromPath: lastPath.! !

!GdsStructure methodsFor: 'objects from disk' stamp: 'kf 11/8/2009 22:21'!
loadBetaFromPath: aString
	GdsFeel 
		xmlDocumentFromPath: aString 
		documentBlock: [:doc |
			storagePath := aString.
			self loadBetaFromXmlDocument: doc].
! !

!GdsStructure methodsFor: 'objects from disk' stamp: 'kf 11/18/2008 10:21'!
loadBetaFromXmlDocument: aXMLDocument
	| structureNode |
	structureNode := aXMLDocument firstTagNamed: #structure.
	structureNode
		elementsDo: [ :node |
			| clazz element |
			clazz := GdsElement classForType: (node attributes at: 'type').
			clazz ifNotNil: [
				element := clazz new.
				element loadFromXmlNode: node.
				element fixGeometryError.				
				self addElement: element]].
	self loadFromAttributes: 	structureNode attributes.		
	self flushDirtyInfo.! !

!GdsStructure methodsFor: 'objects from disk' stamp: 'kf 10/23/2008 17:58'!
loadFromAttributes: aDictionary
	| iso8601 tempName |
	
	iso8601 := (aDictionary at: 'created' ifAbsent: [self timeCreatedForStorage]) asString.
	iso8601
		ifNotNil: [timeCreated := DateAndTime fromString: iso8601].

	iso8601 := (aDictionary at: 'modified' ifAbsent: [self timeModifiedForStorage]) asString.
	iso8601
		ifNotNil: [timeModified := DateAndTime fromString: iso8601].
		
	tempName := aDictionary at: 'name' ifAbsent: [].
	tempName
		ifNotNil: [savedName := tempName].
	! !

!GdsStructure methodsFor: 'accessing' stamp: 'kf 10/29/2009 09:43'!
localLayers
	^layers! !

!GdsStructure methodsFor: 'private' stamp: 'kf 5/30/2009 21:12'!
lookupDataExtentForElements
	^self lookupDataExtentForElementsChooserBlock: [:element | true]
! !

!GdsStructure methodsFor: 'private' stamp: 'kf 5/30/2009 21:11'!
lookupDataExtentForElementsChooserBlock: aElementBlock
	| bounds |
	bounds := GeometryUtils minusBounds.
	(self liveElements select: aElementBlock) do: [:e |
		bounds := bounds merge: e dataBounds.].
	^bounds! !

!GdsStructure methodsFor: 'key generator' stamp: 'kf 11/12/2008 09:22'!
lookupMaxKeyNumber
	| filledElements | 
	filledElements := self elements select: [:each | each keyNumberFilled].
	filledElements 
		ifEmpty: [^0]
		ifNotEmpty: [^(filledElements collect: [:each | each keyNumber]) max].! !

!GdsStructure methodsFor: 'private' stamp: 'kf 10/29/2009 09:41'!
lookupUsingLayerNumbers
	^(self elements 
		select: [:each | each hasLayer] 
		thenCollect: [:each | each layerNumber]) asSet asSortedArray.! !

!GdsStructure methodsFor: 'updating' stamp: 'kf 11/17/2008 14:16'!
markDirty
	self currentItem holdsElement 
		ifTrue: [self pushDirtyReservedArea: self currentItem editElement]
		ifFalse: [
			self liveElements ifNotEmpty: [
				self pushDirtyReservedArea: self liveElements last]].
	self changed: #dirty.
	! !

!GdsStructure methodsFor: 'updating' stamp: 'kf 10/27/2009 11:58'!
markDirtySelectors
	^#(geometry wipe newElement layer layerNumber width pathtype angle mag sname)! !

!GdsStructure methodsFor: 'key generator' stamp: 'kf 11/12/2008 09:16'!
maxKeyNumber
	maxKeyNumber ifNil: [maxKeyNumber := self lookupMaxKeyNumber].
	^maxKeyNumber
	
	! !

!GdsStructure methodsFor: 'objects from disk' stamp: 'kf 6/15/2009 16:44'!
maxRevName
	| names revs |
	names := self fileDirectory fileNamesMatching: (self name, '.*', '.gdsfeelbeta').
	revs := names collect: [:each | (each findTokens: '.') second asInteger].
	revs ifEmpty: [revs := Array with: 1].
	^{self name .  revs max asString .  'gdsfeelbeta'}
		joinUsing: '.'.! !

!GdsStructure methodsFor: 'attribute' stamp: 'kf 9/19/2008 18:39'!
name
	^name.! !

!GdsStructure methodsFor: 'attribute' stamp: 'kf 6/15/2009 15:29'!
nameWithExtension
	^self name, self newExtension ! !

!GdsStructure methodsFor: 'attribute' stamp: 'kf 6/15/2009 15:27'!
newExtension
	^'.', self newExtensionBody! !

!GdsStructure methodsFor: 'attribute' stamp: 'kf 6/15/2009 16:42'!
newExtensionBody
	^'structure'! !

!GdsStructure methodsFor: 'key generator' stamp: 'kf 11/12/2008 09:18'!
nextKeyNumber
	| newValue |
	newValue := self maxKeyNumber + 1.
	maxKeyNumber := newValue.
	^newValue
	! !

!GdsStructure methodsFor: 'private' stamp: 'kf 11/8/2008 15:59'!
popDirtyReservedArea
	dirtyReservedArea ifNil: [^nil].
	dirtyReservedArea ifNotEmpty: [^dirtyReservedArea removeLast].
	! !

!GdsStructure methodsFor: 'printing' stamp: 'kf 9/19/2008 18:46'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: '('.
	aStream nextPutAll: self name.
	aStream nextPutAll: ')'.	! !

!GdsStructure methodsFor: 'private' stamp: 'kf 11/8/2008 15:55'!
pushDirtyReservedArea: aGdsElement.
	dirtyReservedArea ifNil: [dirtyReservedArea := OrderedCollection new].
	^dirtyReservedArea add: aGdsElement.
	! !

!GdsStructure methodsFor: 'accessing' stamp: 'kf 11/6/2009 15:03'!
referenceEnabledStructureNames
	| ignoreNames |
	ignoreNames := self indirectReferencedStructureNames.
	^ self  database structureNames 
		reject: [ :each | (each sameAs: self  name) or: [ignoreNames includes: each]]! !

!GdsStructure methodsFor: 'accessing' stamp: 'kf 11/6/2009 14:37'!
referencedStructureNames
	^self referencedStructures collect: [:each | each name].! !

!GdsStructure methodsFor: 'accessing' stamp: 'kf 11/6/2009 14:36'!
referencedStructures
	^self database structures 
		select: [:each | each directReferenceElements anySatisfy: [:el | el structureName sameAs: self name] ]
! !

!GdsStructure methodsFor: 'initialization' stamp: 'kf 10/31/2009 21:01'!
release
	timeCreated := nil.
	timeModified := nil.
	colElements ifNotNil: [ colElements do: [:each | each release]].
	colElements := nil.
	maxKeyNumber := nil.
	layers release.
	layers := nil.
	name := nil.
	super release.

	! !

!GdsStructure methodsFor: 'accessing' stamp: 'kf 11/8/2008 16:26'!
removeElement: aGdsElement
	colElements remove: aGdsElement.
	dataExtentForElements := nil.
	"self setDirty: true."
	! !

!GdsStructure methodsFor: 'accessing' stamp: 'kf 11/8/2008 16:48'!
removedElements
	^self elements select: [:each | each state = #inTrush].! !

!GdsStructure methodsFor: 'private' stamp: 'kf 11/8/2008 16:42'!
revertDirty
	self popDirtyReservedArea.
	self changed: #dirty.! !

!GdsStructure methodsFor: 'accessing' stamp: 'kf 9/20/2008 21:07'!
safeNoElementDataExtent
	^self class safeNoElementDataExtent! !

!GdsStructure methodsFor: 'objects from disk' stamp: 'kf 6/16/2009 23:28'!
save
	self saveBlock: [self fileOutAsXml].
! !

!GdsStructure methodsFor: 'objects from disk' stamp: 'kf 6/16/2009 23:28'!
saveBlock: aBlock
	self dirty ifFalse: [^self].
	timeModified := DateAndTime now.
	aBlock value.
	self flushDirtyInfo.
	"self setDirty: false.	"! !

!GdsStructure methodsFor: 'objects from disk' stamp: 'kf 6/16/2009 23:27'!
saveUsingSelector: savingSelector
	self dirty ifFalse: [^self].
	timeModified := DateAndTime now.
	self perform: savingSelector.
	self flushDirtyInfo.
	"self setDirty: false.	"! !

!GdsStructure methodsFor: 'initialization' stamp: 'kf 10/21/2009 20:38'!
setName: aStructureName 
	name := GdsCompatibility default coerceStructureName:  aStructureName.
	
! !

!GdsStructure methodsFor: 'initialization' stamp: 'kf 10/21/2009 20:38'!
setName: aStructureName database: aGdsDatabase.
	self setName: aStructureName.
	database := aGdsDatabase.
	
! !

!GdsStructure methodsFor: 'attribute' stamp: 'kf 10/23/2008 16:53'!
timeCreated
	timeCreated ifNil: [timeCreated := DateAndTime now].
	^timeCreated.! !

!GdsStructure methodsFor: 'printing' stamp: 'kf 10/23/2008 17:52'!
timeCreatedForStorage
	| fd | 	
	storagePath ifNil: [^nil].
	fd := FileDirectory on: storagePath.
	^DateAndTime fromSeconds: (fd directoryEntry creationTime).
	! !

!GdsStructure methodsFor: 'attribute' stamp: 'kf 10/23/2008 16:54'!
timeModified
	timeModified ifNil: [timeModified := DateAndTime now].
	^timeModified.! !

!GdsStructure methodsFor: 'printing' stamp: 'kf 10/23/2008 17:52'!
timeModifiedForStorage
	| fd | 	
	storagePath ifNil: [^nil].
	fd := FileDirectory on: storagePath.
	^DateAndTime fromSeconds: (fd directoryEntry modificationTime).
	! !

!GdsStructure methodsFor: 'updating' stamp: 'kf 6/24/2009 17:01'!
update: anObject.
	GdsFeel ifDebugOn: [:s |
		s nextPutAll:  self class printString.
		s nextPutAll: ' recieve: '.
		s nextPutAll: anObject printString.].
	(self markDirtySelectors includes: anObject)
		ifTrue: [
			self markDirty.
			dataExtentForElements := nil.
			self changed: #geometry.
			self changed].
	anObject == #geometry
		ifTrue: [
			dataExtentForElements := nil.
			self changed.].
	anObject == #unget
		ifTrue: [
			self revertDirty].
	({ #put . #wipe . #idDelete } includes: anObject)
		ifTrue: [
			self comitDirty.
			self changed: anObject].
	anObject == #get
		ifTrue: [self changed].
	anObject == #id
		ifTrue: [
			self changedIdGroup.			
			self changed].
	anObject == #tstructEnabled
		ifTrue: [self changed: #tstructEnabled].
	anObject == self currentItem
		ifTrue: [self changed: #geometry].		
	super update: anObject.! !

!GdsStructure methodsFor: 'debug' stamp: 'kf 11/18/2008 21:22'!
updateIdState
	| idKeys colChangedElements|
	self idSelection ifNil: [^self].
	idKeys := self idSelection keyNumbers.
	colChangedElements := OrderedCollection new.
	(self liveElements reject: [:each | each state = #inItem])
		do: [:each | 
			(idKeys includes: each keyNumber)
				ifTrue: [
						each statusNumber ~= GdsElement inIdStausNumber
							ifTrue: [
								each statusNumber: GdsElement inIdStausNumber.
								colChangedElements add: each] ]
				ifFalse: [
						each statusNumber = GdsElement inIdStausNumber
							ifTrue: [
								each statusNumber: GdsElement inDatabaseStausNumber.
								colChangedElements add: each]]].
	self changed: colChangedElements asArray.! !

!GdsStructure methodsFor: 'private' stamp: 'kf 10/27/2009 10:14'!
usingLayerNumbers
	^self lookupUsingLayerNumbers! !

GdsStructure subclass: #GdsTransientBetaStructure
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsFeel-Model-Container'!

!GdsTransientBetaStructure methodsFor: 'printing' stamp: 'kf 6/16/2009 23:20'!
betaFilename
	^self name , '.gdsfeelbeta'.! !

!GdsTransientBetaStructure methodsFor: 'objects from disk' stamp: 'kf 6/17/2009 22:39'!
fileDirectoryForLoad
	^database class fileDirectoryForBeta ! !

!GdsTransientBetaStructure methodsFor: 'objects from disk' stamp: 'kf 6/17/2009 22:37'!
fileOutAsXml
	self 
		fileOutAsXmlInto: (self fileDirectoryForBeta)
		localName: self betaFilename.! !

!GdsTransientBetaStructure methodsFor: 'objects from disk' stamp: 'kf 6/17/2009 15:15'!
saveWithUpdate
	self saveBlock: [super fileOutAsXmlNew].
! !

Model subclass: #GdsStructureTransform
	instanceVariableNames: 'offset mag angle reflected absAngle absMag'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsFeel-Model-Property'!

!GdsStructureTransform commentStamp: 'kf 5/11/2009 23:42' prior: 0!
A GdsStructureTransform is transform information.

Instance Variables
!

!GdsStructureTransform methodsFor: 'accessing' stamp: 'kf 5/12/2009 11:03'!
angle
	^angle.! !

!GdsStructureTransform methodsFor: 'accessing' stamp: 'kf 5/14/2009 21:27'!
angle: aDegrees
	angle := aDegrees.
	! !

!GdsStructureTransform methodsFor: 'convertor' stamp: 'kf 11/10/2009 17:48'!
asMatrix2x3
	| t tm |
	t := MatrixTransform2x3 identity.
	t := t composedWithLocal: (MatrixTransform2x3 withOffset: self offset).
	t := t composedWithLocal: (MatrixTransform2x3 withScale: self mag).
	t := t composedWithLocal: (MatrixTransform2x3 withAngle: self angle).
	self isReflected 
		ifTrue: [
			tm := MatrixTransform2x3 identity.
			tm a11: -1.0.
			t := t composedWithLocal: tm].
	^t.! !

!GdsStructureTransform methodsFor: 'copying' stamp: 'kf 5/15/2009 14:55'!
copy
	^super copy copyTransform.! !

!GdsStructureTransform methodsFor: 'copying' stamp: 'kf 5/15/2009 14:55'!
copyTransform
	angle := angle deepCopy.
	offset := offset deepCopy.
	mag := mag deepCopy.! !

!GdsStructureTransform methodsFor: 'initialize-release' stamp: 'kf 11/10/2009 14:17'!
initialize
	super initialize.
	self safeReset.
! !

!GdsStructureTransform methodsFor: 'testing' stamp: 'kf 10/23/2009 21:31'!
isAbsAngle
	^absAngle! !

!GdsStructureTransform methodsFor: 'testing' stamp: 'kf 10/23/2009 21:31'!
isAbsMag
	^absMag! !

!GdsStructureTransform methodsFor: 'testing' stamp: 'kf 11/10/2009 00:06'!
isReflected
	^reflected .! !

!GdsStructureTransform methodsFor: 'accessing' stamp: 'kf 5/12/2009 11:03'!
mag
	^mag.! !

!GdsStructureTransform methodsFor: 'accessing' stamp: 'kf 5/15/2009 23:20'!
mag: aFactor
	mag := aFactor.
	! !

!GdsStructureTransform methodsFor: 'accessing' stamp: 'kf 5/11/2009 23:50'!
offset
	^offset
	! !

!GdsStructureTransform methodsFor: 'accessing' stamp: 'kf 5/11/2009 23:49'!
offset: aPoint
	offset := aPoint.
	! !

!GdsStructureTransform methodsFor: 'printing' stamp: 'kf 11/10/2009 16:54'!
printOn: aStream
	super printOn: aStream.
	aStream nextPut: $(.
	self mag = 1.0
		ifFalse: [
			aStream print: self mag].
	self angle = 0.0
		ifFalse: [
			aStream print: self angle.
			aStream nextPut: $,].
	self isReflected
		ifTrue: [
			aStream nextPutAll: 'REFL'].
	aStream nextPut: $).
	! !

!GdsStructureTransform methodsFor: 'initialize-release' stamp: 'kf 11/10/2009 14:17'!
safeReset
	offset := 0.0@0.0.
	mag := 1.0.
	angle := 0.0.	
	absAngle := false.
	absMag := false.
	reflected := false.
! !

!GdsStructureTransform methodsFor: 'testing' stamp: 'kf 10/23/2009 21:30'!
setAngleAbsolute: aBoolean
	absAngle := aBoolean.! !

!GdsStructureTransform methodsFor: 'testing' stamp: 'kf 10/23/2009 21:31'!
setMagAbsolute: aBoolean
	absMag := aBoolean.! !

!GdsStructureTransform methodsFor: 'testing' stamp: 'kf 10/23/2009 21:29'!
setReflected: aBoolean
	reflected := aBoolean.! !

Model subclass: #GdsViewport
	instanceVariableNames: 'wTrans scale grid viewCenter lastPoint pixelBoundsSelector pixelBoundsTarget model compositMatrix fittingRatio'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsFeel-Model-Viewing'!

!GdsViewport commentStamp: 'kf 11/14/2008 20:08' prior: 0!
A GdsViewport is Pluggable coordinate transformer.

Instance Variables
	grid:		<GdsGrid>
	lastPoint:		<Object>
	model:		<Object>
	pixelBoundsSelector:		<Symbol>
	pixelBoundsTarget:		<Object>
	scale:		<Float>
	viewCenter:		<Point>
	wTrans:		<MatrixTransform2x3>

grid
	- xxxxx

lastPoint
	- xxxxx

model
	- xxxxx

pixelBoundsSelector
	- xxxxx

pixelBoundsTarget
	- xxxxx

scale
	- xxxxx

viewCenter
	- xxxxx

wTrans
	- xxxxx
!

!GdsViewport class methodsFor: 'as yet unclassified' stamp: 'kf 11/14/2009 15:43'!
defaultFittingRatio 
	^0.98.! !

!GdsViewport methodsFor: 'testing' stamp: 'kf 6/10/2009 10:08'!
canGridDraw
	| pixelPitch |
	self grid displayMultiply = 0 ifTrue: [^false].
	pixelPitch :=   
			(self gridScale x * self wTrans a11) asFloat
		 *	 self grid displayMultiply.
	(pixelPitch  <= 4.0)
		ifTrue: [^false].
	^true.
	! !

!GdsViewport methodsFor: 'initialization' stamp: 'kf 6/24/2009 17:47'!
composeNewTransform: aMatrixTransform2x3
	wTrans := self wTrans composedWithLocal: aMatrixTransform2x3.
	compositMatrix :=  aMatrixTransform2x3.
	 ! !

!GdsViewport methodsFor: 'initialization' stamp: 'kf 6/24/2009 17:48'!
compositMatrix
	compositMatrix ifNil: [compositMatrix := MatrixTransform2x3 identity].
	^compositMatrix.! !

!GdsViewport methodsFor: 'defaults' stamp: 'kf 11/14/2009 15:54'!
defaultFittingRatio 
	^GdsFeel fittingRatio.! !

!GdsViewport methodsFor: 'drawing' stamp: 'kf 9/27/2008 00:12'!
extent: aPoint
	wTrans := nil.
! !

!GdsViewport methodsFor: 'accessing' stamp: 'kf 11/13/2009 21:46'!
fittingRatio
	^fittingRatio! !

!GdsViewport methodsFor: 'accessing' stamp: 'kf 11/14/2009 15:42'!
fittingRatio: aFloat
	fittingRatio := (aFloat > 1.0 or: [aFloat < 0.5]) ifTrue: [self defaultFittingRatio] ifFalse: [aFloat].! !

!GdsViewport methodsFor: 'viewing' stamp: 'kf 11/20/2008 11:26'!
grid
	grid ifNil: [grid := GdsGrid new].
	^grid 
	
	
	! !

!GdsViewport methodsFor: 'accessing' stamp: 'kf 9/20/2008 18:31'!
grid: aGrid
	grid := aGrid.
	self changed.
	! !

!GdsViewport methodsFor: 'viewing' stamp: 'kf 6/9/2009 18:16'!
gridOffset
	^self grid offset.
	
	! !

!GdsViewport methodsFor: 'viewing' stamp: 'kf 11/20/2008 11:26'!
gridScale
	^self grid scale.
	
	! !

!GdsViewport methodsFor: 'initialization' stamp: 'kf 11/13/2009 21:47'!
initialize
	super initialize.
	fittingRatio := self defaultFittingRatio.! !

!GdsViewport methodsFor: 'lookup' stamp: 'kf 11/16/2009 13:12'!
lookupHorizontalGridSteps
	^self grid 
		lookupGridStepsMin: self worldViewMinX 
		max: self worldViewMaxX 
		gridScale: self gridScale x gridOffset: self gridOffset x
	! !

!GdsViewport methodsFor: 'lookup' stamp: 'kf 11/16/2009 13:13'!
lookupVerticalGridSteps
	^self grid 
		lookupGridStepsMin: self worldViewMinY 
		max: self worldViewMaxY 
		gridScale: self gridScale y gridOffset: self gridOffset y

	
	! !

!GdsViewport methodsFor: 'viewing' stamp: 'kf 11/19/2009 11:31'!
marginBounds: aBaseBounds
	| growFactor growWidth growHeight|
	growFactor := (self fittingRatio reciprocal) - 1.0.
	growWidth := (aBaseBounds width * growFactor) * 0.5.
	growHeight := (aBaseBounds height * growFactor) * 0.5.
	^aBaseBounds expandBy: (growWidth@growHeight).
	 ! !

!GdsViewport methodsFor: 'viewing' stamp: 'kf 5/28/2009 19:25'!
maxScaleLimit
	^1000.! !

!GdsViewport methodsFor: 'viewing' stamp: 'kf 5/28/2009 19:09'!
minScaleLimit
	^self maxScaleLimit reciprocal asFloat.! !

!GdsViewport methodsFor: 'accessing' stamp: 'kf 11/18/2008 21:16'!
model: aModel
	model := aModel.
	self addDependent: model.
	
	! !

!GdsViewport methodsFor: 'transforms' stamp: 'kf 9/26/2008 23:44'!
morhicPointFromGlobal:  aGlobalPoint
	^aGlobalPoint - self pixelBounds origin.! !

!GdsViewport methodsFor: 'private' stamp: 'kf 9/27/2008 00:20'!
pixelBounds
	^pixelBoundsTarget perform: pixelBoundsSelector.! !

!GdsViewport methodsFor: 'accessing' stamp: 'kf 9/27/2008 00:17'!
pixelBoundsSelector: aSelector
	pixelBoundsSelector := aSelector.
	
	! !

!GdsViewport methodsFor: 'accessing' stamp: 'kf 10/22/2008 13:41'!
pixelBoundsTarget: aTarget
	self assert: [aTarget isNil not].
	pixelBoundsTarget := aTarget.
	self addDependent: aTarget.
	
	! !

!GdsViewport methodsFor: 'viewing' stamp: 'kf 9/25/2008 23:29'!
privateViewCenter: aPoint
	viewCenter := aPoint.	
	wTrans := nil.! !

!GdsViewport methodsFor: 'viewing' stamp: 'kf 11/17/2009 20:23'!
privateViewMoveFractionX: aXfraction y: aYfraction
	| xDelta yDelta newCenter |
	xDelta := self worldViewWidth * aXfraction.
	yDelta := self worldViewHeight * aYfraction.	
	newCenter := self viewCenter + (xDelta@yDelta).
	self privateViewCenter: newCenter.
	! !

!GdsViewport methodsFor: 'viewing' stamp: 'kf 9/25/2008 23:28'!
privateViewScale: aScale
	aScale < self minScaleLimit 
		ifTrue: [
			Transcript cr; show: '*** WARNING *** minimam scale limit.'.
			^self].
	aScale > self maxScaleLimit 
		ifTrue: [
			Transcript cr; show: '*** WARNING *** maximam scale limit.'.
			^self].
	scale := aScale.
	wTrans := nil.! !

!GdsViewport methodsFor: 'transforms' stamp: 'kf 6/9/2009 18:17'!
snapedWorldPoint:  aWorldPoint
	^(GeometryUtils point: aWorldPoint roundTo: (self gridScale)) + self gridOffset.! !

!GdsViewport methodsFor: 'transforms' stamp: 'kf 10/3/2008 22:45'!
snapedWorldPointFromGlobal:  aGlobalPoint
	^self snapedWorldPoint: (self worldPointFromGlobal: aGlobalPoint).! !

!GdsViewport methodsFor: 'transforms' stamp: 'kf 9/20/2008 11:58'!
verticalFlipTransform
	^MatrixTransform2x3 withScale: (1.0@-1.0).
	
	! !

!GdsViewport methodsFor: 'viewing' stamp: 'kf 11/19/2009 11:08'!
viewBounds: aWorldBounds
	| hRatio vRatio scalingFactor centerPoint |
	hRatio := (self pixelBounds width / aWorldBounds width) asFloat.
	vRatio := (self pixelBounds height / aWorldBounds height) asFloat.
	scalingFactor := hRatio min: vRatio.
	centerPoint := (aWorldBounds origin + aWorldBounds corner) / 2.0.	
	self privateViewScale: scalingFactor.
	self privateViewCenter: centerPoint.
	self changed.! !

!GdsViewport methodsFor: 'viewing' stamp: 'kf 9/20/2008 18:28'!
viewCenter
	viewCenter ifNil: [viewCenter := 0.0@0.0].
	^viewCenter.
	! !

!GdsViewport methodsFor: 'viewing' stamp: 'kf 9/21/2008 21:52'!
viewCenter: aPoint
	self privateViewCenter: aPoint.
	self changed.! !

!GdsViewport methodsFor: 'viewing' stamp: 'kf 11/19/2009 11:30'!
viewFit
	self viewBounds: (self marginBounds: (model dataExtentForFittingView)).
	 ! !

!GdsViewport methodsFor: 'viewing' stamp: 'kf 9/21/2008 21:14'!
viewMove: aFractionPoint
	self viewMoveFractionX: aFractionPoint x y: aFractionPoint y.
	self changed..! !

!GdsViewport methodsFor: 'viewing' stamp: 'kf 9/21/2008 21:01'!
viewMoveFractionX: aXfraction y: aYfraction	
	self privateViewMoveFractionX: aXfraction y: aYfraction..
	! !

!GdsViewport methodsFor: 'viewing' stamp: 'kf 9/20/2008 15:57'!
viewScale
	scale ifNil: [scale := 1.0].
	^scale.! !

!GdsViewport methodsFor: 'viewing' stamp: 'kf 9/21/2008 20:59'!
viewScale: aScale
	self privateViewScale: aScale.
	self changed.! !

!GdsViewport methodsFor: 'initialization' stamp: 'kf 9/20/2008 13:45'!
wTrans
	wTrans ifNil: [wTrans := self worldTransform].
	^wTrans
	! !

!GdsViewport methodsFor: 'transforms' stamp: 'kf 11/13/2009 10:22'!
worldPointFromGlobal:  aGlobalPoint
	^self wTrans invertPoint: (self morhicPointFromGlobal: aGlobalPoint).! !

!GdsViewport methodsFor: 'transforms' stamp: 'kf 9/26/2008 23:46'!
worldTransform
	| m |
	m := MatrixTransform2x3 new.
	m setOffset: (0@self pixelBounds extent y).	
	m setScale: (1@-1).
	m := m composedWithLocal: (MatrixTransform2x3 withOffset: ((self pixelBounds extent) / 2.0)).
	m := m composedWithLocal: (MatrixTransform2x3 withScale: self viewScale asPoint).
	m := m composedWithLocal: (MatrixTransform2x3 withOffset: self viewCenter negated).
	^m	! !

!GdsViewport methodsFor: 'world-geometry' stamp: 'kf 10/3/2008 23:31'!
worldViewBounds
	^Rectangle origin: self worldViewOrigin corner: self worldViewCorner.
	! !

!GdsViewport methodsFor: 'world-geometry' stamp: 'kf 9/26/2008 23:46'!
worldViewCorner
	| globalPoint |
	globalPoint := self pixelBounds right@self pixelBounds top.
	^self worldPointFromGlobal: globalPoint.
	! !

!GdsViewport methodsFor: 'world-geometry' stamp: 'kf 9/21/2008 19:58'!
worldViewHeight
	^self worldViewMaxY - self worldViewMinY.
	! !

!GdsViewport methodsFor: 'world-geometry' stamp: 'kf 9/20/2008 16:28'!
worldViewMaxX
	^self worldViewCorner x.! !

!GdsViewport methodsFor: 'world-geometry' stamp: 'kf 9/20/2008 16:28'!
worldViewMaxY
	^self worldViewCorner y.! !

!GdsViewport methodsFor: 'world-geometry' stamp: 'kf 9/20/2008 16:28'!
worldViewMinX
	^self worldViewOrigin x.! !

!GdsViewport methodsFor: 'world-geometry' stamp: 'kf 9/20/2008 16:29'!
worldViewMinY
	^self worldViewOrigin y.! !

!GdsViewport methodsFor: 'world-geometry' stamp: 'kf 9/26/2008 23:45'!
worldViewOrigin
	| globalPoint |
	globalPoint := self pixelBounds left@self pixelBounds bottom.
	^self worldPointFromGlobal: globalPoint.
	! !

!GdsViewport methodsFor: 'world-geometry' stamp: 'kf 9/21/2008 19:58'!
worldViewWidth
	^self worldViewMaxX - self worldViewMinX.
	! !

!GdsViewport methodsFor: 'transforms' stamp: 'kf 7/9/2009 10:29'!
xy2hv: aWorldPoint
	^self xy2hv: aWorldPoint transform: self wTrans! !

!GdsViewport methodsFor: 'transforms' stamp: 'kf 11/17/2009 20:45'!
xy2hv: aWorldPoint transform: aMatrixTransform2x3
	| np1 |
	np1 :=aMatrixTransform2x3 localPointToGlobal: aWorldPoint.
	"np1 := GeometryUtils point: np1 roundTo: 1.0."
	^GeometryUtils limitedPoint:  np1 rounded.	! !

!GdsViewport methodsFor: 'transforms' stamp: 'kf 9/28/2008 20:48'!
xy2hvPoints: aPointArray
	^aPointArray collect: 
		[:each | self xy2hv: each]. ! !

!GdsViewport methodsFor: 'viewing' stamp: 'kf 9/20/2008 15:58'!
zoom: aNumber
	self viewScale: self viewScale * aNumber.
	! !

Model subclass: #GdsWireContext
	instanceVariableNames: 'width outlineSegMap boundaryPoints pathtype element'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsFeel-Model-Property'!

!GdsWireContext commentStamp: 'kf 11/12/2008 12:05' prior: 0!
A GdsWireContext is GDS II's PATH or TEXT shared property.

Instance Variables
	boundaryPoints:		<Array<Point>>
	outlineSegMap:		<Object>
	width:		<Float>

boundaryPoints
	- xxxxx

outlineSegMap
	- xxxxx

width
	- xxxxx
!

!GdsWireContext class methodsFor: 'testing' stamp: 'kf 5/4/2009 11:15'!
hasWidth
	^true.! !

!GdsWireContext class methodsFor: 'accessing' stamp: 'kf 9/20/2008 14:18'!
requiredVertexCount
	^2.! !

!GdsWireContext class methodsFor: 'accessing' stamp: 'kf 10/23/2008 19:53'!
type
	^#path! !

!GdsWireContext methodsFor: 'accessing' stamp: 'kf 10/24/2008 22:10'!
boundaryPoints
	boundaryPoints ifNil: [boundaryPoints := self lookupBoundaryPoints].
	^boundaryPoints! !

!GdsWireContext methodsFor: 'accessing' stamp: 'kf 10/26/2008 12:04'!
dataOutlinePoints
	^ self boundaryPoints! !

!GdsWireContext methodsFor: 'outline' stamp: 'kf 10/24/2009 21:01'!
degressOfPathType
	^self pathtype = 0 ifTrue: [90] ifFalse: [45].
! !

!GdsWireContext methodsFor: 'accessing' stamp: 'kf 10/24/2009 20:41'!
element: aGdsElement
	element := aGdsElement.! !

!GdsWireContext methodsFor: 'accessing' stamp: 'kf 10/17/2008 22:30'!
halfWidth
	^self width / 2.0.! !

!GdsWireContext methodsFor: 'initialization' stamp: 'kf 10/24/2009 20:14'!
initialize
	super initialize.
	width := 0.0.
	pathtype := 0.! !

!GdsWireContext methodsFor: 'other' stamp: 'kf 10/24/2009 20:55'!
lineSegmentsDo: aLineSegmentBlock
	element lineSegmentsDo: aLineSegmentBlock! !

!GdsWireContext methodsFor: 'outline' stamp: 'kf 10/24/2009 20:52'!
lookupBoundaryPoints
	|  unit r offsetRadians getSegsBlock lastSeg vpLeftPrev vpLeft vpRight vpRightPrev count points colPoints colLeftPoints colRightPoints segOutlinePoints segs1 segs2 leftSeg1 leftSeg2 rightSeg1 rightSeg2 |
	colPoints := OrderedCollection new.	
	colLeftPoints := OrderedCollection new.	
	colRightPoints := OrderedCollection new.	
	points := self vertices.
	offsetRadians :=  self degressOfPathType degreesToRadians.
	unit := offsetRadians sin.
	r := unit = 0 ifTrue: [self halfWidth] ifFalse: [self halfWidth / unit].
	lastSeg := nil.
	vpLeft := nil.
	vpLeftPrev := nil.
	vpRight := nil.
	vpRightPrev := nil.
	count := 0.
	getSegsBlock := [:each | self outlineSegmentsOf: each offsetRadians: offsetRadians r: r].
	self lineSegmentsDo: [:seg |
		|  |
		count := count + 1.
		segOutlinePoints := seg outlinePoints: offsetRadians r: r.
		(points size = 2)
			ifTrue: [
				colPoints addAll: {segOutlinePoints at: 3 . segOutlinePoints at: 2 . segOutlinePoints at: 1 . segOutlinePoints at: 4 . segOutlinePoints at: 3}.
				^colPoints asArray].	
		segs1 := getSegsBlock value: seg.
		leftSeg1 := segs1 second reversed.
		rightSeg1 := segs1 fourth .
		(count == 1)
			ifTrue: [
				vpLeft := leftSeg1 start clone..
				vpRight := rightSeg1 start clone..
				vpLeftPrev := leftSeg1 start clone..
				vpRightPrev := rightSeg1 start clone..				
				].		
		lastSeg ifNotNil: [
			segs2 := getSegsBlock value: lastSeg.
			leftSeg2 := segs2 second reversed.
			rightSeg2 := segs2 fourth .
			vpLeft := leftSeg1 intersectionWith: leftSeg2  virtualAllowed: true.
			vpLeft ifNil: [vpLeft := leftSeg2 end clone.].
			vpLeftPrev 
				ifNil:[vpLeftPrev := leftSeg2 start].
			colLeftPoints add: vpLeftPrev.
			colLeftPoints add: vpLeft.
			vpLeftPrev := vpLeft clone.
			
			vpRight := rightSeg1 intersectionWith: rightSeg2  virtualAllowed: true.
			vpRight ifNil: [vpRight := rightSeg2 end clone.].
			colRightPoints add: vpRightPrev.
			colRightPoints add: vpRight.
			vpRightPrev := vpRight clone.
		count = (points size - 1)
			ifTrue: [
				vpLeft ifNotNil: [
					colLeftPoints add: leftSeg1 end copy].
				vpRight ifNotNil: [
					colRightPoints add: rightSeg1 end copy]].].
		lastSeg := seg].
	colPoints addAll: colLeftPoints.
	colPoints addAll: colRightPoints reversed.	
	colPoints size >= 2 	
		ifTrue: [colPoints add: colPoints first].
	self assert: [colPoints size >= 5].
	^colPoints asArray.
	! !

!GdsWireContext methodsFor: 'outline' stamp: 'kf 10/24/2009 20:52'!
offsetRadiansAndRadiusDo: aBlock
	|  unit r offsetRadians  |
	offsetRadians :=  self degressOfPathType degreesToRadians.
	unit := offsetRadians sin.
	r := unit = 0 ifTrue: [self halfWidth] ifFalse: [self halfWidth / unit].
	aBlock value: offsetRadians value: r.! !

!GdsWireContext methodsFor: 'outline' stamp: 'kf 6/8/2009 17:19'!
outlinePointsOf: aLineSegment
	| points |
	points := #() copy.
	self offsetRadiansAndRadiusDo: [:radians :r |
		points := aLineSegment outlinePoints: radians r: r.].
	^points! !

!GdsWireContext methodsFor: 'outline' stamp: 'kf 10/17/2008 22:09'!
outlineSegmentsOf: aLineSegment
	outlineSegMap ifNil: [outlineSegMap := Dictionary new].
	! !

!GdsWireContext methodsFor: 'outline' stamp: 'kf 10/17/2008 22:12'!
outlineSegmentsOf: aLineSegment offsetRadians: radians r: r
	outlineSegMap ifNil: [outlineSegMap := Dictionary new].
	^outlineSegMap 
		at: aLineSegment 
		ifAbsentPut: [aLineSegment outlineSegments: radians r: r].
	! !

!GdsWireContext methodsFor: 'accessing' stamp: 'kf 10/21/2009 17:17'!
pathtype
	^pathtype! !

!GdsWireContext methodsFor: 'accessing' stamp: 'kf 10/27/2009 13:47'!
pathtype: aInteger
	self assert: [aInteger isKindOf: Integer].
	pathtype = aInteger ifTrue: [^self].
	pathtype := aInteger.
	self removeGeometryCache.
	self changed: #pathtype.! !

!GdsWireContext methodsFor: 'other' stamp: 'kf 10/27/2009 12:06'!
removeGeometryCache
	boundaryPoints := nil.
	outlineSegMap := nil.! !

!GdsWireContext methodsFor: 'accessing' stamp: 'kf 10/24/2009 20:44'!
vertices
	^element vertices! !

!GdsWireContext methodsFor: 'accessing' stamp: 'kf 10/17/2008 17:17'!
width
	width ifNil: [width := 10.0].
	^width.! !

!GdsWireContext methodsFor: 'accessing' stamp: 'kf 10/27/2009 11:29'!
width: aFloat
	width = aFloat ifTrue: [^self].
	width := aFloat.! !

Object subclass: #GdsColorUtils
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsFeel-Model-Utility'!

!GdsColorUtils class methodsFor: 'as yet unclassified' stamp: 'kf 11/7/2009 18:50'!
fromAttributes: aDictionary 
	| a r g b |
	a := aDictionary at: 'a' ifAbsent: [1.0].		
	r := aDictionary at: 'r' ifAbsent: [1.0].		
	g := aDictionary at: 'g' ifAbsent: [1.0].		
	b := aDictionary at: 'b' ifAbsent: [1.0].
	^Color r: r g: g b: b alpha: a. 										! !

!GdsColorUtils class methodsFor: 'as yet unclassified' stamp: 'kf 11/7/2009 22:22'!
rgbaAttributesOn: aDictionary color: aColor
	aDictionary at: 'r' put: aColor red asString.
	aDictionary at: 'g' put: aColor green asString.
	aDictionary at: 'b' put: aColor blue asString.
	aDictionary at: 'a' put: aColor alpha asString.
	 ! !

Object subclass: #GdsCompatibility
	instanceVariableNames: ''
	classVariableNames: 'CompatibilityClass DefaultCompatibility Checker'
	poolDictionaries: ''
	category: 'GdsFeel-Model-Spec'!

!GdsCompatibility commentStamp: 'kf 11/12/2008 12:03' prior: 0!
A GdsCompatibility is controls GDS II simulation spec level  .

Instance Variables
!

!GdsCompatibility class methodsFor: 'as yet unclassified' stamp: 'kf 10/23/2008 10:53'!
activeClass
	GdsCompatibility allSubclasses do: [:class |
		class isActive ifTrue: [^ class]].
	^ GdsCompatibility 
! !

!GdsCompatibility class methodsFor: 'as yet unclassified' stamp: 'kf 10/23/2008 23:46'!
checker
	Checker ifNil: [Checker := DosFileDirectory new.].
	^Checker.! !

!GdsCompatibility class methodsFor: 'actions' stamp: 'kf 10/23/2008 11:02'!
create
	CompatibilityClass ifNil: [self setActiveClass].
	^CompatibilityClass new.
! !

!GdsCompatibility class methodsFor: 'defaults' stamp: 'kf 10/23/2008 11:03'!
default
	DefaultCompatibility ifNil: [DefaultCompatibility := self create.].
	^DefaultCompatibility.
! !

!GdsCompatibility class methodsFor: 'class initialization' stamp: 'kf 5/6/2009 21:36'!
initialize
	"self initialize"
	Smalltalk addToStartUpList: self.	
! !

!GdsCompatibility class methodsFor: 'testing' stamp: 'kf 10/23/2008 10:52'!
isActive
	^false! !

!GdsCompatibility class methodsFor: 'as yet unclassified' stamp: 'kf 10/23/2008 10:56'!
setActiveClass
	CompatibilityClass := self activeClass.
! !

!GdsCompatibility class methodsFor: 'system startup' stamp: 'kf 10/23/2008 11:06'!
startUp
	self setActiveClass.
	! !

!GdsCompatibility methodsFor: 'convert' stamp: 'kf 10/23/2008 23:48'!
checker
	^self class checker.! !

!GdsCompatibility methodsFor: 'convert' stamp: 'kf 10/26/2008 09:53'!
coerceStructureName: aString
	| partial |
	partial := aString copyReplaceAll: ' ' with: '_' .
	partial ifEmpty: [^'' copy].
	^self checker checkName: partial fixErrors: true.! !

!GdsCompatibility methodsFor: 'testing' stamp: 'kf 10/23/2008 10:15'!
elementColorAllowed
	^true! !

!GdsCompatibility methodsFor: 'testing' stamp: 'kf 6/22/2009 15:11'!
isValidLibraryName: aString 
	(self isValidStorageName: aString)
		ifFalse: [^false].
	^aString matchesRegex: '[A-Z][A-Z0-9$_]+'.! !

!GdsCompatibility methodsFor: 'testing' stamp: 'kf 6/12/2009 12:46'!
isValidStorageName: aString 
	(aString includes: Character space) ifTrue: [^false].
	[self checker checkName: aString fixErrors: false.] on: Error do: [:ex | ^false]. 
	self multilingalNameAllowed ifFalse: [ ^ (aString isKindOf: WideString) not ].
	^true.! !

!GdsCompatibility methodsFor: 'testing' stamp: 'kf 6/12/2009 12:47'!
isValidStructureName: aString 
	^self isValidStorageName: aString! !

!GdsCompatibility methodsFor: 'acessing' stamp: 'kf 11/10/2008 13:17'!
itemNumberMax
	^9! !

!GdsCompatibility methodsFor: 'acessing' stamp: 'kf 11/10/2008 13:17'!
itemNumberMin
	^0! !

!GdsCompatibility methodsFor: 'acessing' stamp: 'kf 11/10/2008 13:17'!
itemNumberRange
	^Interval from: self itemNumberMin to: self itemNumberMax. ! !

!GdsCompatibility methodsFor: 'acessing' stamp: 'kf 10/23/2008 11:10'!
layerNumberMax
	^255.! !

!GdsCompatibility methodsFor: 'acessing' stamp: 'kf 10/23/2008 11:10'!
layerNumberMin
	^0.! !

!GdsCompatibility methodsFor: 'acessing' stamp: 'kf 10/23/2008 11:13'!
layerNumberRange
	^Interval from: self layerNumberMin to: self layerNumberMax. ! !

!GdsCompatibility methodsFor: 'acessing' stamp: 'kf 6/12/2009 10:59'!
libNameMax
	^-1! !

!GdsCompatibility methodsFor: 'testing' stamp: 'kf 9/21/2008 22:38'!
limitedColorSpace
	^self supportedColorSymbols isEmpty not.! !

!GdsCompatibility methodsFor: 'testing' stamp: 'kf 9/21/2008 23:06'!
limitedColors
	^self supportedColorSymbols collect: [ :colorSymbol | Color perform: colorSymbol].
! !

!GdsCompatibility methodsFor: 'testing' stamp: 'kf 10/23/2008 11:41'!
multilingalNameAllowed
	^ true! !

!GdsCompatibility methodsFor: 'category name' stamp: 'kf 10/23/2008 09:58'!
supportedColorSymbols
	^#() copy.! !

GdsCompatibility subclass: #GdsStrictCompatibility
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsFeel-Model-Spec'!

GdsStrictCompatibility subclass: #GdsBetaCompatibility
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsFeel-Model-Spec'!

!GdsBetaCompatibility class methodsFor: 'as yet unclassified' stamp: 'kf 10/23/2008 10:51'!
isActive
	^true.! !

!GdsBetaCompatibility methodsFor: 'as yet unclassified' stamp: 'kf 10/23/2008 11:50'!
coerceStructureName: aString
	^(super coerceStructureName: aString) asUppercase.! !

!GdsBetaCompatibility methodsFor: 'as yet unclassified' stamp: 'kf 10/22/2009 21:38'!
libNameMax
	^32! !

!GdsStrictCompatibility methodsFor: 'testing' stamp: 'kf 10/23/2008 10:15'!
elementColorAllowed
	^false! !

!GdsStrictCompatibility methodsFor: 'acessing' stamp: 'kf 10/23/2008 11:15'!
layerNumberMax
	^63! !

!GdsStrictCompatibility methodsFor: 'acessing' stamp: 'kf 6/12/2009 10:58'!
libNameMax
	^10! !

!GdsStrictCompatibility methodsFor: 'testing' stamp: 'kf 10/23/2008 11:41'!
multilingalNameAllowed
	^ false! !

!GdsStrictCompatibility methodsFor: 'category name' stamp: 'kf 9/21/2008 23:03'!
supportedColorSymbols
	^#(blue cyan green magenta red white yellow).! !

Object subclass: #GdsFeel
	instanceVariableNames: ''
	classVariableNames: 'TypedMap'
	poolDictionaries: ''
	category: 'GdsFeel-Model-Spec'!

!GdsFeel commentStamp: 'kf 11/8/2008 00:10' prior: 0!
A GdsFeel is Project symbolic name.

- not a real GUI class. (real class GdsStationUI).
- project property holder like as NextStep's defaults (write|read) NSGlobalDomain.

Instance Variables
!

!GdsFeel class methodsFor: 'debug-flags' stamp: 'kf 11/2/2009 11:40'!
debugConsoleOut
	^self typedMap booleanFor: #debugConsoleOut.! !

!GdsFeel class methodsFor: 'debug-flags' stamp: 'kf 11/2/2009 11:40'!
debugConsoleOut: aBoolean
	self typedMap booleanFor: #debugConsoleOut value: aBoolean.
	! !

!GdsFeel class methodsFor: 'accessing' stamp: 'kf 6/12/2009 10:21'!
fileDirectory
	^FileDirectory on: self pathToSelf.
! !

!GdsFeel class methodsFor: 'objects from disk' stamp: 'kf 11/7/2009 23:02'!
fileOutXmlTopElement: aXMLElement fileDirectory: aFileDirectory localName: aLocalName 
	| doc stream writer |
	aFileDirectory assureExistence.
	stream := nil.
	
	[ doc := XMLDocument new version: 1.0 asString.
	stream := FileStream forceNewFileNamed: (aFileDirectory fullNameFor: aLocalName).
	doc addElement: aXMLElement.
	writer := XMLWriter on: stream.
	writer canonical: false.
	doc printXMLOn: writer ] ensure: [ stream ifNotNil: [ stream close ] ]! !

!GdsFeel class methodsFor: 'debug-flags' stamp: 'kf 11/14/2009 15:45'!
fittingRatio
	^self typedMap numberFor: #fittingRatio default:  GdsViewport defaultFittingRatio.! !

!GdsFeel class methodsFor: 'debug-flags' stamp: 'kf 11/14/2009 15:51'!
fittingRatio: aFloat
	self assert: [aFloat <= 1.0 and: [aFloat >= 0.5]] description: 'fittingRatio specify between 0.5 and 1.0'.
	^self typedMap numberFor: #fittingRatio value:  aFloat.! !

!GdsFeel class methodsFor: 'debug' stamp: 'kf 10/27/2008 21:46'!
ifDebug: aBlock
	self debugConsoleOut ifFalse: [^self].
	aBlock value.
	
	! !

!GdsFeel class methodsFor: 'debug' stamp: 'kf 10/27/2008 21:37'!
ifDebugOn: aStreamBlock
	self ifDebug: [
		Transcript cr; show: 
			(String streamContents: [ :stream |
				stream nextPutAll: '***DEBUG***'.
				stream nextPutAll: ' '.
				aStreamBlock value: stream])].
	! !

!GdsFeel class methodsFor: 'class initialization' stamp: 'kf 11/11/2009 16:47'!
initialize
	"self initialize"
	"self openReadMe."
	! !

!GdsFeel class methodsFor: 'private' stamp: 'kf 5/4/2009 22:21'!
join: anArray using: joint
	"TODO: using KFStringUtils #join:using:"
	| path |
	path := String streamContents: [:s |
		anArray do: [:each | 
			s nextPutAll: each.
			s nextPutAll: joint]].
	^path allButLast:  joint size.! !

!GdsFeel class methodsFor: 'maintenance' stamp: 'kf 11/2/2009 13:20'!
migrateConfigulationValues
	"self migrateConfigulationValues"
	| lowerCapital |
	TypedMap ifNil: [ TypedMap := TypedConfigulation new ].
	lowerCapital := 
	[ :symbol | 
	| varName |
	varName := symbol asString.
	varName first asString asLowercase , varName allButFirst ].
	(self classVarNames reject: [ :each | each = #TypedMap ]) do: 
		[ :each | 
		(self classPool at: each) ifNotNilDo: 
			[ :clazzVar | 
			TypedMap 
				instVarNamed: (lowerCapital value: each)
				put: clazzVar copy ] ]! !

!GdsFeel class methodsFor: 'documentation' stamp: 'kf 10/8/2009 15:26'!
openReadMe
	"self openReadMe."
	"| window |
	window := SystemWindow allSubInstances 
						detect: [:w | w label sameAs: self readMeTitle] ifNone: [nil].
	window ifNotNil: [window owner ifNotNil: [^self]]."
	(StringHolder new contents: self readMeContents)
		openLabel: self readMeTitle.! !

!GdsFeel class methodsFor: 'private' stamp: 'kf 11/10/2008 12:00'!
pathFromComponents: anArray
	^self join: anArray using: FileDirectory slash! !

!GdsFeel class methodsFor: 'accessing' stamp: 'kf 11/7/2008 15:37'!
pathToBeta
	^self pathFromComponents: self pathToBetaNameItems.! !

!GdsFeel class methodsFor: 'private' stamp: 'kf 10/20/2008 14:07'!
pathToBetaNameItems
	^self pathToSelfNameItems, {'Beta'}.! !

!GdsFeel class methodsFor: 'accessing' stamp: 'kf 11/7/2008 15:37'!
pathToSelf
	^self pathFromComponents: self pathToSelfNameItems.! !

!GdsFeel class methodsFor: 'private' stamp: 'kf 10/20/2008 11:17'!
pathToSelfNameItems
	^{ FileDirectory default pathName . 'GdsFeel' }! !

!GdsFeel class methodsFor: 'documentation' stamp: 'kf 11/11/2009 16:44'!
readMeContents
	^self readMeV003! !

!GdsFeel class methodsFor: 'documentation' stamp: 'kf 11/2/2009 14:02'!
readMeTitle
	^'README - ', (((self category asString splitOn: '-') allButLast) joinUsing: '-')
! !

!GdsFeel class methodsFor: 'documentation' stamp: 'kf 10/8/2009 10:27'!
readMeV000
	^'
kf 10/8/2009 10:25

- fix: can''t enabled button [OPENLIB]. after [INITLIB] 
'! !

!GdsFeel class methodsFor: 'documentation' stamp: 'kf 10/28/2009 11:51'!
readMeV001
	^'
kf 10/28/2009 11:49

- add datatype, pathtype
- change layer -> layerNumber.

- fix: GeometryUtils>>#removeDuplicatePoints:on:

'! !

!GdsFeel class methodsFor: 'documentation' stamp: 'kf 11/2/2009 14:06'!
readMeV002
	^'
V002
______

move GUI configulation methods to GdsFeelMorphic(GdsFeel-Morphic mcz Package).

- #goodiesEnabled
- #goodiesEnabled:
- #debugStretchFeedback 
- #debugStretchFeedback: 
- #debugFindElement 
- #debugFindElement: 
- #debugPathBoundary: 
- #clickSoundEnabled 
- #clickSoundEnabled: 
- #debugPathBoundary 



'! !

!GdsFeel class methodsFor: 'documentation' stamp: 'kf 11/14/2009 15:10'!
readMeV003
	^'
V003
______

- GdsViewport screen allocate margin attribute.
  defaultFittingRatio => 0.98.

- fix: Can''t effect floating number grid.
'! !

!GdsFeel class methodsFor: 'maintenance' stamp: 'kf 11/13/2009 16:55'!
rebuild
	"GdsFeel rebuild"
	(Smalltalk allClasses select: [:clazz |
		#('KF' 'Gds' 'Gpl') anySatisfy: [:each | clazz name beginsWith: each]])
		do: [:clazz |
			clazz compileAll]! !

!GdsFeel class methodsFor: 'accessing' stamp: 'kf 11/2/2009 13:20'!
typedMap
	TypedMap ifNil: [ TypedMap := TypedConfigulation new ].
	^ TypedMap! !

!GdsFeel class methodsFor: 'objects from disk' stamp: 'kf 11/8/2009 21:07'!
xmlDocumentFromPath: aString documentBlock: aBlock
	| stream doc |
	stream := nil.
	[stream := FileStream readOnlyFileNamed: aString .
	doc := XMLDOMParser parseDocumentFrom: stream.
	aBlock value: doc.]
		ensure: [stream ifNotNil: [stream close]].
! !

Object subclass: #GeometryUtils
	instanceVariableNames: ''
	classVariableNames: 'Pi2 Degree45Theta'
	poolDictionaries: ''
	category: 'GdsFeel-Model-Utility'!

!GeometryUtils class methodsFor: 'analisys-linesegment' stamp: 'kf 11/5/2008 10:44'!
analisysSegmentsAt: aPoint pointArray: vertices 
	| maps infos minSegIndex result minInfo|
	maps := self segmentDistanceMaps: aPoint pointArray: vertices.
	infos := maps collect: [:each | self nearyInfoOfDistanceMap:  each ].
	minInfo := (infos sort: [:a :b | a second  < b second ]) first.
	minSegIndex := minInfo last at: #segIndex.
	infos := infos sort: [:a :b | (a third at: #segIndex) < (b third at: #segIndex) ].
	result := Dictionary new.
	result at: #index put: minSegIndex.
	result at: #infos put: infos.
	result at: #element put: self.
	result at: #testPoint put: aPoint.
	^result.! !

!GeometryUtils class methodsFor: 'as yet unclassified' stamp: 'kf 11/5/2008 16:18'!
asCirculerIndex: segIndex segments: segs
	| index |
	index := segIndex \\ segs size. 
	index = 0 ifTrue: [index := segs size].
	self assert: [index between: 1 and: segs size].
	^index! !

!GeometryUtils class methodsFor: 'analisys-linesegment' stamp: 'kf 7/13/2009 16:06'!
distanceMapAt: aPoint segment: aLineSegment
	| distanceMap  p distP |
	distanceMap := Dictionary new.
	distanceMap at: #seg put: aLineSegment.

	p := aPoint nearestPointAlongLineFrom: aLineSegment start to: aLineSegment end.
	distanceMap at: #virtualCrossPoint put: p copy.
	
	p := (distanceMap at: #virtualCrossPoint) 
				adhereTo: (aLineSegment bounds).
	distanceMap at: #crossPoint put: p copy.
	distP := p dist: aPoint.
	distanceMap at: #cross put: distP copy.

	distP := aLineSegment start dist: aPoint.
	distanceMap at: #start put: distP copy.

	distP := aLineSegment start dist: (distanceMap at: #crossPoint).
	distanceMap at: #startToCross put: distP copy.

	distP := aLineSegment end dist: aPoint.
	distanceMap at: #end put: distP copy.

	distP := aLineSegment end dist: (distanceMap at: #crossPoint).
	distanceMap at: #endToCross put: distP copy.

	distanceMap at: #side put: (aLineSegment sideOfPoint: aPoint).
	^distanceMap.! !

!GeometryUtils class methodsFor: 'analisys-linesegment' stamp: 'kf 7/13/2009 12:23'!
distanceMapAt: aPoint segment: aLineSegment index: segIndex
	| distanceMap  |
	distanceMap := self distanceMapAt:  aPoint segment: aLineSegment.
	distanceMap at: #segIndex put: segIndex.
	^distanceMap.
! !

!GeometryUtils class methodsFor: 'as yet unclassified' stamp: 'kf 10/3/2008 21:44'!
initialize
	"GeometryUtils initialize"
	super initialize.
	Degree45Theta := (Float pi / 4.0).
	Pi2 := (Float pi * 2.0).
	
	! !

!GeometryUtils class methodsFor: 'as yet unclassified' stamp: 'kf 11/17/2009 20:24'!
limitedPoint: aPoint
	| x y |
	x := aPoint x < 0 
		ifTrue: [aPoint x max:  -32768]
		ifFalse: [aPoint x min:  32767].
	y := aPoint y < 0 
		ifTrue: [aPoint y max:  -32768]
		ifFalse: [aPoint y min:  32767].
	^x@y.	! !

!GeometryUtils class methodsFor: 'as yet unclassified' stamp: 'kf 9/30/2008 23:04'!
lineSegmentsFormPointArray: aPointArray
	| col |
	col := OrderedCollection new.
	self pointArray: aPointArray lineSegmentsDo: [ :seg |
		col add: seg].
	^col asArray.! !

!GeometryUtils class methodsFor: 'as yet unclassified' stamp: 'kf 11/5/2008 17:10'!
lookupDataBounds: vertices
	| minX minY maxX maxY |
	minX := SmallInteger maxVal.
	minY := SmallInteger maxVal.
	maxX := SmallInteger minVal.
	maxY := SmallInteger minVal.
	vertices do: 
		[ :p | 
		minX := minX min: p x.
		minY := minY min: p y.
		maxX := maxX max: p x.
		maxY := maxY max: p y ].
	^ minX @ minY corner: maxX @ maxY! !

!GeometryUtils class methodsFor: 'analisys-linesegment' stamp: 'kf 7/15/2009 15:41'!
lookupVertexIndex: anAlisysResult
	| segInfo distanceMap segIndex whichSide |
	segIndex := anAlisysResult at: #index.
	segInfo := (anAlisysResult at: #infos) at: segIndex.
	distanceMap := segInfo last.
	whichSide := segInfo first.
	(#cross == whichSide)
		ifTrue: [
			whichSide := 
				((distanceMap at: #startToCross) <= (distanceMap at: #endToCross))
					ifTrue:[#start] ifFalse:[#end]].
	^(#start == whichSide) 
		ifTrue: [segIndex] ifFalse:[segIndex + 1].! !

!GeometryUtils class methodsFor: 'as yet unclassified' stamp: 'kf 9/17/2008 22:43'!
midPointP1: pt1 p2: pt2
	^(pt1 + pt2) / 2.0.! !

!GeometryUtils class methodsFor: 'as yet unclassified' stamp: 'kf 9/11/2008 21:39'!
minusBounds
	^Rectangle 
		origin: (SmallInteger maxVal@SmallInteger maxVal) 
		corner: (SmallInteger minVal@SmallInteger minVal).
! !

!GeometryUtils class methodsFor: 'analisys-linesegment' stamp: 'kf 11/5/2008 10:41'!
nearyInfoOfDistanceMap: aDictionary
	| infos sortItemBlock |
	sortItemBlock := [:map :sel | {sel . map at: sel . map} ].
	((aDictionary at: #start) = (aDictionary at: #cross)) 
		ifTrue: [^sortItemBlock value: aDictionary value: #start].
	((aDictionary at: #end) = (aDictionary at: #cross)) 
		ifTrue: [^sortItemBlock value: aDictionary value: #end].
	infos := (aDictionary keys select: [:each | 
		{#start . #end . #cross } includes: each]) asArray 
			collect: [:key | sortItemBlock value: aDictionary value: key] .
	^(infos sort: [:a :b | a second < b second]) first. 
	! !

!GeometryUtils class methodsFor: 'as yet unclassified' stamp: 'kf 10/3/2008 21:47'!
octagonalRoundTheta: aTheta
	| ratio roundedRatio |
	ratio := aTheta / Pi2.
	roundedRatio := ratio roundTo: 0.125.
	^Pi2 * roundedRatio.! !

!GeometryUtils class methodsFor: 'as yet unclassified' stamp: 'kf 11/17/2009 20:24'!
point: aPoint roundTo: grid
	"Answer a Point that is the receiver's x and y rounded to grid x and 
	grid y."
	
	| gridPoint nX nY |
	gridPoint := grid asPoint.
	nX := aPoint x copy.
	nY := aPoint y copy.
	gridPoint x asFloat = 0.0 
		ifFalse: [nX := aPoint x roundTo: gridPoint x].
	gridPoint y asFloat = 0.0 
		ifFalse: [nY := aPoint y roundTo: gridPoint y].
	^nX@nY! !

!GeometryUtils class methodsFor: 'as yet unclassified' stamp: 'kf 9/30/2008 22:59'!
pointArray: aPointArray lineSegmentsDo: aLineSegmentBlock
	| p1 p2 segment |
	aPointArray size < 2 ifTrue: [^self].
	1 to: aPointArray size -1 do: [ :index |
		p1 := aPointArray at: index.
		p2 := aPointArray at: index + 1.
		segment := LineSegment from: p1 to: p2.
		aLineSegmentBlock value: segment]. ! !

!GeometryUtils class methodsFor: 'as yet unclassified' stamp: 'kf 9/12/2008 14:51'!
reducedPoints: aLength p1: pt1 p2: pt2
	| deltaPoint theta dx dy |
	deltaPoint := pt2 - pt1.
	theta := deltaPoint theta.
	dx := theta cos * aLength.
	dy := theta sin *aLength.
	^{pt1 + (dx@dy) . pt2 - (dx@dy) }! !

!GeometryUtils class methodsFor: 'as yet unclassified' stamp: 'kf 10/28/2009 11:35'!
removeDuplicatePoints: aPointArray on: aOrderedCollection
	| prevPoint |
	prevPoint := nil.
	aPointArray do: [:each |
		prevPoint 
			ifNil: [aOrderedCollection add: each]
			ifNotNil: [
				prevPoint = each
					ifFalse: [aOrderedCollection add: each]]. 
		prevPoint := each.]! !

!GeometryUtils class methodsFor: 'analisys-linesegment' stamp: 'kf 7/13/2009 12:24'!
segmentDistanceMaps: aPoint pointArray: vertices 
	| col segIndex |
	col := OrderedCollection new.
	segIndex := 0.
	GeometryUtils 
		pointArray:  vertices
		lineSegmentsDo: [ :lineSegment | 			
			| distanceMap |
			segIndex := segIndex + 1.
			distanceMap := self distanceMapAt: aPoint segment: lineSegment index: segIndex.			
			col add: distanceMap ].
	^ col asArray.! !

!GeometryUtils class methodsFor: 'as yet unclassified' stamp: 'kf 11/27/2008 23:30'!
verticesFromBounds: aBounds
	^{
		aBounds origin x @ aBounds origin y .
		aBounds origin x @ aBounds corner y .
		aBounds corner x @ aBounds corner y .
		aBounds corner x @ aBounds origin y .
		aBounds origin x @ aBounds origin y}.		! !

!GeometryUtils methodsFor: 'look in class' stamp: 'kf 10/25/2008 08:58'!
seeClassSide
	"All the code for GeometryUtils is on the class side"! !

Object subclass: #TypedConfigulation
	instanceVariableNames: 'booleanMap numberMap pointMap stringMap'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsFeel-Model-Utility'!

!TypedConfigulation methodsFor: 'as yet unclassified' stamp: 'kf 11/2/2009 11:04'!
booleanFor: aSymbol
	^self booleanFor: aSymbol default: false.! !

!TypedConfigulation methodsFor: 'as yet unclassified' stamp: 'kf 11/2/2009 11:03'!
booleanFor: aSymbol default: aValue
	booleanMap ifNil: [booleanMap := Dictionary new].
	^booleanMap at: aSymbol ifAbsentPut: [aValue].! !

!TypedConfigulation methodsFor: 'as yet unclassified' stamp: 'kf 11/2/2009 11:04'!
booleanFor: aSymbol value: aBoolean
	booleanMap ifNil: [booleanMap := Dictionary new].
	booleanMap at: aSymbol put: aBoolean.! !

!TypedConfigulation methodsFor: 'as yet unclassified' stamp: 'kf 11/2/2009 11:06'!
numberFor: aSymbol
	^self numberFor: aSymbol default: 0.! !

!TypedConfigulation methodsFor: 'as yet unclassified' stamp: 'kf 11/2/2009 11:05'!
numberFor: aSymbol default: aValue
	numberMap ifNil: [numberMap := Dictionary new].
	^numberMap at: aSymbol ifAbsentPut: [aValue].! !

!TypedConfigulation methodsFor: 'as yet unclassified' stamp: 'kf 11/14/2009 15:47'!
numberFor: aSymbol value: aNumber
	self assert: [aNumber isNumber].
	numberMap ifNil: [numberMap := Dictionary new].
	numberMap at: aSymbol put: aNumber.! !

!TypedConfigulation methodsFor: 'as yet unclassified' stamp: 'kf 11/2/2009 11:11'!
pointFor: aString 
	^self pointFor: aString default: 0@0 copy! !

!TypedConfigulation methodsFor: 'as yet unclassified' stamp: 'kf 11/2/2009 11:08'!
pointFor: aString default: aValue 
	pointMap ifNil: [ pointMap := Dictionary new ].
	^ pointMap 
		at: aString
		ifAbsentPut: [ aValue ]! !

!TypedConfigulation methodsFor: 'as yet unclassified' stamp: 'kf 11/2/2009 11:08'!
pointFor: aString value: aPoint 
	pointMap ifNil: [ pointMap := Dictionary new ].
	pointMap 
		at: aString
		put: aPoint! !

!TypedConfigulation methodsFor: 'as yet unclassified' stamp: 'kf 11/2/2009 11:11'!
stringFor: aSymbol 
	^self stringFor:  aSymbol default: ''.! !

!TypedConfigulation methodsFor: 'as yet unclassified' stamp: 'kf 11/2/2009 11:09'!
stringFor: aSymbol default: aValue
	stringMap ifNil: [stringMap := Dictionary new].
	^stringMap at: aSymbol ifAbsentPut: [aValue].! !

!TypedConfigulation methodsFor: 'as yet unclassified' stamp: 'kf 11/2/2009 11:10'!
stringFor: aSymbol value: aBoolean
	stringMap ifNil: [stringMap := Dictionary new].
	stringMap at: aSymbol put: aBoolean.! !

!Point class methodsFor: '*GdsFeel-Model-extension' stamp: 'kf 10/17/2008 21:21'!
r: rho radians: radians
	"Answer an instance of me with polar coordinates rho and theta."

	^self basicNew setR: rho radians: radians! !

!Point methodsFor: '*GdsFeel-Model-extension' stamp: 'kf 10/17/2008 21:19'!
setR: rho radians: radians 
	x := rho asFloat * radians cos.
	y := rho asFloat * radians sin.! !

INIFile subclass: #GdsIniFile
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsFeel-Model-Utility'!

!GdsIniFile methodsFor: 'writing' stamp: 'kf 6/16/2009 13:19'!
writeOn: aStream
	self sections
		do: [:ea | ea writeOn: aStream]
		separatedBy: [
			aStream cr. 
			aStream nextPut: Character lf]! !

!INIFile methodsFor: '*gdsfeel-Model-extension' stamp: 'kf 6/14/2009 21:08'!
section: sectionString
	^ self sectionClass named: sectionString on: self! !

!INIFile methodsFor: '*gdsfeel-Model-extension' stamp: 'kf 6/14/2009 21:08'!
sectionClass
	^INIFileSection! !

!INIFile methodsFor: '*gdsfeel-Model-extension' stamp: 'kf 6/15/2009 20:27'!
sectionsDo: aBlock
	self sectionDictionaries do:
		[:assoc | aBlock value: (self sectionClass on: self label: assoc key)]! !

!LineSegment methodsFor: '*GdsFeel-Model-extension' stamp: 'kf 10/24/2008 20:13'!
intersectionWith: anotherSegment virtualAllowed: aBoolean
	| det deltaPt alpha beta pt1Dir pt2Dir |
	pt1Dir _ end - start.
	pt2Dir _ anotherSegment end - anotherSegment start.
	det _ (pt1Dir x * pt2Dir y) - (pt1Dir y * pt2Dir x).
	deltaPt _ anotherSegment start - start.
	alpha _ (deltaPt x * pt2Dir y) - (deltaPt y * pt2Dir x).
	beta _ (deltaPt x * pt1Dir y) - (deltaPt y * pt1Dir x).
	det = 0 ifTrue:[^nil]. "no intersection"
	aBoolean 
		ifFalse: [
			alpha * det < 0 ifTrue:[^nil].
			beta * det < 0 ifTrue:[^nil].
			det > 0 
				ifTrue:[(alpha > det or:[beta > det]) ifTrue:[^nil]]
				ifFalse:[(alpha < det or:[beta < det]) ifTrue:[^nil]].].
	
	"And compute intersection"
	^start + (alpha * pt1Dir / (det@det))! !

!LineSegment methodsFor: '*GdsFeel-Model-extension' stamp: 'kf 10/17/2008 21:56'!
outlinePoints: offsetRadians r: r
	| slant p1 p2 p3 p4  offP1 offP2 |
	slant := (self end -  self start) theta .
	offP1 := Point r: r radians: (slant - offsetRadians).
	offP2 := Point r: r radians: (slant + offsetRadians).
	p4 := self start - offP2.
	p1 := self end + offP1.
	p2 := self end + offP2.
	p3 := self start - offP1.		
	^{p1 . p2 .p3 . p4 . p1}.
	! !

!LineSegment methodsFor: '*GdsFeel-Model-extension' stamp: 'kf 10/17/2008 22:04'!
outlineSegments: offsetRadians r: r 
	| col |
	col := OrderedCollection new.
	self outlineSegments: offsetRadians  r: r do: [ :seg |
		col add: seg]. 
	^col asArray
	! !

!LineSegment methodsFor: '*GdsFeel-Model-extension' stamp: 'kf 10/17/2008 22:02'!
outlineSegments: offsetRadians r: r do: aLineSegmentBlock
	GeometryUtils pointArray: (self outlinePoints: offsetRadians  r: r)  lineSegmentsDo: aLineSegmentBlock
	! !
GdsElement initialize!
GdsCompatibility initialize!
GdsFeel initialize!
GeometryUtils initialize!
